package db3

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import kotlin.Any
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow

@Dao
public actual abstract class ExampleEntity3Dao {
  @Insert(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract suspend fun insertAsync(exampleEntity3: ExampleEntity3): Long

  @Insert(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract fun insert(exampleEntity3: ExampleEntity3): Long

  @Query(`value` =
      "\n        INSERT OR IGNORE INTO ExampleEntity3(cardNumber, name, lastUpdatedTime)\n        SELECT :cardNumber AS cardNumber,\n               :name AS name,\n               :time AS time\n    ")
  public actual abstract suspend fun insertDifferently(
    cardNumber: Int,
    name: String,
    time: Long,
  )

  @Query(`value` =
      "\n        INSERT INTO OutgoingReplication(destNodeId, orTableId, orPk1, orPk2, orPk3, orPk4)\n               SELECT :destination AS destNodeId, \n                      542 AS orTableId,\n                      :entityUid AS orPk1,\n                      0 AS orPk2,\n                      0 AS orPk3,\n                      0 AS orPk4\n    ")
  public actual abstract suspend fun insertOutgoingReplication(entityUid: Long, destination: Long)

  @Query(`value` =
      "\n        SELECT ExampleEntity3.*\n          FROM ExampleEntity3\n         WHERE ExampleEntity3.eeUid = :uid \n    ")
  public actual abstract suspend fun findByUid(uid: Long): ExampleEntity3?

  @Query(`value` =
      "\n        SELECT ExampleEntity3.*\n          FROM ExampleEntity3\n         WHERE ExampleEntity3.eeUid = :uid \n    ")
  public actual abstract fun findByUidAsFlow(uid: Long): Flow<ExampleEntity3?>

  @Query(`value` =
      "\n        SELECT ExampleEntity3.*\n          FROM ExampleEntity3\n         WHERE ExampleEntity3.cardNumber >= :minCardNum \n    ")
  public actual abstract suspend fun findAllWithCardNumAbove(minCardNum: Int): List<ExampleEntity3>
}
