package db3

import com.ustadmobile.door.ext.doorPrimaryKeyManager
import com.ustadmobile.door.ext.rootDatabase
import com.ustadmobile.door.room.RoomDatabase
import com.ustadmobile.door.util.systemTimeInMillis
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow

public class ExampleEntity3Dao_DoorWrapper(
  private val _db: RoomDatabase,
  private val _dao: ExampleEntity3Dao,
) : ExampleEntity3Dao() {
  override suspend fun insertAsync(exampleEntity3: ExampleEntity3): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(exampleEntity3.eeUid == 0L) {
      val _newPk = _pkManager.nextIdAsync(542)
      exampleEntity3.eeUid = _newPk
    }
    exampleEntity3.lastUpdatedTime = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insertAsync(exampleEntity3)
    return exampleEntity3.eeUid
  }

  override fun insert(exampleEntity3: ExampleEntity3): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(exampleEntity3.eeUid == 0L) {
      val _newPk = _pkManager.nextId(542)
      exampleEntity3.eeUid = _newPk
    }
    exampleEntity3.lastUpdatedTime = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insert(exampleEntity3)
    return exampleEntity3.eeUid
  }

  override suspend fun insertDifferently(
    cardNumber: Int,
    name: String,
    time: Long,
  ) {
    _dao.insertDifferently(cardNumber, name, time)
  }

  override suspend fun insertOutgoingReplication(entityUid: Long, destination: Long) {
    _dao.insertOutgoingReplication(entityUid, destination)
  }

  override suspend fun findByUid(uid: Long): ExampleEntity3? = _dao.findByUid(uid)

  override fun findByUidAsFlow(uid: Long): Flow<ExampleEntity3?> = _dao.findByUidAsFlow(uid)

  override suspend fun findAllWithCardNumAbove(minCardNum: Int): List<ExampleEntity3> =
      _dao.findAllWithCardNumAbove(minCardNum)
}
