package db3

import com.ustadmobile.door.DoorDatabaseRepository
import com.ustadmobile.door.ext.doorNodeIdHeader
import com.ustadmobile.door.ext.setRepoUrl
import com.ustadmobile.door.http.replicateHttpRequestCatchAndLog
import com.ustadmobile.door.replication.onClientRepoDoorMessageHttpResponse
import com.ustadmobile.door.replication.withRepoChangeMonitor
import com.ustadmobile.door.replication.withRepoChangeMonitorAsync
import com.ustadmobile.door.room.RoomDatabase
import io.ktor.client.HttpClient
import io.ktor.client.request.`get`
import io.ktor.client.request.`header`
import io.ktor.client.request.parameter
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.Suppress
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow
import kotlinx.serialization.builtins.serializer

@Suppress("REDUNDANT_PROJECTION", "LocalVariableName", "ClassName")
public class ExampleEntity3Dao_Repo(
  public val _db: RoomDatabase,
  public val _repo: DoorDatabaseRepository,
  public val _dao: ExampleEntity3Dao,
  public val _httpClient: HttpClient,
  public val _clientId: Long,
  public val _endpoint: String,
) : ExampleEntity3Dao() {
  override suspend fun insertAsync(exampleEntity3: ExampleEntity3): Long {
    val _result = _repo.withRepoChangeMonitorAsync("ExampleEntity3") {
      _dao.insertAsync(exampleEntity3)
    }
    return _result
  }

  override fun insert(exampleEntity3: ExampleEntity3): Long {
    val _result = _repo.withRepoChangeMonitor("ExampleEntity3") {
      _dao.insert(exampleEntity3)
    }
    return _result
  }

  override suspend fun insertDifferently(
    cardNumber: Int,
    name: String,
    time: Long,
  ) {
    _repo.withRepoChangeMonitorAsync("ExampleEntity3") {
      _dao.insertDifferently(cardNumber, name, time)
    }
  }

  override suspend fun insertOutgoingReplication(entityUid: Long, destination: Long) {
    _repo.withRepoChangeMonitorAsync("OutgoingReplication") {
      _dao.insertOutgoingReplication(entityUid, destination)
    }
  }

  override suspend fun findByUid(uid: Long): ExampleEntity3? {
    val _result = _dao.findByUid(uid)
    return _result
  }

  override fun findByUidAsFlow(uid: Long): Flow<ExampleEntity3?> {
    val _result = _dao.findByUidAsFlow(uid)
    return _result
  }

  override suspend fun findAllWithCardNumAbove(minCardNum: Int): List<ExampleEntity3> {
    _repo.replicateHttpRequestCatchAndLog(repoPath = "ExampleEntity3Dao/findAllWithCardNumAbove") {
      val _response = _httpClient.`get` {
        setRepoUrl(_repo.config, "ExampleEntity3Dao/findAllWithCardNumAbove")
        doorNodeIdHeader(_repo)
        `header`("cache-control", "no-store")
        parameter("minCardNum", _repo.config.json.encodeToString(Int.serializer(), minCardNum))
      }

      _db.onClientRepoDoorMessageHttpResponse(_response, _repo.config.json)
    }
    val _result = _dao.findAllWithCardNumAbove(minCardNum)
    return _result
  }
}
