package db3

import com.ustadmobile.door.DoorDatabaseRepository
import com.ustadmobile.door.ext.doorNodeIdHeader
import com.ustadmobile.door.ext.setRepoUrl
import com.ustadmobile.door.http.repoHttpRequestWithFallback
import com.ustadmobile.door.replication.withRepoChangeMonitorAsync
import com.ustadmobile.door.room.RoomDatabase
import io.ktor.client.HttpClient
import io.ktor.client.request.`get`
import io.ktor.client.request.`header`
import io.ktor.client.request.parameter
import io.ktor.client.statement.bodyAsText
import kotlin.Boolean
import kotlin.Long
import kotlin.String
import kotlin.Suppress
import kotlinx.serialization.builtins.nullable
import kotlinx.serialization.builtins.serializer

@Suppress("REDUNDANT_PROJECTION", "LocalVariableName", "ClassName")
public class MemberDao_Repo(
  public val _db: RoomDatabase,
  public val _repo: DoorDatabaseRepository,
  public val _dao: MemberDao,
  public val _httpClient: HttpClient,
  public val _clientId: Long,
  public val _endpoint: String,
) : MemberDao() {
  override suspend fun insertAsync(member: Member): Long {
    val _result = _repo.withRepoChangeMonitorAsync("Member") {
      _dao.insertAsync(member)
    }
    return _result
  }

  override suspend fun findByUid(memberUid: Long): Member? {
    val _result = _dao.findByUid(memberUid)
    return _result
  }

  override suspend fun checkMemberNodeHasPermission(postUid: Long, nodeId: Long): Boolean {
    val _result = _dao.checkMemberNodeHasPermission(postUid, nodeId)
    return _result
  }

  override suspend fun findAuthorByPostUid(postUid: Long): Member? {
    val _result = _dao.findAuthorByPostUid(postUid)
    return _result
  }

  override suspend fun getFirstNameByMemberId(memberUid: Long): String? =
      _repo.repoHttpRequestWithFallback(
    repoPath = "MemberDao/getFirstNameByMemberId",
    http =  {
      _repo.config.json.decodeFromString(
        deserializer = String.serializer().nullable,
        string = _repo.config.httpClient.`get` {
          setRepoUrl(_repo.config, "MemberDao/getFirstNameByMemberId")
          doorNodeIdHeader(_repo)
          `header`("cache-control", "no-store")
          parameter("memberUid", _repo.config.json.encodeToString(Long.serializer(), memberUid))
        }
        .bodyAsText()
      )
    } ,
    fallback =  {
      _dao.getFirstNameByMemberId(memberUid)
    }

  )
}
