package db3

import com.ustadmobile.door.room.RoomDatabase
import com.ustadmobile.door.util.systemTimeInMillis
import kotlin.Long
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow

public class StatementEntityDao_DoorWrapper(
  private val _db: RoomDatabase,
  private val _dao: StatementEntityDao,
) : StatementEntityDao() {
  override suspend fun insertAsync(entity: StatementEntity) {
    entity.lct = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insertAsync(entity)
  }

  override suspend fun findAllAsync(): List<StatementEntity> = _dao.findAllAsync()

  override fun findByUidAsFlow(uidHi: Long, uidLo: Long): Flow<StatementEntity?> =
      _dao.findByUidAsFlow(uidHi, uidLo)

  override suspend fun findByUidAsync(uidHi: Long, uidLo: Long): StatementEntity? =
      _dao.findByUidAsync(uidHi, uidLo)
}
