package db2;

import android.database.Cursor;
import android.os.CancellationSignal;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.room.CoroutinesRoom;
import androidx.room.EntityDeletionOrUpdateAdapter;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.SharedSQLiteStatement;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.room.util.StringUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import com.ustadmobile.door.SyncNode;
import java.lang.Class;
import java.lang.Exception;
import java.lang.Integer;
import java.lang.Long;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.StringBuilder;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import javax.annotation.processing.Generated;
import kotlin.Unit;
import kotlin.coroutines.Continuation;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class ExampleSyncableDao_Impl extends ExampleSyncableDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<ExampleSyncableEntity> __insertionAdapterOfExampleSyncableEntity;

  private final EntityDeletionOrUpdateAdapter<ExampleSyncableEntity> __updateAdapterOfExampleSyncableEntity;

  private final SharedSQLiteStatement __preparedStmtOfUpdateNumberByUid;

  private final SharedSQLiteStatement __preparedStmtOfInsertFromSelectQuery;

  public ExampleSyncableDao_Impl(@NonNull final RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfExampleSyncableEntity = new EntityInsertionAdapter<ExampleSyncableEntity>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "INSERT OR ABORT INTO `ExampleSyncableEntity` (`esUid`,`esLcsn`,`esMcsn`,`esLcb`,`esNumber`,`esName`,`publik`) VALUES (nullif(?, 0),?,?,?,?,?,?)";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final ExampleSyncableEntity entity) {
        statement.bindLong(1, entity.getEsUid());
        statement.bindLong(2, entity.getEsLcsn());
        statement.bindLong(3, entity.getEsMcsn());
        statement.bindLong(4, entity.getEsLcb());
        statement.bindLong(5, entity.getEsNumber());
        if (entity.getEsName() == null) {
          statement.bindNull(6);
        } else {
          statement.bindString(6, entity.getEsName());
        }
        final int _tmp = entity.getPublik() ? 1 : 0;
        statement.bindLong(7, _tmp);
      }
    };
    this.__updateAdapterOfExampleSyncableEntity = new EntityDeletionOrUpdateAdapter<ExampleSyncableEntity>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "UPDATE OR ABORT `ExampleSyncableEntity` SET `esUid` = ?,`esLcsn` = ?,`esMcsn` = ?,`esLcb` = ?,`esNumber` = ?,`esName` = ?,`publik` = ? WHERE `esUid` = ?";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final ExampleSyncableEntity entity) {
        statement.bindLong(1, entity.getEsUid());
        statement.bindLong(2, entity.getEsLcsn());
        statement.bindLong(3, entity.getEsMcsn());
        statement.bindLong(4, entity.getEsLcb());
        statement.bindLong(5, entity.getEsNumber());
        if (entity.getEsName() == null) {
          statement.bindNull(6);
        } else {
          statement.bindString(6, entity.getEsName());
        }
        final int _tmp = entity.getPublik() ? 1 : 0;
        statement.bindLong(7, _tmp);
        statement.bindLong(8, entity.getEsUid());
      }
    };
    this.__preparedStmtOfUpdateNumberByUid = new SharedSQLiteStatement(__db) {
      @Override
      @NonNull
      public String createQuery() {
        final String _query = "UPDATE ExampleSyncableEntity SET esNumber = ?,esLcb = (SELECT nodeClientId FROM SyncNode LIMIT 1) WHERE esUid = ?";
        return _query;
      }
    };
    this.__preparedStmtOfInsertFromSelectQuery = new SharedSQLiteStatement(__db) {
      @Override
      @NonNull
      public String createQuery() {
        final String _query = "\n"
                + "   INSERT INTO ExampleSyncableEntity (esUid, esLcsn, esMcsn, esLcb, esNumber, esName, publik)\n"
                + "        SELECT (esUid * 5) AS esUid, 0 AS esLcsn, 0 AS esMcsn, 0 AS esLcb, 42 AS esNumber, ? AS esName, \n"
                + "               ? AS publik \n"
                + "          FROM ExampleSyncableEntity\n"
                + "         WHERE esName = ?\n"
                + "    ";
        return _query;
      }
    };
  }

  @Override
  public long insert(final ExampleSyncableEntity syncableEntity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      final long _result = __insertionAdapterOfExampleSyncableEntity.insertAndReturnId(syncableEntity);
      __db.setTransactionSuccessful();
      return _result;
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void insertList(final List<? extends ExampleSyncableEntity> syncableEntityLIst) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfExampleSyncableEntity.insert(syncableEntityLIst);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public Object insertAndReturnList(final List<? extends ExampleSyncableEntity> entities,
      final Continuation<? super List<Long>> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<List<Long>>() {
      @Override
      @NonNull
      public List<Long> call() throws Exception {
        __db.beginTransaction();
        try {
          final List<Long> _result = __insertionAdapterOfExampleSyncableEntity.insertAndReturnIdsList(entities);
          __db.setTransactionSuccessful();
          return _result;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public Object insertAsync(final ExampleSyncableEntity syncableEntity,
      final Continuation<? super Long> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Long>() {
      @Override
      @NonNull
      public Long call() throws Exception {
        __db.beginTransaction();
        try {
          final Long _result = __insertionAdapterOfExampleSyncableEntity.insertAndReturnId(syncableEntity);
          __db.setTransactionSuccessful();
          return _result;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public Object updateAsync(final ExampleSyncableEntity exampleSyncableEntity,
      final Continuation<? super Unit> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      @NonNull
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __updateAdapterOfExampleSyncableEntity.handle(exampleSyncableEntity);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public void updateNumberByUid(final long uid, final long newNumber) {
    __db.assertNotSuspendingTransaction();
    final SupportSQLiteStatement _stmt = __preparedStmtOfUpdateNumberByUid.acquire();
    int _argIndex = 1;
    _stmt.bindLong(_argIndex, newNumber);
    _argIndex = 2;
    _stmt.bindLong(_argIndex, uid);
    try {
      __db.beginTransaction();
      try {
        _stmt.executeUpdateDelete();
        __db.setTransactionSuccessful();
      } finally {
        __db.endTransaction();
      }
    } finally {
      __preparedStmtOfUpdateNumberByUid.release(_stmt);
    }
  }

  @Override
  public void insertFromSelectQuery(final String name, final boolean publik) {
    __db.assertNotSuspendingTransaction();
    final SupportSQLiteStatement _stmt = __preparedStmtOfInsertFromSelectQuery.acquire();
    int _argIndex = 1;
    if (name == null) {
      _stmt.bindNull(_argIndex);
    } else {
      _stmt.bindString(_argIndex, name);
    }
    _argIndex = 2;
    final int _tmp = publik ? 1 : 0;
    _stmt.bindLong(_argIndex, _tmp);
    _argIndex = 3;
    if (name == null) {
      _stmt.bindNull(_argIndex);
    } else {
      _stmt.bindString(_argIndex, name);
    }
    try {
      __db.beginTransaction();
      try {
        _stmt.executeInsert();
        __db.setTransactionSuccessful();
      } finally {
        __db.endTransaction();
      }
    } finally {
      __preparedStmtOfInsertFromSelectQuery.release(_stmt);
    }
  }

  @Override
  public List<ExampleSyncableEntity> findAll() {
    final String _sql = "SELECT * FROM ExampleSyncableEntity";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfEsUid = CursorUtil.getColumnIndexOrThrow(_cursor, "esUid");
      final int _cursorIndexOfEsLcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcsn");
      final int _cursorIndexOfEsMcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esMcsn");
      final int _cursorIndexOfEsLcb = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcb");
      final int _cursorIndexOfEsNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "esNumber");
      final int _cursorIndexOfEsName = CursorUtil.getColumnIndexOrThrow(_cursor, "esName");
      final int _cursorIndexOfPublik = CursorUtil.getColumnIndexOrThrow(_cursor, "publik");
      final List<ExampleSyncableEntity> _result = new ArrayList<ExampleSyncableEntity>(_cursor.getCount());
      while (_cursor.moveToNext()) {
        final ExampleSyncableEntity _item;
        final long _tmpEsUid;
        _tmpEsUid = _cursor.getLong(_cursorIndexOfEsUid);
        final int _tmpEsLcsn;
        _tmpEsLcsn = _cursor.getInt(_cursorIndexOfEsLcsn);
        final int _tmpEsMcsn;
        _tmpEsMcsn = _cursor.getInt(_cursorIndexOfEsMcsn);
        final int _tmpEsLcb;
        _tmpEsLcb = _cursor.getInt(_cursorIndexOfEsLcb);
        final int _tmpEsNumber;
        _tmpEsNumber = _cursor.getInt(_cursorIndexOfEsNumber);
        final String _tmpEsName;
        if (_cursor.isNull(_cursorIndexOfEsName)) {
          _tmpEsName = null;
        } else {
          _tmpEsName = _cursor.getString(_cursorIndexOfEsName);
        }
        final boolean _tmpPublik;
        final int _tmp;
        _tmp = _cursor.getInt(_cursorIndexOfPublik);
        _tmpPublik = _tmp != 0;
        _item = new ExampleSyncableEntity(_tmpEsUid,_tmpEsLcsn,_tmpEsMcsn,_tmpEsLcb,_tmpEsNumber,_tmpEsName,_tmpPublik);
        _result.add(_item);
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public Object findByListParam(final List<Long> numberList,
      final Continuation<? super List<? extends ExampleSyncableEntity>> $completion) {
    final StringBuilder _stringBuilder = StringUtil.newStringBuilder();
    _stringBuilder.append("SELECT * FROM ExampleSyncableEntity WHERE esNumber IN (");
    final int _inputSize = numberList.size();
    StringUtil.appendPlaceholders(_stringBuilder, _inputSize);
    _stringBuilder.append(")");
    final String _sql = _stringBuilder.toString();
    final int _argCount = 0 + _inputSize;
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, _argCount);
    int _argIndex = 1;
    for (long _item : numberList) {
      _statement.bindLong(_argIndex, _item);
      _argIndex++;
    }
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<ExampleSyncableEntity>>() {
      @Override
      @NonNull
      public List<ExampleSyncableEntity> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfEsUid = CursorUtil.getColumnIndexOrThrow(_cursor, "esUid");
          final int _cursorIndexOfEsLcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcsn");
          final int _cursorIndexOfEsMcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esMcsn");
          final int _cursorIndexOfEsLcb = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcb");
          final int _cursorIndexOfEsNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "esNumber");
          final int _cursorIndexOfEsName = CursorUtil.getColumnIndexOrThrow(_cursor, "esName");
          final int _cursorIndexOfPublik = CursorUtil.getColumnIndexOrThrow(_cursor, "publik");
          final List<ExampleSyncableEntity> _result = new ArrayList<ExampleSyncableEntity>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final ExampleSyncableEntity _item_1;
            final long _tmpEsUid;
            _tmpEsUid = _cursor.getLong(_cursorIndexOfEsUid);
            final int _tmpEsLcsn;
            _tmpEsLcsn = _cursor.getInt(_cursorIndexOfEsLcsn);
            final int _tmpEsMcsn;
            _tmpEsMcsn = _cursor.getInt(_cursorIndexOfEsMcsn);
            final int _tmpEsLcb;
            _tmpEsLcb = _cursor.getInt(_cursorIndexOfEsLcb);
            final int _tmpEsNumber;
            _tmpEsNumber = _cursor.getInt(_cursorIndexOfEsNumber);
            final String _tmpEsName;
            if (_cursor.isNull(_cursorIndexOfEsName)) {
              _tmpEsName = null;
            } else {
              _tmpEsName = _cursor.getString(_cursorIndexOfEsName);
            }
            final boolean _tmpPublik;
            final int _tmp;
            _tmp = _cursor.getInt(_cursorIndexOfPublik);
            _tmpPublik = _tmp != 0;
            _item_1 = new ExampleSyncableEntity(_tmpEsUid,_tmpEsLcsn,_tmpEsMcsn,_tmpEsLcb,_tmpEsNumber,_tmpEsName,_tmpPublik);
            _result.add(_item_1);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public ExampleSyncableEntity findByUid(final long uid) {
    final String _sql = "SELECT * FROM ExampleSyncableEntity WHERE esUid = ?";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uid);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfEsUid = CursorUtil.getColumnIndexOrThrow(_cursor, "esUid");
      final int _cursorIndexOfEsLcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcsn");
      final int _cursorIndexOfEsMcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esMcsn");
      final int _cursorIndexOfEsLcb = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcb");
      final int _cursorIndexOfEsNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "esNumber");
      final int _cursorIndexOfEsName = CursorUtil.getColumnIndexOrThrow(_cursor, "esName");
      final int _cursorIndexOfPublik = CursorUtil.getColumnIndexOrThrow(_cursor, "publik");
      final ExampleSyncableEntity _result;
      if (_cursor.moveToFirst()) {
        final long _tmpEsUid;
        _tmpEsUid = _cursor.getLong(_cursorIndexOfEsUid);
        final int _tmpEsLcsn;
        _tmpEsLcsn = _cursor.getInt(_cursorIndexOfEsLcsn);
        final int _tmpEsMcsn;
        _tmpEsMcsn = _cursor.getInt(_cursorIndexOfEsMcsn);
        final int _tmpEsLcb;
        _tmpEsLcb = _cursor.getInt(_cursorIndexOfEsLcb);
        final int _tmpEsNumber;
        _tmpEsNumber = _cursor.getInt(_cursorIndexOfEsNumber);
        final String _tmpEsName;
        if (_cursor.isNull(_cursorIndexOfEsName)) {
          _tmpEsName = null;
        } else {
          _tmpEsName = _cursor.getString(_cursorIndexOfEsName);
        }
        final boolean _tmpPublik;
        final int _tmp;
        _tmp = _cursor.getInt(_cursorIndexOfPublik);
        _tmpPublik = _tmp != 0;
        _result = new ExampleSyncableEntity(_tmpEsUid,_tmpEsLcsn,_tmpEsMcsn,_tmpEsLcb,_tmpEsNumber,_tmpEsName,_tmpPublik);
      } else {
        _result = null;
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public ExampleSyncableEntity findByName(final String name) {
    final String _sql = "SELECT * FROM ExampleSyncableEntity WHERE esName = ?";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    if (name == null) {
      _statement.bindNull(_argIndex);
    } else {
      _statement.bindString(_argIndex, name);
    }
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfEsUid = CursorUtil.getColumnIndexOrThrow(_cursor, "esUid");
      final int _cursorIndexOfEsLcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcsn");
      final int _cursorIndexOfEsMcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esMcsn");
      final int _cursorIndexOfEsLcb = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcb");
      final int _cursorIndexOfEsNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "esNumber");
      final int _cursorIndexOfEsName = CursorUtil.getColumnIndexOrThrow(_cursor, "esName");
      final int _cursorIndexOfPublik = CursorUtil.getColumnIndexOrThrow(_cursor, "publik");
      final ExampleSyncableEntity _result;
      if (_cursor.moveToFirst()) {
        final long _tmpEsUid;
        _tmpEsUid = _cursor.getLong(_cursorIndexOfEsUid);
        final int _tmpEsLcsn;
        _tmpEsLcsn = _cursor.getInt(_cursorIndexOfEsLcsn);
        final int _tmpEsMcsn;
        _tmpEsMcsn = _cursor.getInt(_cursorIndexOfEsMcsn);
        final int _tmpEsLcb;
        _tmpEsLcb = _cursor.getInt(_cursorIndexOfEsLcb);
        final int _tmpEsNumber;
        _tmpEsNumber = _cursor.getInt(_cursorIndexOfEsNumber);
        final String _tmpEsName;
        if (_cursor.isNull(_cursorIndexOfEsName)) {
          _tmpEsName = null;
        } else {
          _tmpEsName = _cursor.getString(_cursorIndexOfEsName);
        }
        final boolean _tmpPublik;
        final int _tmp;
        _tmp = _cursor.getInt(_cursorIndexOfPublik);
        _tmpPublik = _tmp != 0;
        _result = new ExampleSyncableEntity(_tmpEsUid,_tmpEsLcsn,_tmpEsMcsn,_tmpEsLcb,_tmpEsNumber,_tmpEsName,_tmpPublik);
      } else {
        _result = null;
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public List<ExampleSyncableEntityWithOtherSyncableEntity> findAllWithOtherByUid() {
    final String _sql = "SELECT ExampleSyncableEntity.*, OtherSyncableEntity.* FROM ExampleSyncableEntity LEFT JOIN OtherSyncableEntity ON ExampleSyncableEntity.esUid = OtherSyncableEntity.otherFk";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfEsUid = CursorUtil.getColumnIndexOrThrow(_cursor, "esUid");
      final int _cursorIndexOfEsLcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcsn");
      final int _cursorIndexOfEsMcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esMcsn");
      final int _cursorIndexOfEsLcb = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcb");
      final int _cursorIndexOfEsNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "esNumber");
      final int _cursorIndexOfEsName = CursorUtil.getColumnIndexOrThrow(_cursor, "esName");
      final int _cursorIndexOfPublik = CursorUtil.getColumnIndexOrThrow(_cursor, "publik");
      final int _cursorIndexOfOsUid = CursorUtil.getColumnIndexOrThrow(_cursor, "osUid");
      final int _cursorIndexOfOsLcb = CursorUtil.getColumnIndexOrThrow(_cursor, "osLcb");
      final int _cursorIndexOfOsMcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "osMcsn");
      final int _cursorIndexOfOsLcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "osLcsn");
      final int _cursorIndexOfOtherFk = CursorUtil.getColumnIndexOrThrow(_cursor, "otherFk");
      final int _cursorIndexOfOtherNum = CursorUtil.getColumnIndexOrThrow(_cursor, "otherNum");
      final int _cursorIndexOfOtherStr = CursorUtil.getColumnIndexOrThrow(_cursor, "otherStr");
      final List<ExampleSyncableEntityWithOtherSyncableEntity> _result = new ArrayList<ExampleSyncableEntityWithOtherSyncableEntity>(_cursor.getCount());
      while (_cursor.moveToNext()) {
        final ExampleSyncableEntityWithOtherSyncableEntity _item;
        final long _tmpEsUid;
        _tmpEsUid = _cursor.getLong(_cursorIndexOfEsUid);
        final int _tmpEsLcsn;
        _tmpEsLcsn = _cursor.getInt(_cursorIndexOfEsLcsn);
        final int _tmpEsMcsn;
        _tmpEsMcsn = _cursor.getInt(_cursorIndexOfEsMcsn);
        final int _tmpEsLcb;
        _tmpEsLcb = _cursor.getInt(_cursorIndexOfEsLcb);
        final int _tmpEsNumber;
        _tmpEsNumber = _cursor.getInt(_cursorIndexOfEsNumber);
        final OtherSyncableEntity _tmpEmbeddedOse;
        if (!(_cursor.isNull(_cursorIndexOfOsUid) && _cursor.isNull(_cursorIndexOfOsLcb) && _cursor.isNull(_cursorIndexOfOsMcsn) && _cursor.isNull(_cursorIndexOfOsLcsn) && _cursor.isNull(_cursorIndexOfOtherFk) && _cursor.isNull(_cursorIndexOfOtherNum) && _cursor.isNull(_cursorIndexOfOtherStr))) {
          final long _tmpOsUid;
          _tmpOsUid = _cursor.getLong(_cursorIndexOfOsUid);
          final int _tmpOsLcb;
          _tmpOsLcb = _cursor.getInt(_cursorIndexOfOsLcb);
          final int _tmpOsMcsn;
          _tmpOsMcsn = _cursor.getInt(_cursorIndexOfOsMcsn);
          final int _tmpOsLcsn;
          _tmpOsLcsn = _cursor.getInt(_cursorIndexOfOsLcsn);
          final int _tmpOtherFk;
          _tmpOtherFk = _cursor.getInt(_cursorIndexOfOtherFk);
          final int _tmpOtherNum;
          _tmpOtherNum = _cursor.getInt(_cursorIndexOfOtherNum);
          final String _tmpOtherStr;
          if (_cursor.isNull(_cursorIndexOfOtherStr)) {
            _tmpOtherStr = null;
          } else {
            _tmpOtherStr = _cursor.getString(_cursorIndexOfOtherStr);
          }
          _tmpEmbeddedOse = new OtherSyncableEntity(_tmpOsUid,_tmpOsLcb,_tmpOsMcsn,_tmpOsLcsn,_tmpOtherFk,_tmpOtherNum,_tmpOtherStr);
        } else {
          _tmpEmbeddedOse = null;
        }
        _item = new ExampleSyncableEntityWithOtherSyncableEntity(_tmpEsUid,_tmpEsLcsn,_tmpEsMcsn,_tmpEsLcb,_tmpEsNumber);
        final String _tmpEsName;
        if (_cursor.isNull(_cursorIndexOfEsName)) {
          _tmpEsName = null;
        } else {
          _tmpEsName = _cursor.getString(_cursorIndexOfEsName);
        }
        _item.setEsName(_tmpEsName);
        final boolean _tmpPublik;
        final int _tmp;
        _tmp = _cursor.getInt(_cursorIndexOfPublik);
        _tmpPublik = _tmp != 0;
        _item.setPublik(_tmpPublik);
        _item.setEmbeddedOse(_tmpEmbeddedOse);
        _result.add(_item);
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public Object findOneFromWeb(final Continuation<? super ExampleSyncableEntity> $completion) {
    final String _sql = "SELECT * FROM ExampleSyncableEntity LIMIT 1";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<ExampleSyncableEntity>() {
      @Override
      @Nullable
      public ExampleSyncableEntity call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfEsUid = CursorUtil.getColumnIndexOrThrow(_cursor, "esUid");
          final int _cursorIndexOfEsLcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcsn");
          final int _cursorIndexOfEsMcsn = CursorUtil.getColumnIndexOrThrow(_cursor, "esMcsn");
          final int _cursorIndexOfEsLcb = CursorUtil.getColumnIndexOrThrow(_cursor, "esLcb");
          final int _cursorIndexOfEsNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "esNumber");
          final int _cursorIndexOfEsName = CursorUtil.getColumnIndexOrThrow(_cursor, "esName");
          final int _cursorIndexOfPublik = CursorUtil.getColumnIndexOrThrow(_cursor, "publik");
          final ExampleSyncableEntity _result;
          if (_cursor.moveToFirst()) {
            final long _tmpEsUid;
            _tmpEsUid = _cursor.getLong(_cursorIndexOfEsUid);
            final int _tmpEsLcsn;
            _tmpEsLcsn = _cursor.getInt(_cursorIndexOfEsLcsn);
            final int _tmpEsMcsn;
            _tmpEsMcsn = _cursor.getInt(_cursorIndexOfEsMcsn);
            final int _tmpEsLcb;
            _tmpEsLcb = _cursor.getInt(_cursorIndexOfEsLcb);
            final int _tmpEsNumber;
            _tmpEsNumber = _cursor.getInt(_cursorIndexOfEsNumber);
            final String _tmpEsName;
            if (_cursor.isNull(_cursorIndexOfEsName)) {
              _tmpEsName = null;
            } else {
              _tmpEsName = _cursor.getString(_cursorIndexOfEsName);
            }
            final boolean _tmpPublik;
            final int _tmp;
            _tmp = _cursor.getInt(_cursorIndexOfPublik);
            _tmpPublik = _tmp != 0;
            _result = new ExampleSyncableEntity(_tmpEsUid,_tmpEsLcsn,_tmpEsMcsn,_tmpEsLcb,_tmpEsNumber,_tmpEsName,_tmpPublik);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object findOneValue(final Continuation<? super Integer> $completion) {
    final String _sql = "SELECT esNumber FROM ExampleSyncableEntity LIMIT 1";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<Integer>() {
      @Override
      @NonNull
      public Integer call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _result;
          if (_cursor.moveToFirst()) {
            _result = _cursor.getInt(0);
          } else {
            _result = 0;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public SyncNode getSyncNode() {
    final String _sql = "SELECT SyncNode.* FROM SyncNode LIMIT 1";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfNodeClientId = CursorUtil.getColumnIndexOrThrow(_cursor, "nodeClientId");
      final SyncNode _result;
      if (_cursor.moveToFirst()) {
        final long _tmpNodeClientId;
        _tmpNodeClientId = _cursor.getLong(_cursorIndexOfNodeClientId);
        _result = new SyncNode(_tmpNodeClientId);
      } else {
        _result = null;
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @NonNull
  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
