package db3;

import android.database.Cursor;
import android.os.CancellationSignal;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.room.CoroutinesRoom;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.SharedSQLiteStatement;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import java.lang.Class;
import java.lang.Exception;
import java.lang.Integer;
import java.lang.Long;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import javax.annotation.processing.Generated;
import kotlin.Unit;
import kotlin.coroutines.Continuation;
import kotlinx.coroutines.flow.Flow;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class ExampleEntity3Dao_Impl extends ExampleEntity3Dao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<ExampleEntity3> __insertionAdapterOfExampleEntity3;

  private final SharedSQLiteStatement __preparedStmtOfInsertDifferently;

  private final SharedSQLiteStatement __preparedStmtOfInsertOutgoingReplication;

  public ExampleEntity3Dao_Impl(@NonNull final RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfExampleEntity3 = new EntityInsertionAdapter<ExampleEntity3>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "INSERT OR ABORT INTO `ExampleEntity3` (`eeUid`,`cardNumber`,`name`,`lastUpdatedTime`,`nullableNumber`) VALUES (nullif(?, 0),?,?,?,?)";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final ExampleEntity3 entity) {
        statement.bindLong(1, entity.getEeUid());
        statement.bindLong(2, entity.getCardNumber());
        if (entity.getName() == null) {
          statement.bindNull(3);
        } else {
          statement.bindString(3, entity.getName());
        }
        statement.bindLong(4, entity.getLastUpdatedTime());
        if (entity.getNullableNumber() == null) {
          statement.bindNull(5);
        } else {
          statement.bindLong(5, entity.getNullableNumber());
        }
      }
    };
    this.__preparedStmtOfInsertDifferently = new SharedSQLiteStatement(__db) {
      @Override
      @NonNull
      public String createQuery() {
        final String _query = "\n"
                + "        INSERT OR IGNORE INTO ExampleEntity3(cardNumber, name, lastUpdatedTime)\n"
                + "        SELECT ? AS cardNumber,\n"
                + "               ? AS name,\n"
                + "               ? AS time\n"
                + "    ";
        return _query;
      }
    };
    this.__preparedStmtOfInsertOutgoingReplication = new SharedSQLiteStatement(__db) {
      @Override
      @NonNull
      public String createQuery() {
        final String _query = "\n"
                + "        INSERT INTO OutgoingReplication(destNodeId, orTableId, orPk1, orPk2, orPk3, orPk4)\n"
                + "               SELECT ? AS destNodeId, \n"
                + "                      542 AS orTableId,\n"
                + "                      ? AS orPk1,\n"
                + "                      0 AS orPk2,\n"
                + "                      0 AS orPk3,\n"
                + "                      0 AS orPk4\n"
                + "    ";
        return _query;
      }
    };
  }

  @Override
  public Object insertAsync(final ExampleEntity3 exampleEntity3,
      final Continuation<? super Long> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Long>() {
      @Override
      @NonNull
      public Long call() throws Exception {
        __db.beginTransaction();
        try {
          final Long _result = __insertionAdapterOfExampleEntity3.insertAndReturnId(exampleEntity3);
          __db.setTransactionSuccessful();
          return _result;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public long insert(final ExampleEntity3 exampleEntity3) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      final long _result = __insertionAdapterOfExampleEntity3.insertAndReturnId(exampleEntity3);
      __db.setTransactionSuccessful();
      return _result;
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public Object insertDifferently(final int cardNumber, final String name, final long time,
      final Continuation<? super Unit> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      @NonNull
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfInsertDifferently.acquire();
        int _argIndex = 1;
        _stmt.bindLong(_argIndex, cardNumber);
        _argIndex = 2;
        _stmt.bindString(_argIndex, name);
        _argIndex = 3;
        _stmt.bindLong(_argIndex, time);
        try {
          __db.beginTransaction();
          try {
            _stmt.executeInsert();
            __db.setTransactionSuccessful();
            return Unit.INSTANCE;
          } finally {
            __db.endTransaction();
          }
        } finally {
          __preparedStmtOfInsertDifferently.release(_stmt);
        }
      }
    }, $completion);
  }

  @Override
  public Object insertOutgoingReplication(final long entityUid, final long destination,
      final Continuation<? super Unit> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      @NonNull
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfInsertOutgoingReplication.acquire();
        int _argIndex = 1;
        _stmt.bindLong(_argIndex, destination);
        _argIndex = 2;
        _stmt.bindLong(_argIndex, entityUid);
        try {
          __db.beginTransaction();
          try {
            _stmt.executeInsert();
            __db.setTransactionSuccessful();
            return Unit.INSTANCE;
          } finally {
            __db.endTransaction();
          }
        } finally {
          __preparedStmtOfInsertOutgoingReplication.release(_stmt);
        }
      }
    }, $completion);
  }

  @Override
  public Object findByUid(final long uid, final Continuation<? super ExampleEntity3> $completion) {
    final String _sql = "\n"
            + "        SELECT ExampleEntity3.*\n"
            + "          FROM ExampleEntity3\n"
            + "         WHERE ExampleEntity3.eeUid = ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<ExampleEntity3>() {
      @Override
      @Nullable
      public ExampleEntity3 call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfEeUid = CursorUtil.getColumnIndexOrThrow(_cursor, "eeUid");
          final int _cursorIndexOfCardNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "cardNumber");
          final int _cursorIndexOfName = CursorUtil.getColumnIndexOrThrow(_cursor, "name");
          final int _cursorIndexOfLastUpdatedTime = CursorUtil.getColumnIndexOrThrow(_cursor, "lastUpdatedTime");
          final int _cursorIndexOfNullableNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "nullableNumber");
          final ExampleEntity3 _result;
          if (_cursor.moveToFirst()) {
            final long _tmpEeUid;
            _tmpEeUid = _cursor.getLong(_cursorIndexOfEeUid);
            final int _tmpCardNumber;
            _tmpCardNumber = _cursor.getInt(_cursorIndexOfCardNumber);
            final String _tmpName;
            if (_cursor.isNull(_cursorIndexOfName)) {
              _tmpName = null;
            } else {
              _tmpName = _cursor.getString(_cursorIndexOfName);
            }
            final long _tmpLastUpdatedTime;
            _tmpLastUpdatedTime = _cursor.getLong(_cursorIndexOfLastUpdatedTime);
            final Integer _tmpNullableNumber;
            if (_cursor.isNull(_cursorIndexOfNullableNumber)) {
              _tmpNullableNumber = null;
            } else {
              _tmpNullableNumber = _cursor.getInt(_cursorIndexOfNullableNumber);
            }
            _result = new ExampleEntity3(_tmpEeUid,_tmpCardNumber,_tmpName,_tmpLastUpdatedTime,_tmpNullableNumber);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Flow<ExampleEntity3> findByUidAsFlow(final long uid) {
    final String _sql = "\n"
            + "        SELECT ExampleEntity3.*\n"
            + "          FROM ExampleEntity3\n"
            + "         WHERE ExampleEntity3.eeUid = ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uid);
    return CoroutinesRoom.createFlow(__db, false, new String[] {"ExampleEntity3"}, new Callable<ExampleEntity3>() {
      @Override
      @Nullable
      public ExampleEntity3 call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfEeUid = CursorUtil.getColumnIndexOrThrow(_cursor, "eeUid");
          final int _cursorIndexOfCardNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "cardNumber");
          final int _cursorIndexOfName = CursorUtil.getColumnIndexOrThrow(_cursor, "name");
          final int _cursorIndexOfLastUpdatedTime = CursorUtil.getColumnIndexOrThrow(_cursor, "lastUpdatedTime");
          final int _cursorIndexOfNullableNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "nullableNumber");
          final ExampleEntity3 _result;
          if (_cursor.moveToFirst()) {
            final long _tmpEeUid;
            _tmpEeUid = _cursor.getLong(_cursorIndexOfEeUid);
            final int _tmpCardNumber;
            _tmpCardNumber = _cursor.getInt(_cursorIndexOfCardNumber);
            final String _tmpName;
            if (_cursor.isNull(_cursorIndexOfName)) {
              _tmpName = null;
            } else {
              _tmpName = _cursor.getString(_cursorIndexOfName);
            }
            final long _tmpLastUpdatedTime;
            _tmpLastUpdatedTime = _cursor.getLong(_cursorIndexOfLastUpdatedTime);
            final Integer _tmpNullableNumber;
            if (_cursor.isNull(_cursorIndexOfNullableNumber)) {
              _tmpNullableNumber = null;
            } else {
              _tmpNullableNumber = _cursor.getInt(_cursorIndexOfNullableNumber);
            }
            _result = new ExampleEntity3(_tmpEeUid,_tmpCardNumber,_tmpName,_tmpLastUpdatedTime,_tmpNullableNumber);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Object findAllWithCardNumAbove(final int minCardNum,
      final Continuation<? super List<ExampleEntity3>> $completion) {
    final String _sql = "\n"
            + "        SELECT ExampleEntity3.*\n"
            + "          FROM ExampleEntity3\n"
            + "         WHERE ExampleEntity3.cardNumber >= ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, minCardNum);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<ExampleEntity3>>() {
      @Override
      @NonNull
      public List<ExampleEntity3> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfEeUid = CursorUtil.getColumnIndexOrThrow(_cursor, "eeUid");
          final int _cursorIndexOfCardNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "cardNumber");
          final int _cursorIndexOfName = CursorUtil.getColumnIndexOrThrow(_cursor, "name");
          final int _cursorIndexOfLastUpdatedTime = CursorUtil.getColumnIndexOrThrow(_cursor, "lastUpdatedTime");
          final int _cursorIndexOfNullableNumber = CursorUtil.getColumnIndexOrThrow(_cursor, "nullableNumber");
          final List<ExampleEntity3> _result = new ArrayList<ExampleEntity3>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final ExampleEntity3 _item;
            final long _tmpEeUid;
            _tmpEeUid = _cursor.getLong(_cursorIndexOfEeUid);
            final int _tmpCardNumber;
            _tmpCardNumber = _cursor.getInt(_cursorIndexOfCardNumber);
            final String _tmpName;
            if (_cursor.isNull(_cursorIndexOfName)) {
              _tmpName = null;
            } else {
              _tmpName = _cursor.getString(_cursorIndexOfName);
            }
            final long _tmpLastUpdatedTime;
            _tmpLastUpdatedTime = _cursor.getLong(_cursorIndexOfLastUpdatedTime);
            final Integer _tmpNullableNumber;
            if (_cursor.isNull(_cursorIndexOfNullableNumber)) {
              _tmpNullableNumber = null;
            } else {
              _tmpNullableNumber = _cursor.getInt(_cursorIndexOfNullableNumber);
            }
            _item = new ExampleEntity3(_tmpEeUid,_tmpCardNumber,_tmpName,_tmpLastUpdatedTime,_tmpNullableNumber);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @NonNull
  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
