package db3;

import android.database.Cursor;
import android.os.CancellationSignal;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.room.CoroutinesRoom;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import java.lang.Class;
import java.lang.Exception;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import javax.annotation.processing.Generated;
import kotlin.Unit;
import kotlin.coroutines.Continuation;
import kotlinx.coroutines.flow.Flow;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class StatementEntityDao_Impl extends StatementEntityDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<StatementEntity> __insertionAdapterOfStatementEntity;

  public StatementEntityDao_Impl(@NonNull final RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfStatementEntity = new EntityInsertionAdapter<StatementEntity>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "INSERT OR ABORT INTO `StatementEntity` (`uidHi`,`uidLo`,`lct`,`name`) VALUES (?,?,?,?)";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final StatementEntity entity) {
        statement.bindLong(1, entity.getUidHi());
        statement.bindLong(2, entity.getUidLo());
        statement.bindLong(3, entity.getLct());
        if (entity.getName() == null) {
          statement.bindNull(4);
        } else {
          statement.bindString(4, entity.getName());
        }
      }
    };
  }

  @Override
  public Object insertAsync(final StatementEntity entity,
      final Continuation<? super Unit> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      @NonNull
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfStatementEntity.insert(entity);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public Object findAllAsync(final Continuation<? super List<StatementEntity>> $completion) {
    final String _sql = "\n"
            + "        SELECT StatementEntity.*\n"
            + "          FROM StatementEntity\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<StatementEntity>>() {
      @Override
      @NonNull
      public List<StatementEntity> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfUidHi = CursorUtil.getColumnIndexOrThrow(_cursor, "uidHi");
          final int _cursorIndexOfUidLo = CursorUtil.getColumnIndexOrThrow(_cursor, "uidLo");
          final int _cursorIndexOfLct = CursorUtil.getColumnIndexOrThrow(_cursor, "lct");
          final int _cursorIndexOfName = CursorUtil.getColumnIndexOrThrow(_cursor, "name");
          final List<StatementEntity> _result = new ArrayList<StatementEntity>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final StatementEntity _item;
            final long _tmpUidHi;
            _tmpUidHi = _cursor.getLong(_cursorIndexOfUidHi);
            final long _tmpUidLo;
            _tmpUidLo = _cursor.getLong(_cursorIndexOfUidLo);
            final long _tmpLct;
            _tmpLct = _cursor.getLong(_cursorIndexOfLct);
            final String _tmpName;
            if (_cursor.isNull(_cursorIndexOfName)) {
              _tmpName = null;
            } else {
              _tmpName = _cursor.getString(_cursorIndexOfName);
            }
            _item = new StatementEntity(_tmpUidHi,_tmpUidLo,_tmpLct,_tmpName);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Flow<StatementEntity> findByUidAsFlow(final long uidHi, final long uidLo) {
    final String _sql = "\n"
            + "        SELECT StatementEntity.*\n"
            + "          FROM StatementEntity\n"
            + "         WHERE StatementEntity.uidHi = ?\n"
            + "           AND StatementEntity.uidLo = ?\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 2);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uidHi);
    _argIndex = 2;
    _statement.bindLong(_argIndex, uidLo);
    return CoroutinesRoom.createFlow(__db, false, new String[] {"StatementEntity"}, new Callable<StatementEntity>() {
      @Override
      @Nullable
      public StatementEntity call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfUidHi = CursorUtil.getColumnIndexOrThrow(_cursor, "uidHi");
          final int _cursorIndexOfUidLo = CursorUtil.getColumnIndexOrThrow(_cursor, "uidLo");
          final int _cursorIndexOfLct = CursorUtil.getColumnIndexOrThrow(_cursor, "lct");
          final int _cursorIndexOfName = CursorUtil.getColumnIndexOrThrow(_cursor, "name");
          final StatementEntity _result;
          if (_cursor.moveToFirst()) {
            final long _tmpUidHi;
            _tmpUidHi = _cursor.getLong(_cursorIndexOfUidHi);
            final long _tmpUidLo;
            _tmpUidLo = _cursor.getLong(_cursorIndexOfUidLo);
            final long _tmpLct;
            _tmpLct = _cursor.getLong(_cursorIndexOfLct);
            final String _tmpName;
            if (_cursor.isNull(_cursorIndexOfName)) {
              _tmpName = null;
            } else {
              _tmpName = _cursor.getString(_cursorIndexOfName);
            }
            _result = new StatementEntity(_tmpUidHi,_tmpUidLo,_tmpLct,_tmpName);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Object findByUidAsync(final long uidHi, final long uidLo,
      final Continuation<? super StatementEntity> $completion) {
    final String _sql = "\n"
            + "        SELECT StatementEntity.*\n"
            + "          FROM StatementEntity\n"
            + "         WHERE StatementEntity.uidHi = ?\n"
            + "           AND StatementEntity.uidLo = ?\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 2);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uidHi);
    _argIndex = 2;
    _statement.bindLong(_argIndex, uidLo);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<StatementEntity>() {
      @Override
      @Nullable
      public StatementEntity call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfUidHi = CursorUtil.getColumnIndexOrThrow(_cursor, "uidHi");
          final int _cursorIndexOfUidLo = CursorUtil.getColumnIndexOrThrow(_cursor, "uidLo");
          final int _cursorIndexOfLct = CursorUtil.getColumnIndexOrThrow(_cursor, "lct");
          final int _cursorIndexOfName = CursorUtil.getColumnIndexOrThrow(_cursor, "name");
          final StatementEntity _result;
          if (_cursor.moveToFirst()) {
            final long _tmpUidHi;
            _tmpUidHi = _cursor.getLong(_cursorIndexOfUidHi);
            final long _tmpUidLo;
            _tmpUidLo = _cursor.getLong(_cursorIndexOfUidLo);
            final long _tmpLct;
            _tmpLct = _cursor.getLong(_cursorIndexOfLct);
            final String _tmpName;
            if (_cursor.isNull(_cursorIndexOfName)) {
              _tmpName = null;
            } else {
              _tmpName = _cursor.getString(_cursorIndexOfName);
            }
            _result = new StatementEntity(_tmpUidHi,_tmpUidLo,_tmpLct,_tmpName);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @NonNull
  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
