package repdb;

import android.database.Cursor;
import android.os.CancellationSignal;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.paging.PagingSource;
import androidx.room.CoroutinesRoom;
import androidx.room.EntityDeletionOrUpdateAdapter;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.paging.LimitOffsetPagingSource;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.room.util.StringUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import com.ustadmobile.door.entities.DoorNode;
import java.lang.Class;
import java.lang.Exception;
import java.lang.Integer;
import java.lang.Long;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.StringBuilder;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import javax.annotation.processing.Generated;
import kotlin.Unit;
import kotlin.coroutines.Continuation;
import kotlinx.coroutines.flow.Flow;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class RepDao_Impl implements RepDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<RepEntity> __insertionAdapterOfRepEntity;

  private final EntityInsertionAdapter<DoorNode> __insertionAdapterOfDoorNode;

  private final EntityDeletionOrUpdateAdapter<RepEntity> __updateAdapterOfRepEntity;

  public RepDao_Impl(@NonNull final RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfRepEntity = new EntityInsertionAdapter<RepEntity>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "INSERT OR ABORT INTO `RepEntity` (`rePrimaryKey`,`reLastChangedBy`,`reLastChangeTime`,`reNumField`,`reString`,`reBoolean`) VALUES (nullif(?, 0),?,?,?,?,?)";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final RepEntity entity) {
        statement.bindLong(1, entity.getRePrimaryKey());
        statement.bindLong(2, entity.getReLastChangedBy());
        statement.bindLong(3, entity.getReLastChangeTime());
        statement.bindLong(4, entity.getReNumField());
        if (entity.getReString() == null) {
          statement.bindNull(5);
        } else {
          statement.bindString(5, entity.getReString());
        }
        final int _tmp = entity.getReBoolean() ? 1 : 0;
        statement.bindLong(6, _tmp);
      }
    };
    this.__insertionAdapterOfDoorNode = new EntityInsertionAdapter<DoorNode>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "INSERT OR ABORT INTO `DoorNode` (`nodeId`,`auth`,`rel`) VALUES (?,?,?)";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final DoorNode entity) {
        statement.bindLong(1, entity.getNodeId());
        if (entity.getAuth() == null) {
          statement.bindNull(2);
        } else {
          statement.bindString(2, entity.getAuth());
        }
        statement.bindLong(3, entity.getRel());
      }
    };
    this.__updateAdapterOfRepEntity = new EntityDeletionOrUpdateAdapter<RepEntity>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "UPDATE OR ABORT `RepEntity` SET `rePrimaryKey` = ?,`reLastChangedBy` = ?,`reLastChangeTime` = ?,`reNumField` = ?,`reString` = ?,`reBoolean` = ? WHERE `rePrimaryKey` = ?";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final RepEntity entity) {
        statement.bindLong(1, entity.getRePrimaryKey());
        statement.bindLong(2, entity.getReLastChangedBy());
        statement.bindLong(3, entity.getReLastChangeTime());
        statement.bindLong(4, entity.getReNumField());
        if (entity.getReString() == null) {
          statement.bindNull(5);
        } else {
          statement.bindString(5, entity.getReString());
        }
        final int _tmp = entity.getReBoolean() ? 1 : 0;
        statement.bindLong(6, _tmp);
        statement.bindLong(7, entity.getRePrimaryKey());
      }
    };
  }

  @Override
  public void interfaceInsertFun(final RepEntity entity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfRepEntity.insert(entity);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public Object insertDoorNodeAsync(final DoorNode node,
      final Continuation<? super Unit> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      @NonNull
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfDoorNode.insert(node);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public void insertDoorNode(final DoorNode node) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfDoorNode.insert(node);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public Object insertAsync(final RepEntity repEntity,
      final Continuation<? super Long> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Long>() {
      @Override
      @NonNull
      public Long call() throws Exception {
        __db.beginTransaction();
        try {
          final Long _result = __insertionAdapterOfRepEntity.insertAndReturnId(repEntity);
          __db.setTransactionSuccessful();
          return _result;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public long insert(final RepEntity repEntity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      final long _result = __insertionAdapterOfRepEntity.insertAndReturnId(repEntity);
      __db.setTransactionSuccessful();
      return _result;
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void insertList(final List<RepEntity> repEntityList) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfRepEntity.insert(repEntityList);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public Object insertHttp(final RepEntity entity, final Continuation<? super Long> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Long>() {
      @Override
      @NonNull
      public Long call() throws Exception {
        __db.beginTransaction();
        try {
          final Long _result = __insertionAdapterOfRepEntity.insertAndReturnId(entity);
          __db.setTransactionSuccessful();
          return _result;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public void update(final RepEntity repEntity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __updateAdapterOfRepEntity.handle(repEntity);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public Object updateAsync(final RepEntity repEntity,
      final Continuation<? super Unit> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      @NonNull
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __updateAdapterOfRepEntity.handle(repEntity);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public int countEntities() {
    final String _sql = "\n"
            + "    SELECT COUNT(*)\n"
            + "      FROM RepEntity\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _result;
      if (_cursor.moveToFirst()) {
        _result = _cursor.getInt(0);
      } else {
        _result = 0;
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public RepEntity findByUid(final long uid) {
    final String _sql = "\n"
            + "    SELECT RepEntity.*\n"
            + "      FROM RepEntity\n"
            + "     WHERE RepEntity.rePrimaryKey = ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uid);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfRePrimaryKey = CursorUtil.getColumnIndexOrThrow(_cursor, "rePrimaryKey");
      final int _cursorIndexOfReLastChangedBy = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangedBy");
      final int _cursorIndexOfReLastChangeTime = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangeTime");
      final int _cursorIndexOfReNumField = CursorUtil.getColumnIndexOrThrow(_cursor, "reNumField");
      final int _cursorIndexOfReString = CursorUtil.getColumnIndexOrThrow(_cursor, "reString");
      final int _cursorIndexOfReBoolean = CursorUtil.getColumnIndexOrThrow(_cursor, "reBoolean");
      final RepEntity _result;
      if (_cursor.moveToFirst()) {
        _result = new RepEntity();
        final long _tmpRePrimaryKey;
        _tmpRePrimaryKey = _cursor.getLong(_cursorIndexOfRePrimaryKey);
        _result.setRePrimaryKey(_tmpRePrimaryKey);
        final long _tmpReLastChangedBy;
        _tmpReLastChangedBy = _cursor.getLong(_cursorIndexOfReLastChangedBy);
        _result.setReLastChangedBy(_tmpReLastChangedBy);
        final long _tmpReLastChangeTime;
        _tmpReLastChangeTime = _cursor.getLong(_cursorIndexOfReLastChangeTime);
        _result.setReLastChangeTime(_tmpReLastChangeTime);
        final int _tmpReNumField;
        _tmpReNumField = _cursor.getInt(_cursorIndexOfReNumField);
        _result.setReNumField(_tmpReNumField);
        final String _tmpReString;
        if (_cursor.isNull(_cursorIndexOfReString)) {
          _tmpReString = null;
        } else {
          _tmpReString = _cursor.getString(_cursorIndexOfReString);
        }
        _result.setReString(_tmpReString);
        final boolean _tmpReBoolean;
        final int _tmp;
        _tmp = _cursor.getInt(_cursorIndexOfReBoolean);
        _tmpReBoolean = _tmp != 0;
        _result.setReBoolean(_tmpReBoolean);
      } else {
        _result = null;
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public Object findByUidAsync(final long uid, final Continuation<? super RepEntity> $completion) {
    final String _sql = "\n"
            + "    SELECT RepEntity.*\n"
            + "      FROM RepEntity\n"
            + "     WHERE RepEntity.rePrimaryKey = ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<RepEntity>() {
      @Override
      @Nullable
      public RepEntity call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfRePrimaryKey = CursorUtil.getColumnIndexOrThrow(_cursor, "rePrimaryKey");
          final int _cursorIndexOfReLastChangedBy = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangedBy");
          final int _cursorIndexOfReLastChangeTime = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangeTime");
          final int _cursorIndexOfReNumField = CursorUtil.getColumnIndexOrThrow(_cursor, "reNumField");
          final int _cursorIndexOfReString = CursorUtil.getColumnIndexOrThrow(_cursor, "reString");
          final int _cursorIndexOfReBoolean = CursorUtil.getColumnIndexOrThrow(_cursor, "reBoolean");
          final RepEntity _result;
          if (_cursor.moveToFirst()) {
            _result = new RepEntity();
            final long _tmpRePrimaryKey;
            _tmpRePrimaryKey = _cursor.getLong(_cursorIndexOfRePrimaryKey);
            _result.setRePrimaryKey(_tmpRePrimaryKey);
            final long _tmpReLastChangedBy;
            _tmpReLastChangedBy = _cursor.getLong(_cursorIndexOfReLastChangedBy);
            _result.setReLastChangedBy(_tmpReLastChangedBy);
            final long _tmpReLastChangeTime;
            _tmpReLastChangeTime = _cursor.getLong(_cursorIndexOfReLastChangeTime);
            _result.setReLastChangeTime(_tmpReLastChangeTime);
            final int _tmpReNumField;
            _tmpReNumField = _cursor.getInt(_cursorIndexOfReNumField);
            _result.setReNumField(_tmpReNumField);
            final String _tmpReString;
            if (_cursor.isNull(_cursorIndexOfReString)) {
              _tmpReString = null;
            } else {
              _tmpReString = _cursor.getString(_cursorIndexOfReString);
            }
            _result.setReString(_tmpReString);
            final boolean _tmpReBoolean;
            final int _tmp;
            _tmp = _cursor.getInt(_cursorIndexOfReBoolean);
            _tmpReBoolean = _tmp != 0;
            _result.setReBoolean(_tmpReBoolean);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object findAllAsync(final Continuation<? super List<RepEntity>> $completion) {
    final String _sql = "\n"
            + "    SELECT RepEntity.*\n"
            + "      FROM RepEntity\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<RepEntity>>() {
      @Override
      @NonNull
      public List<RepEntity> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfRePrimaryKey = CursorUtil.getColumnIndexOrThrow(_cursor, "rePrimaryKey");
          final int _cursorIndexOfReLastChangedBy = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangedBy");
          final int _cursorIndexOfReLastChangeTime = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangeTime");
          final int _cursorIndexOfReNumField = CursorUtil.getColumnIndexOrThrow(_cursor, "reNumField");
          final int _cursorIndexOfReString = CursorUtil.getColumnIndexOrThrow(_cursor, "reString");
          final int _cursorIndexOfReBoolean = CursorUtil.getColumnIndexOrThrow(_cursor, "reBoolean");
          final List<RepEntity> _result = new ArrayList<RepEntity>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final RepEntity _item;
            _item = new RepEntity();
            final long _tmpRePrimaryKey;
            _tmpRePrimaryKey = _cursor.getLong(_cursorIndexOfRePrimaryKey);
            _item.setRePrimaryKey(_tmpRePrimaryKey);
            final long _tmpReLastChangedBy;
            _tmpReLastChangedBy = _cursor.getLong(_cursorIndexOfReLastChangedBy);
            _item.setReLastChangedBy(_tmpReLastChangedBy);
            final long _tmpReLastChangeTime;
            _tmpReLastChangeTime = _cursor.getLong(_cursorIndexOfReLastChangeTime);
            _item.setReLastChangeTime(_tmpReLastChangeTime);
            final int _tmpReNumField;
            _tmpReNumField = _cursor.getInt(_cursorIndexOfReNumField);
            _item.setReNumField(_tmpReNumField);
            final String _tmpReString;
            if (_cursor.isNull(_cursorIndexOfReString)) {
              _tmpReString = null;
            } else {
              _tmpReString = _cursor.getString(_cursorIndexOfReString);
            }
            _item.setReString(_tmpReString);
            final boolean _tmpReBoolean;
            final int _tmp;
            _tmp = _cursor.getInt(_cursorIndexOfReBoolean);
            _tmpReBoolean = _tmp != 0;
            _item.setReBoolean(_tmpReBoolean);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object selectSyncNodeId(final Continuation<? super Long> $completion) {
    final String _sql = "\n"
            + "        SELECT COALESCE(\n"
            + "                    (SELECT nodeClientId \n"
            + "                       FROM SyncNode \n"
            + "                      LIMIT 1), 0)\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<Long>() {
      @Override
      @NonNull
      public Long call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final Long _result;
          if (_cursor.moveToFirst()) {
            final long _tmp;
            _tmp = _cursor.getLong(0);
            _result = _tmp;
          } else {
            _result = 0L;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object findInStringList(final List<String> strList,
      final Continuation<? super List<RepEntity>> $completion) {
    final StringBuilder _stringBuilder = StringUtil.newStringBuilder();
    _stringBuilder.append("\n");
    _stringBuilder.append("        SELECT RepEntity.*");
    _stringBuilder.append("\n");
    _stringBuilder.append("          FROM RepEntity");
    _stringBuilder.append("\n");
    _stringBuilder.append("         WHERE reString IN (");
    final int _inputSize = strList.size();
    StringUtil.appendPlaceholders(_stringBuilder, _inputSize);
    _stringBuilder.append(") ");
    _stringBuilder.append("\n");
    _stringBuilder.append("    ");
    final String _sql = _stringBuilder.toString();
    final int _argCount = 0 + _inputSize;
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, _argCount);
    int _argIndex = 1;
    for (String _item : strList) {
      _statement.bindString(_argIndex, _item);
      _argIndex++;
    }
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<RepEntity>>() {
      @Override
      @NonNull
      public List<RepEntity> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfRePrimaryKey = CursorUtil.getColumnIndexOrThrow(_cursor, "rePrimaryKey");
          final int _cursorIndexOfReLastChangedBy = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangedBy");
          final int _cursorIndexOfReLastChangeTime = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangeTime");
          final int _cursorIndexOfReNumField = CursorUtil.getColumnIndexOrThrow(_cursor, "reNumField");
          final int _cursorIndexOfReString = CursorUtil.getColumnIndexOrThrow(_cursor, "reString");
          final int _cursorIndexOfReBoolean = CursorUtil.getColumnIndexOrThrow(_cursor, "reBoolean");
          final List<RepEntity> _result = new ArrayList<RepEntity>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final RepEntity _item_1;
            _item_1 = new RepEntity();
            final long _tmpRePrimaryKey;
            _tmpRePrimaryKey = _cursor.getLong(_cursorIndexOfRePrimaryKey);
            _item_1.setRePrimaryKey(_tmpRePrimaryKey);
            final long _tmpReLastChangedBy;
            _tmpReLastChangedBy = _cursor.getLong(_cursorIndexOfReLastChangedBy);
            _item_1.setReLastChangedBy(_tmpReLastChangedBy);
            final long _tmpReLastChangeTime;
            _tmpReLastChangeTime = _cursor.getLong(_cursorIndexOfReLastChangeTime);
            _item_1.setReLastChangeTime(_tmpReLastChangeTime);
            final int _tmpReNumField;
            _tmpReNumField = _cursor.getInt(_cursorIndexOfReNumField);
            _item_1.setReNumField(_tmpReNumField);
            final String _tmpReString;
            if (_cursor.isNull(_cursorIndexOfReString)) {
              _tmpReString = null;
            } else {
              _tmpReString = _cursor.getString(_cursorIndexOfReString);
            }
            _item_1.setReString(_tmpReString);
            final boolean _tmpReBoolean;
            final int _tmp;
            _tmp = _cursor.getInt(_cursorIndexOfReBoolean);
            _tmpReBoolean = _tmp != 0;
            _item_1.setReBoolean(_tmpReBoolean);
            _result.add(_item_1);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object sqliteOnlyFun(final int num1, final int num2,
      final Continuation<? super Long> $completion) {
    final String _sql = "SELECT MAX(?, ?)";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 2);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, num1);
    _argIndex = 2;
    _statement.bindLong(_argIndex, num2);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<Long>() {
      @Override
      @NonNull
      public Long call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final Long _result;
          if (_cursor.moveToFirst()) {
            final long _tmp;
            _tmp = _cursor.getLong(0);
            _result = _tmp;
          } else {
            _result = 0L;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Flow<List<RepEntity>> findAllAsFlow() {
    final String _sql = "\n"
            + "        SELECT * FROM RepEntity\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[] {"RepEntity"}, new Callable<List<RepEntity>>() {
      @Override
      @NonNull
      public List<RepEntity> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfRePrimaryKey = CursorUtil.getColumnIndexOrThrow(_cursor, "rePrimaryKey");
          final int _cursorIndexOfReLastChangedBy = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangedBy");
          final int _cursorIndexOfReLastChangeTime = CursorUtil.getColumnIndexOrThrow(_cursor, "reLastChangeTime");
          final int _cursorIndexOfReNumField = CursorUtil.getColumnIndexOrThrow(_cursor, "reNumField");
          final int _cursorIndexOfReString = CursorUtil.getColumnIndexOrThrow(_cursor, "reString");
          final int _cursorIndexOfReBoolean = CursorUtil.getColumnIndexOrThrow(_cursor, "reBoolean");
          final List<RepEntity> _result = new ArrayList<RepEntity>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final RepEntity _item;
            _item = new RepEntity();
            final long _tmpRePrimaryKey;
            _tmpRePrimaryKey = _cursor.getLong(_cursorIndexOfRePrimaryKey);
            _item.setRePrimaryKey(_tmpRePrimaryKey);
            final long _tmpReLastChangedBy;
            _tmpReLastChangedBy = _cursor.getLong(_cursorIndexOfReLastChangedBy);
            _item.setReLastChangedBy(_tmpReLastChangedBy);
            final long _tmpReLastChangeTime;
            _tmpReLastChangeTime = _cursor.getLong(_cursorIndexOfReLastChangeTime);
            _item.setReLastChangeTime(_tmpReLastChangeTime);
            final int _tmpReNumField;
            _tmpReNumField = _cursor.getInt(_cursorIndexOfReNumField);
            _item.setReNumField(_tmpReNumField);
            final String _tmpReString;
            if (_cursor.isNull(_cursorIndexOfReString)) {
              _tmpReString = null;
            } else {
              _tmpReString = _cursor.getString(_cursorIndexOfReString);
            }
            _item.setReString(_tmpReString);
            final boolean _tmpReBoolean;
            final int _tmp;
            _tmp = _cursor.getInt(_cursorIndexOfReBoolean);
            _tmpReBoolean = _tmp != 0;
            _item.setReBoolean(_tmpReBoolean);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public PagingSource<Integer, RepEntity> findAllPaged() {
    final String _sql = "\n"
            + "        SELECT * FROM RepEntity\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return new LimitOffsetPagingSource<RepEntity>(_statement, __db, "RepEntity") {
      @Override
      @NonNull
      protected List<RepEntity> convertRows(@NonNull final Cursor cursor) {
        final int _cursorIndexOfRePrimaryKey = CursorUtil.getColumnIndexOrThrow(cursor, "rePrimaryKey");
        final int _cursorIndexOfReLastChangedBy = CursorUtil.getColumnIndexOrThrow(cursor, "reLastChangedBy");
        final int _cursorIndexOfReLastChangeTime = CursorUtil.getColumnIndexOrThrow(cursor, "reLastChangeTime");
        final int _cursorIndexOfReNumField = CursorUtil.getColumnIndexOrThrow(cursor, "reNumField");
        final int _cursorIndexOfReString = CursorUtil.getColumnIndexOrThrow(cursor, "reString");
        final int _cursorIndexOfReBoolean = CursorUtil.getColumnIndexOrThrow(cursor, "reBoolean");
        final List<RepEntity> _result = new ArrayList<RepEntity>(cursor.getCount());
        while (cursor.moveToNext()) {
          final RepEntity _item;
          _item = new RepEntity();
          final long _tmpRePrimaryKey;
          _tmpRePrimaryKey = cursor.getLong(_cursorIndexOfRePrimaryKey);
          _item.setRePrimaryKey(_tmpRePrimaryKey);
          final long _tmpReLastChangedBy;
          _tmpReLastChangedBy = cursor.getLong(_cursorIndexOfReLastChangedBy);
          _item.setReLastChangedBy(_tmpReLastChangedBy);
          final long _tmpReLastChangeTime;
          _tmpReLastChangeTime = cursor.getLong(_cursorIndexOfReLastChangeTime);
          _item.setReLastChangeTime(_tmpReLastChangeTime);
          final int _tmpReNumField;
          _tmpReNumField = cursor.getInt(_cursorIndexOfReNumField);
          _item.setReNumField(_tmpReNumField);
          final String _tmpReString;
          if (cursor.isNull(_cursorIndexOfReString)) {
            _tmpReString = null;
          } else {
            _tmpReString = cursor.getString(_cursorIndexOfReString);
          }
          _item.setReString(_tmpReString);
          final boolean _tmpReBoolean;
          final int _tmp;
          _tmp = cursor.getInt(_cursorIndexOfReBoolean);
          _tmpReBoolean = _tmp != 0;
          _item.setReBoolean(_tmpReBoolean);
          _result.add(_item);
        }
        return _result;
      }
    };
  }

  @NonNull
  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
