package db3

import com.google.gson.Gson
import com.ustadmobile.door.AbstractDoorUriResponder
import com.ustadmobile.door.DoorConstants
import com.ustadmobile.door.DoorDaoProvider
import com.ustadmobile.door.NanoHttpdCall
import com.ustadmobile.door.ext.DoorTag
import com.ustadmobile.door.room.RoomDatabase
import fi.iki.elonen.NanoHTTPD
import fi.iki.elonen.router.RouterNanoHTTPD
import kotlin.Int
import kotlin.String
import kotlin.collections.Map
import kotlin.text.substringAfterLast
import kotlinx.coroutines.runBlocking
import org.kodein.di.DI
import org.kodein.di.Instance
import org.kodein.di.instance
import org.kodein.di.on
import org.kodein.type.TypeToken

public class ExampleEntity3Dao_UriResponder : AbstractDoorUriResponder() {
  public fun findAllWithCardNumAbove(
    _uriResource: RouterNanoHTTPD.UriResource,
    _urlParams: Map<String, String>,
    _session: NanoHTTPD.IHTTPSession,
    _dao: ExampleEntity3Dao,
    _gson: Gson,
  ): NanoHTTPD.Response {
    val __minCardNum : Int = _session.parameters.get("minCardNum")?.get(0)?.toInt() ?: 0
    val _result = runBlocking {
      _dao.findAllWithCardNumAbove(__minCardNum)
    }
    return NanoHTTPD.newFixedLengthResponse(NanoHTTPD.Response.Status.OK,
        DoorConstants.MIME_TYPE_JSON, _gson.toJson(_result))
  }

  override fun `get`(
    _uriResource: RouterNanoHTTPD.UriResource,
    _urlParams: Map<String, String>,
    _session: NanoHTTPD.IHTTPSession,
  ): NanoHTTPD.Response {
    val _fnName = _session.uri.substringAfterLast('/')
    val _di = _uriResource.initParameter(0, DI::class.java)
    val _daoProvider = _uriResource.initParameter(1, DoorDaoProvider::class.java) as
        DoorDaoProvider<RoomDatabase, ExampleEntity3Dao>
    val _typeToken = _uriResource.initParameter(2, TypeToken::class.java) as TypeToken<RoomDatabase>
    val _call = NanoHttpdCall(_uriResource, _urlParams, _session)
    val _db: RoomDatabase by _di.on(_call).Instance(_typeToken, tag = DoorTag.TAG_DB)
    val _repo: RoomDatabase by _di.on(_call).Instance(_typeToken, tag = DoorTag.TAG_REPO)
    val _dao = _daoProvider.getDao(_db)
    val _gson : Gson by _di.instance()
    return when(_fnName) {
      "findAllWithCardNumAbove" -> findAllWithCardNumAbove(_uriResource, _urlParams, _session, _dao,
          _gson)
      else -> NanoHTTPD.newFixedLengthResponse(NanoHTTPD.Response.Status.NOT_FOUND,
          DoorConstants.MIME_TYPE_PLAIN, "")
    }
  }

  override fun post(
    _uriResource: RouterNanoHTTPD.UriResource,
    _urlParams: Map<String, String>,
    _session: NanoHTTPD.IHTTPSession,
  ): NanoHTTPD.Response {
    val _fnName = _session.uri.substringAfterLast('/')
    val _di = _uriResource.initParameter(0, DI::class.java)
    val _daoProvider = _uriResource.initParameter(1, DoorDaoProvider::class.java) as
        DoorDaoProvider<RoomDatabase, ExampleEntity3Dao>
    val _typeToken = _uriResource.initParameter(2, TypeToken::class.java) as TypeToken<RoomDatabase>
    val _call = NanoHttpdCall(_uriResource, _urlParams, _session)
    val _db: RoomDatabase by _di.on(_call).Instance(_typeToken, tag = DoorTag.TAG_DB)
    val _repo: RoomDatabase by _di.on(_call).Instance(_typeToken, tag = DoorTag.TAG_REPO)
    val _dao = _daoProvider.getDao(_db)
    val _gson : Gson by _di.instance()
    return NanoHTTPD.newFixedLengthResponse(NanoHTTPD.Response.Status.NOT_FOUND,
        DoorConstants.MIME_TYPE_PLAIN, "")
  }
}
