package repdb

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import androidx.room.Update
import kotlin.Any
import kotlin.Long

@Dao
public actual abstract class RepWithAttachmentDao {
  @Insert(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract fun insert(entityWithAttachment: RepEntityWithAttachment): Long

  @Insert(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract suspend fun insertAsync(entityWithAttachment: RepEntityWithAttachment):
      Long

  @Insert(
    onConflict = 1,
    entity = Any::class,
  )
  public actual abstract fun replace(entityWithAttachment: RepEntityWithAttachment)

  @Query(`value` =
      "\n        SELECT RepEntityWithAttachment.*\n          FROM RepEntityWithAttachment\n         WHERE waUid = :uid\n    ")
  public actual abstract fun findByUid(uid: Long): RepEntityWithAttachment?

  @Update(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract fun update(entity: RepEntityWithAttachment)
}
