package db3

import com.ustadmobile.door.DoorDbType
import com.ustadmobile.door.EntityInsertionAdapter
import com.ustadmobile.door.PreparedStatementConfig
import com.ustadmobile.door.ext.prepareAndUseStatementAsync
import com.ustadmobile.door.jdbc.PreparedStatement
import com.ustadmobile.door.jdbc.ext.executeQueryAsyncKmp
import com.ustadmobile.door.jdbc.ext.mapNextRow
import com.ustadmobile.door.jdbc.ext.useResults
import com.ustadmobile.door.room.RoomDatabase
import kotlin.Boolean
import kotlin.Long
import kotlin.String

public class BadgeDao_JdbcImpl(
  public val _db: RoomDatabase,
) : BadgeDao() {
  public val _insertAdapterBadge_abort: EntityInsertionAdapter<Badge> = object :
      EntityInsertionAdapter<Badge>(_db) {
    override fun makeSql(returnsId: Boolean): String =
        "INSERT INTO Badge (badgeUid, badgeName, badgePoints, badgeLastChangeTime) VALUES(?, ?, ?, ?)"

    override fun bindPreparedStmtToEntity(stmt: PreparedStatement, entity: Badge) {
      if(entity.badgeUid == 0L) {
        stmt.setObject(1, null)
      } else {
        stmt.setLong(1, entity.badgeUid)
      }
      stmt.setString(2, entity.badgeName)
      stmt.setInt(3, entity.badgePoints)
      stmt.setLong(4, entity.badgeLastChangeTime)
    }
  }

  override suspend fun insertAsync(badge: Badge): Long {
    val _retVal = _insertAdapterBadge_abort.insertAndReturnIdAsync(badge)
    return _retVal
  }

  override suspend fun findBadgeByUid(uid: Long): BadgeWithTotal? =
      _db.prepareAndUseStatementAsync(PreparedStatementConfig(
    sql = """
    |
    |        SELECT Badge.*,0 AS total
    |          FROM Badge
    |         WHERE Badge.badgeUid = CAST(? AS BIGINT) 
    |    
    """.trimMargin(),
    postgreSql = """
    |
    |        SELECT Badge.*,0 AS total
    |          FROM Badge
    |         WHERE Badge.badgeUid = ? 
    |    
    |""".trimMargin(),
    readOnly = true,)
  ) { _stmt -> 
    _stmt.setLong(1,uid)
    _stmt.executeQueryAsyncKmp().useResults{ _result -> 
      _result.mapNextRow(null) {
        val _tmp_total = _result.getInt("total")
        val _tmp_badgeUid = _result.getLong("badgeUid")
        val _tmp_badgeName = _result.getString("badgeName")
        val _tmp_badgePoints = _result.getInt("badgePoints")
        val _tmp_badgeLastChangeTime = _result.getLong("badgeLastChangeTime")
        BadgeWithTotal().apply {
          this.total = _tmp_total
          this.badgeUid = _tmp_badgeUid
          this.badgeName = _tmp_badgeName
          this.badgePoints = _tmp_badgePoints
          this.badgeLastChangeTime = _tmp_badgeLastChangeTime
        }
      }
    }
  }
}
