package db3

import com.ustadmobile.door.DoorDatabaseRepository
import com.ustadmobile.door.ext.doorNodeIdHeader
import com.ustadmobile.door.ext.setRepoUrl
import com.ustadmobile.door.http.replicateHttpRequestCatchAndLog
import com.ustadmobile.door.replication.onClientRepoDoorMessageHttpResponse
import com.ustadmobile.door.replication.withRepoChangeMonitorAsync
import com.ustadmobile.door.room.RoomDatabase
import io.ktor.client.HttpClient
import io.ktor.client.request.`get`
import io.ktor.client.request.`header`
import io.ktor.client.request.parameter
import kotlin.Long
import kotlin.String
import kotlin.Suppress
import kotlinx.serialization.builtins.serializer

@Suppress("REDUNDANT_PROJECTION", "LocalVariableName", "ClassName")
public class BadgeDao_Repo(
  public val _db: RoomDatabase,
  public val _repo: DoorDatabaseRepository,
  public val _dao: BadgeDao,
  public val _httpClient: HttpClient,
  public val _clientId: Long,
  public val _endpoint: String,
) : BadgeDao() {
  override suspend fun insertAsync(badge: Badge): Long {
    val _result = _repo.withRepoChangeMonitorAsync("Badge") {
      _dao.insertAsync(badge)
    }
    return _result
  }

  override suspend fun findBadgeByUid(uid: Long): BadgeWithTotal? {
    _repo.replicateHttpRequestCatchAndLog(repoPath = "BadgeDao/findBadgeByUid") {
      val _response = _httpClient.`get` {
        setRepoUrl(_repo.config, "BadgeDao/findBadgeByUid")
        doorNodeIdHeader(_repo)
        `header`("cache-control", "no-store")
        parameter("uid", _repo.config.json.encodeToString(Long.serializer(), uid))
      }

      _db.onClientRepoDoorMessageHttpResponse(_response, _repo.config.json)
    }
    val _result = _dao.findBadgeByUid(uid)
    return _result
  }
}
