package db3

import kotlin.Long
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow

public actual abstract class StatementEntityDao {
  public actual abstract suspend fun insertAsync(entity: StatementEntity)

  public actual abstract suspend fun findAllAsync(): List<StatementEntity>

  public actual abstract fun findByUidAsFlow(uidHi: Long, uidLo: Long): Flow<StatementEntity?>

  public actual abstract suspend fun findByUidAsync(uidHi: Long, uidLo: Long): StatementEntity?
}
