package db3

import com.ustadmobile.door.DoorDatabaseRepository
import com.ustadmobile.door.ext.doorNodeIdHeader
import com.ustadmobile.door.ext.setRepoUrl
import com.ustadmobile.door.http.replicateHttpRequestCatchAndLog
import com.ustadmobile.door.replication.onClientRepoDoorMessageHttpResponse
import com.ustadmobile.door.replication.withRepoChangeMonitorAsync
import com.ustadmobile.door.room.RoomDatabase
import io.ktor.client.HttpClient
import io.ktor.client.request.`get`
import io.ktor.client.request.`header`
import io.ktor.client.request.parameter
import kotlin.Long
import kotlin.String
import kotlin.Suppress
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow
import kotlinx.serialization.builtins.serializer

@Suppress("REDUNDANT_PROJECTION", "LocalVariableName", "ClassName")
public class StatementEntityDao_Repo(
  public val _db: RoomDatabase,
  public val _repo: DoorDatabaseRepository,
  public val _dao: StatementEntityDao,
  public val _httpClient: HttpClient,
  public val _clientId: Long,
  public val _endpoint: String,
) : StatementEntityDao() {
  override suspend fun insertAsync(entity: StatementEntity) {
    _repo.withRepoChangeMonitorAsync("StatementEntity") {
      _dao.insertAsync(entity)
    }
  }

  override suspend fun findAllAsync(): List<StatementEntity> {
    val _result = _dao.findAllAsync()
    return _result
  }

  override fun findByUidAsFlow(uidHi: Long, uidLo: Long): Flow<StatementEntity?> {
    val _result = _dao.findByUidAsFlow(uidHi, uidLo)
    return _result
  }

  override suspend fun findByUidAsync(uidHi: Long, uidLo: Long): StatementEntity? {
    _repo.replicateHttpRequestCatchAndLog(repoPath = "StatementEntityDao/findByUidAsync") {
      val _response = _httpClient.`get` {
        setRepoUrl(_repo.config, "StatementEntityDao/findByUidAsync")
        doorNodeIdHeader(_repo)
        `header`("cache-control", "no-store")
        parameter("uidHi", _repo.config.json.encodeToString(Long.serializer(), uidHi))
        parameter("uidLo", _repo.config.json.encodeToString(Long.serializer(), uidLo))
      }

      _db.onClientRepoDoorMessageHttpResponse(_response, _repo.config.json)
    }
    val _result = _dao.findByUidAsync(uidHi, uidLo)
    return _result
  }
}
