package db2

import com.ustadmobile.door.SyncNode
import kotlin.Boolean
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.collections.List

public actual abstract class ExampleSyncableDao {
  public actual abstract fun insert(syncableEntity: ExampleSyncableEntity): Long

  public actual abstract fun insertList(syncableEntityLIst: List<ExampleSyncableEntity>)

  public actual abstract suspend fun insertAndReturnList(entities: List<ExampleSyncableEntity>):
      List<Long>

  public actual abstract suspend fun insertAsync(syncableEntity: ExampleSyncableEntity): Long

  public actual abstract fun findAll(): List<ExampleSyncableEntity>

  public actual abstract suspend fun findByListParam(numberList: List<Long>):
      List<ExampleSyncableEntity>

  public actual abstract fun findByUid(uid: Long): ExampleSyncableEntity?

  public actual abstract fun findByName(name: String?): ExampleSyncableEntity?

  public actual abstract fun findAllWithOtherByUid():
      List<ExampleSyncableEntityWithOtherSyncableEntity>

  public actual abstract fun updateNumberByUid(uid: Long, newNumber: Long)

  public actual abstract suspend fun updateAsync(exampleSyncableEntity: ExampleSyncableEntity)

  public actual abstract suspend fun findOneFromWeb(): ExampleSyncableEntity?

  public actual abstract suspend fun findOneValue(): Int

  public actual abstract fun getSyncNode(): SyncNode?

  public actual abstract fun insertFromSelectQuery(name: String?, publik: Boolean)
}
