package db3

import com.ustadmobile.door.http.DbAndDao
import com.ustadmobile.door.http.DoorHttpServerConfig
import com.ustadmobile.door.ktor.KtorCallDbAdapter
import com.ustadmobile.door.ktor.routes.ReplicationRoute
import com.ustadmobile.door.replication.DoorRepositoryReplicationClient
import io.ktor.server.routing.Route
import io.ktor.server.routing.route

public fun Route.ExampleDb3_KtorRoute(serverConfig: DoorHttpServerConfig,
    dbCallAdapter: KtorCallDbAdapter<ExampleDb3>) {
  route(DoorRepositoryReplicationClient.REPLICATION_PATH) {
    ReplicationRoute(serverConfig, dbCallAdapter)
  }
  route("ExampleEntity3Dao") {
    ExampleEntity3Dao_KtorRoute(
      serverConfig = serverConfig,
      daoCallAdapter =  {
        call -> dbCallAdapter(call).let { DbAndDao<ExampleEntity3Dao>(it, it.exampleEntity3Dao) }
      }
    )
  }
  route("DiscussionPostDao") {
    DiscussionPostDao_KtorRoute(
      serverConfig = serverConfig,
      daoCallAdapter =  {
        call -> dbCallAdapter(call).let { DbAndDao<DiscussionPostDao>(it, it.discussionPostDao) }
      }
    )
  }
  route("MemberDao") {
    MemberDao_KtorRoute(
      serverConfig = serverConfig,
      daoCallAdapter =  {
        call -> dbCallAdapter(call).let { DbAndDao<MemberDao>(it, it.memberDao) }
      }
    )
  }
  route("BadgeDao") {
    BadgeDao_KtorRoute(
      serverConfig = serverConfig,
      daoCallAdapter =  {
        call -> dbCallAdapter(call).let { DbAndDao<BadgeDao>(it, it.badgeDao) }
      }
    )
  }
  route("StatementEntityDao") {
    StatementEntityDao_KtorRoute(
      serverConfig = serverConfig,
      daoCallAdapter =  {
        call -> dbCallAdapter(call).let { DbAndDao<StatementEntityDao>(it, it.statementEntityDao) }
      }
    )
  }
}
