package db3

import com.ustadmobile.door.ext.doorPrimaryKeyManager
import com.ustadmobile.door.ext.rootDatabase
import com.ustadmobile.door.room.RoomDatabase
import com.ustadmobile.door.util.systemTimeInMillis
import kotlin.Boolean
import kotlin.Long
import kotlin.String

public class MemberDao_DoorWrapper(
  private val _db: RoomDatabase,
  private val _dao: MemberDao,
) : MemberDao() {
  override suspend fun insertAsync(member: Member): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(member.memberUid == 0L) {
      val _newPk = _pkManager.nextIdAsync(544)
      member.memberUid = _newPk
    }
    member.memberLastModified = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insertAsync(member)
    return member.memberUid
  }

  override suspend fun findByUid(memberUid: Long): Member? = _dao.findByUid(memberUid)

  override suspend fun checkMemberNodeHasPermission(postUid: Long, nodeId: Long): Boolean =
      _dao.checkMemberNodeHasPermission(postUid, nodeId)

  override suspend fun findAuthorByPostUid(postUid: Long): Member? =
      _dao.findAuthorByPostUid(postUid)

  override suspend fun getFirstNameByMemberId(memberUid: Long): String? =
      _dao.getFirstNameByMemberId(memberUid)
}
