package repdb

import com.ustadmobile.door.ext.doorPrimaryKeyManager
import com.ustadmobile.door.ext.rootDatabase
import com.ustadmobile.door.room.RoomDatabase
import com.ustadmobile.door.util.systemTimeInMillis
import kotlin.Long

public class RepWithAttachmentDao_DoorWrapper(
  private val _db: RoomDatabase,
  private val _dao: RepWithAttachmentDao,
) : RepWithAttachmentDao() {
  override fun insert(entityWithAttachment: RepEntityWithAttachment): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(entityWithAttachment.waUid == 0L) {
      val _newPk = _pkManager.nextId(50)
      entityWithAttachment.waUid = _newPk
    }
    entityWithAttachment.waVersionId = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insert(entityWithAttachment)
    return entityWithAttachment.waUid
  }

  override suspend fun insertAsync(entityWithAttachment: RepEntityWithAttachment): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(entityWithAttachment.waUid == 0L) {
      val _newPk = _pkManager.nextIdAsync(50)
      entityWithAttachment.waUid = _newPk
    }
    entityWithAttachment.waVersionId = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insertAsync(entityWithAttachment)
    return entityWithAttachment.waUid
  }

  override fun replace(entityWithAttachment: RepEntityWithAttachment) {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(entityWithAttachment.waUid == 0L) {
      val _newPk = _pkManager.nextId(50)
      entityWithAttachment.waUid = _newPk
    }
    entityWithAttachment.waVersionId = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.replace(entityWithAttachment)
  }

  override fun findByUid(uid: Long): RepEntityWithAttachment? = _dao.findByUid(uid)

  override fun update(entity: RepEntityWithAttachment) {
    entity.waVersionId = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.update(entity)
  }
}
