package db3;

import android.database.Cursor;
import android.os.CancellationSignal;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.room.CoroutinesRoom;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import java.lang.Class;
import java.lang.Exception;
import java.lang.Long;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import javax.annotation.processing.Generated;
import kotlin.coroutines.Continuation;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class BadgeDao_Impl extends BadgeDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<Badge> __insertionAdapterOfBadge;

  public BadgeDao_Impl(@NonNull final RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfBadge = new EntityInsertionAdapter<Badge>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "INSERT OR ABORT INTO `Badge` (`badgeUid`,`badgeName`,`badgePoints`,`badgeLastChangeTime`) VALUES (nullif(?, 0),?,?,?)";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final Badge entity) {
        statement.bindLong(1, entity.getBadgeUid());
        if (entity.getBadgeName() == null) {
          statement.bindNull(2);
        } else {
          statement.bindString(2, entity.getBadgeName());
        }
        statement.bindLong(3, entity.getBadgePoints());
        statement.bindLong(4, entity.getBadgeLastChangeTime());
      }
    };
  }

  @Override
  public Object insertAsync(final Badge badge, final Continuation<? super Long> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Long>() {
      @Override
      @NonNull
      public Long call() throws Exception {
        __db.beginTransaction();
        try {
          final Long _result = __insertionAdapterOfBadge.insertAndReturnId(badge);
          __db.setTransactionSuccessful();
          return _result;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public Object findBadgeByUid(final long uid,
      final Continuation<? super BadgeWithTotal> $completion) {
    final String _sql = "\n"
            + "        SELECT Badge.*,0 AS total\n"
            + "          FROM Badge\n"
            + "         WHERE Badge.badgeUid = ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<BadgeWithTotal>() {
      @Override
      @Nullable
      public BadgeWithTotal call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfBadgeUid = CursorUtil.getColumnIndexOrThrow(_cursor, "badgeUid");
          final int _cursorIndexOfBadgeName = CursorUtil.getColumnIndexOrThrow(_cursor, "badgeName");
          final int _cursorIndexOfBadgePoints = CursorUtil.getColumnIndexOrThrow(_cursor, "badgePoints");
          final int _cursorIndexOfBadgeLastChangeTime = CursorUtil.getColumnIndexOrThrow(_cursor, "badgeLastChangeTime");
          final int _cursorIndexOfTotal = CursorUtil.getColumnIndexOrThrow(_cursor, "total");
          final BadgeWithTotal _result;
          if (_cursor.moveToFirst()) {
            _result = new BadgeWithTotal();
            final long _tmpBadgeUid;
            _tmpBadgeUid = _cursor.getLong(_cursorIndexOfBadgeUid);
            _result.setBadgeUid(_tmpBadgeUid);
            final String _tmpBadgeName;
            if (_cursor.isNull(_cursorIndexOfBadgeName)) {
              _tmpBadgeName = null;
            } else {
              _tmpBadgeName = _cursor.getString(_cursorIndexOfBadgeName);
            }
            _result.setBadgeName(_tmpBadgeName);
            final int _tmpBadgePoints;
            _tmpBadgePoints = _cursor.getInt(_cursorIndexOfBadgePoints);
            _result.setBadgePoints(_tmpBadgePoints);
            final long _tmpBadgeLastChangeTime;
            _tmpBadgeLastChangeTime = _cursor.getLong(_cursorIndexOfBadgeLastChangeTime);
            _result.setBadgeLastChangeTime(_tmpBadgeLastChangeTime);
            final int _tmpTotal;
            _tmpTotal = _cursor.getInt(_cursorIndexOfTotal);
            _result.setTotal(_tmpTotal);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @NonNull
  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
