package db3

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import kotlin.Any
import kotlin.Long
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow

@Dao
public actual abstract class StatementEntityDao {
  @Insert(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract suspend fun insertAsync(entity: StatementEntity)

  @Query(`value` = "\n        SELECT StatementEntity.*\n          FROM StatementEntity\n    ")
  public actual abstract suspend fun findAllAsync(): List<StatementEntity>

  @Query(`value` =
      "\n        SELECT StatementEntity.*\n          FROM StatementEntity\n         WHERE StatementEntity.uidHi = :uidHi\n           AND StatementEntity.uidLo = :uidLo\n    ")
  public actual abstract fun findByUidAsFlow(uidHi: Long, uidLo: Long): Flow<StatementEntity?>

  @Query(`value` =
      "\n        SELECT StatementEntity.*\n          FROM StatementEntity\n         WHERE StatementEntity.uidHi = :uidHi\n           AND StatementEntity.uidLo = :uidLo\n    ")
  public actual abstract suspend fun findByUidAsync(uidHi: Long, uidLo: Long): StatementEntity?
}
