package db2;

import androidx.annotation.NonNull;
import androidx.room.DatabaseConfiguration;
import androidx.room.InvalidationTracker;
import androidx.room.RoomDatabase;
import androidx.room.RoomOpenHelper;
import androidx.room.migration.AutoMigrationSpec;
import androidx.room.migration.Migration;
import androidx.room.util.DBUtil;
import androidx.room.util.TableInfo;
import androidx.sqlite.db.SupportSQLiteDatabase;
import androidx.sqlite.db.SupportSQLiteOpenHelper;
import java.lang.Class;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.annotation.processing.Generated;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class ExampleDatabase2_Impl extends ExampleDatabase2 {
  private volatile ExampleSyncableDao _exampleSyncableDao;

  private volatile ExampleDao2 _exampleDao2;

  private volatile ExampleLinkEntityDao _exampleLinkEntityDao;

  private volatile ExampleDaoWithInterface _exampleDaoWithInterface;

  private volatile ExampleEntityPkIntDao _exampleEntityPkIntDao;

  private volatile AccessGrantDao _accessGrantDao;

  @Override
  @NonNull
  protected SupportSQLiteOpenHelper createOpenHelper(@NonNull final DatabaseConfiguration config) {
    final SupportSQLiteOpenHelper.Callback _openCallback = new RoomOpenHelper(config, new RoomOpenHelper.Delegate(2) {
      @Override
      public void createAllTables(@NonNull final SupportSQLiteDatabase db) {
        db.execSQL("CREATE TABLE IF NOT EXISTS `ExampleEntity2` (`uid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `name` TEXT, `someNumber` INTEGER NOT NULL, `checked` INTEGER NOT NULL, `rewardsCardNumber` INTEGER)");
        db.execSQL("CREATE INDEX IF NOT EXISTS `name_checked_idx` ON `ExampleEntity2` (`name`, `checked`)");
        db.execSQL("CREATE INDEX IF NOT EXISTS `index_ExampleEntity2_someNumber` ON `ExampleEntity2` (`someNumber`)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `ExampleLinkEntity` (`eeUid` INTEGER NOT NULL, `fkValue` INTEGER NOT NULL, PRIMARY KEY(`eeUid`))");
        db.execSQL("CREATE TABLE IF NOT EXISTS `ExampleEntityPkInt` (`pk` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `str` TEXT)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `SyncNode` (`nodeClientId` INTEGER NOT NULL, PRIMARY KEY(`nodeClientId`))");
        db.execSQL("CREATE TABLE IF NOT EXISTS `ExampleSyncableEntity` (`esUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `esLcsn` INTEGER NOT NULL, `esMcsn` INTEGER NOT NULL, `esLcb` INTEGER NOT NULL, `esNumber` INTEGER NOT NULL, `esName` TEXT, `publik` INTEGER NOT NULL)");
        db.execSQL("CREATE INDEX IF NOT EXISTS `index_ExampleSyncableEntity_esNumber_esName` ON `ExampleSyncableEntity` (`esNumber`, `esName`)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `OtherSyncableEntity` (`osUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `osLcb` INTEGER NOT NULL, `osMcsn` INTEGER NOT NULL, `osLcsn` INTEGER NOT NULL, `otherFk` INTEGER NOT NULL, `otherNum` INTEGER NOT NULL, `otherStr` TEXT)");
        db.execSQL("CREATE INDEX IF NOT EXISTS `index_other_fk_to_num` ON `OtherSyncableEntity` (`otherFk`, `otherNum`)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `AccessGrant` (`accessId` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `aLcsn` INTEGER NOT NULL, `aPcsn` INTEGER NOT NULL, `aLcb` INTEGER NOT NULL, `deviceId` INTEGER NOT NULL, `tableId` INTEGER NOT NULL, `entityUid` INTEGER NOT NULL)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `DoorNode` (`nodeId` INTEGER NOT NULL, `auth` TEXT, `rel` INTEGER NOT NULL DEFAULT 2, PRIMARY KEY(`nodeId`))");
        db.execSQL("CREATE TABLE IF NOT EXISTS room_master_table (id INTEGER PRIMARY KEY,identity_hash TEXT)");
        db.execSQL("INSERT OR REPLACE INTO room_master_table (id,identity_hash) VALUES(42, '82810d64d7a9210f91a404dd77d01f95')");
      }

      @Override
      public void dropAllTables(@NonNull final SupportSQLiteDatabase db) {
        db.execSQL("DROP TABLE IF EXISTS `ExampleEntity2`");
        db.execSQL("DROP TABLE IF EXISTS `ExampleLinkEntity`");
        db.execSQL("DROP TABLE IF EXISTS `ExampleEntityPkInt`");
        db.execSQL("DROP TABLE IF EXISTS `SyncNode`");
        db.execSQL("DROP TABLE IF EXISTS `ExampleSyncableEntity`");
        db.execSQL("DROP TABLE IF EXISTS `OtherSyncableEntity`");
        db.execSQL("DROP TABLE IF EXISTS `AccessGrant`");
        db.execSQL("DROP TABLE IF EXISTS `DoorNode`");
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onDestructiveMigration(db);
          }
        }
      }

      @Override
      public void onCreate(@NonNull final SupportSQLiteDatabase db) {
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onCreate(db);
          }
        }
      }

      @Override
      public void onOpen(@NonNull final SupportSQLiteDatabase db) {
        mDatabase = db;
        internalInitInvalidationTracker(db);
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onOpen(db);
          }
        }
      }

      @Override
      public void onPreMigrate(@NonNull final SupportSQLiteDatabase db) {
        DBUtil.dropFtsSyncTriggers(db);
      }

      @Override
      public void onPostMigrate(@NonNull final SupportSQLiteDatabase db) {
      }

      @Override
      @NonNull
      public RoomOpenHelper.ValidationResult onValidateSchema(
          @NonNull final SupportSQLiteDatabase db) {
        final HashMap<String, TableInfo.Column> _columnsExampleEntity2 = new HashMap<String, TableInfo.Column>(5);
        _columnsExampleEntity2.put("uid", new TableInfo.Column("uid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntity2.put("name", new TableInfo.Column("name", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntity2.put("someNumber", new TableInfo.Column("someNumber", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntity2.put("checked", new TableInfo.Column("checked", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntity2.put("rewardsCardNumber", new TableInfo.Column("rewardsCardNumber", "INTEGER", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysExampleEntity2 = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesExampleEntity2 = new HashSet<TableInfo.Index>(2);
        _indicesExampleEntity2.add(new TableInfo.Index("name_checked_idx", false, Arrays.asList("name", "checked"), Arrays.asList("ASC", "ASC")));
        _indicesExampleEntity2.add(new TableInfo.Index("index_ExampleEntity2_someNumber", false, Arrays.asList("someNumber"), Arrays.asList("ASC")));
        final TableInfo _infoExampleEntity2 = new TableInfo("ExampleEntity2", _columnsExampleEntity2, _foreignKeysExampleEntity2, _indicesExampleEntity2);
        final TableInfo _existingExampleEntity2 = TableInfo.read(db, "ExampleEntity2");
        if (!_infoExampleEntity2.equals(_existingExampleEntity2)) {
          return new RoomOpenHelper.ValidationResult(false, "ExampleEntity2(db2.ExampleEntity2).\n"
                  + " Expected:\n" + _infoExampleEntity2 + "\n"
                  + " Found:\n" + _existingExampleEntity2);
        }
        final HashMap<String, TableInfo.Column> _columnsExampleLinkEntity = new HashMap<String, TableInfo.Column>(2);
        _columnsExampleLinkEntity.put("eeUid", new TableInfo.Column("eeUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleLinkEntity.put("fkValue", new TableInfo.Column("fkValue", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysExampleLinkEntity = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesExampleLinkEntity = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoExampleLinkEntity = new TableInfo("ExampleLinkEntity", _columnsExampleLinkEntity, _foreignKeysExampleLinkEntity, _indicesExampleLinkEntity);
        final TableInfo _existingExampleLinkEntity = TableInfo.read(db, "ExampleLinkEntity");
        if (!_infoExampleLinkEntity.equals(_existingExampleLinkEntity)) {
          return new RoomOpenHelper.ValidationResult(false, "ExampleLinkEntity(db2.ExampleLinkEntity).\n"
                  + " Expected:\n" + _infoExampleLinkEntity + "\n"
                  + " Found:\n" + _existingExampleLinkEntity);
        }
        final HashMap<String, TableInfo.Column> _columnsExampleEntityPkInt = new HashMap<String, TableInfo.Column>(2);
        _columnsExampleEntityPkInt.put("pk", new TableInfo.Column("pk", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntityPkInt.put("str", new TableInfo.Column("str", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysExampleEntityPkInt = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesExampleEntityPkInt = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoExampleEntityPkInt = new TableInfo("ExampleEntityPkInt", _columnsExampleEntityPkInt, _foreignKeysExampleEntityPkInt, _indicesExampleEntityPkInt);
        final TableInfo _existingExampleEntityPkInt = TableInfo.read(db, "ExampleEntityPkInt");
        if (!_infoExampleEntityPkInt.equals(_existingExampleEntityPkInt)) {
          return new RoomOpenHelper.ValidationResult(false, "ExampleEntityPkInt(db2.ExampleEntityPkInt).\n"
                  + " Expected:\n" + _infoExampleEntityPkInt + "\n"
                  + " Found:\n" + _existingExampleEntityPkInt);
        }
        final HashMap<String, TableInfo.Column> _columnsSyncNode = new HashMap<String, TableInfo.Column>(1);
        _columnsSyncNode.put("nodeClientId", new TableInfo.Column("nodeClientId", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysSyncNode = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesSyncNode = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoSyncNode = new TableInfo("SyncNode", _columnsSyncNode, _foreignKeysSyncNode, _indicesSyncNode);
        final TableInfo _existingSyncNode = TableInfo.read(db, "SyncNode");
        if (!_infoSyncNode.equals(_existingSyncNode)) {
          return new RoomOpenHelper.ValidationResult(false, "SyncNode(com.ustadmobile.door.SyncNode).\n"
                  + " Expected:\n" + _infoSyncNode + "\n"
                  + " Found:\n" + _existingSyncNode);
        }
        final HashMap<String, TableInfo.Column> _columnsExampleSyncableEntity = new HashMap<String, TableInfo.Column>(7);
        _columnsExampleSyncableEntity.put("esUid", new TableInfo.Column("esUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleSyncableEntity.put("esLcsn", new TableInfo.Column("esLcsn", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleSyncableEntity.put("esMcsn", new TableInfo.Column("esMcsn", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleSyncableEntity.put("esLcb", new TableInfo.Column("esLcb", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleSyncableEntity.put("esNumber", new TableInfo.Column("esNumber", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleSyncableEntity.put("esName", new TableInfo.Column("esName", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleSyncableEntity.put("publik", new TableInfo.Column("publik", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysExampleSyncableEntity = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesExampleSyncableEntity = new HashSet<TableInfo.Index>(1);
        _indicesExampleSyncableEntity.add(new TableInfo.Index("index_ExampleSyncableEntity_esNumber_esName", false, Arrays.asList("esNumber", "esName"), Arrays.asList("ASC", "ASC")));
        final TableInfo _infoExampleSyncableEntity = new TableInfo("ExampleSyncableEntity", _columnsExampleSyncableEntity, _foreignKeysExampleSyncableEntity, _indicesExampleSyncableEntity);
        final TableInfo _existingExampleSyncableEntity = TableInfo.read(db, "ExampleSyncableEntity");
        if (!_infoExampleSyncableEntity.equals(_existingExampleSyncableEntity)) {
          return new RoomOpenHelper.ValidationResult(false, "ExampleSyncableEntity(db2.ExampleSyncableEntity).\n"
                  + " Expected:\n" + _infoExampleSyncableEntity + "\n"
                  + " Found:\n" + _existingExampleSyncableEntity);
        }
        final HashMap<String, TableInfo.Column> _columnsOtherSyncableEntity = new HashMap<String, TableInfo.Column>(7);
        _columnsOtherSyncableEntity.put("osUid", new TableInfo.Column("osUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOtherSyncableEntity.put("osLcb", new TableInfo.Column("osLcb", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOtherSyncableEntity.put("osMcsn", new TableInfo.Column("osMcsn", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOtherSyncableEntity.put("osLcsn", new TableInfo.Column("osLcsn", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOtherSyncableEntity.put("otherFk", new TableInfo.Column("otherFk", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOtherSyncableEntity.put("otherNum", new TableInfo.Column("otherNum", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOtherSyncableEntity.put("otherStr", new TableInfo.Column("otherStr", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysOtherSyncableEntity = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesOtherSyncableEntity = new HashSet<TableInfo.Index>(1);
        _indicesOtherSyncableEntity.add(new TableInfo.Index("index_other_fk_to_num", false, Arrays.asList("otherFk", "otherNum"), Arrays.asList("ASC", "ASC")));
        final TableInfo _infoOtherSyncableEntity = new TableInfo("OtherSyncableEntity", _columnsOtherSyncableEntity, _foreignKeysOtherSyncableEntity, _indicesOtherSyncableEntity);
        final TableInfo _existingOtherSyncableEntity = TableInfo.read(db, "OtherSyncableEntity");
        if (!_infoOtherSyncableEntity.equals(_existingOtherSyncableEntity)) {
          return new RoomOpenHelper.ValidationResult(false, "OtherSyncableEntity(db2.OtherSyncableEntity).\n"
                  + " Expected:\n" + _infoOtherSyncableEntity + "\n"
                  + " Found:\n" + _existingOtherSyncableEntity);
        }
        final HashMap<String, TableInfo.Column> _columnsAccessGrant = new HashMap<String, TableInfo.Column>(7);
        _columnsAccessGrant.put("accessId", new TableInfo.Column("accessId", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccessGrant.put("aLcsn", new TableInfo.Column("aLcsn", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccessGrant.put("aPcsn", new TableInfo.Column("aPcsn", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccessGrant.put("aLcb", new TableInfo.Column("aLcb", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccessGrant.put("deviceId", new TableInfo.Column("deviceId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccessGrant.put("tableId", new TableInfo.Column("tableId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccessGrant.put("entityUid", new TableInfo.Column("entityUid", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysAccessGrant = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesAccessGrant = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoAccessGrant = new TableInfo("AccessGrant", _columnsAccessGrant, _foreignKeysAccessGrant, _indicesAccessGrant);
        final TableInfo _existingAccessGrant = TableInfo.read(db, "AccessGrant");
        if (!_infoAccessGrant.equals(_existingAccessGrant)) {
          return new RoomOpenHelper.ValidationResult(false, "AccessGrant(db2.AccessGrant).\n"
                  + " Expected:\n" + _infoAccessGrant + "\n"
                  + " Found:\n" + _existingAccessGrant);
        }
        final HashMap<String, TableInfo.Column> _columnsDoorNode = new HashMap<String, TableInfo.Column>(3);
        _columnsDoorNode.put("nodeId", new TableInfo.Column("nodeId", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDoorNode.put("auth", new TableInfo.Column("auth", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDoorNode.put("rel", new TableInfo.Column("rel", "INTEGER", true, 0, "2", TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysDoorNode = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesDoorNode = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoDoorNode = new TableInfo("DoorNode", _columnsDoorNode, _foreignKeysDoorNode, _indicesDoorNode);
        final TableInfo _existingDoorNode = TableInfo.read(db, "DoorNode");
        if (!_infoDoorNode.equals(_existingDoorNode)) {
          return new RoomOpenHelper.ValidationResult(false, "DoorNode(com.ustadmobile.door.entities.DoorNode).\n"
                  + " Expected:\n" + _infoDoorNode + "\n"
                  + " Found:\n" + _existingDoorNode);
        }
        return new RoomOpenHelper.ValidationResult(true, null);
      }
    }, "82810d64d7a9210f91a404dd77d01f95", "5917dda14b0a196cde86f1e71e32f007");
    final SupportSQLiteOpenHelper.Configuration _sqliteConfig = SupportSQLiteOpenHelper.Configuration.builder(config.context).name(config.name).callback(_openCallback).build();
    final SupportSQLiteOpenHelper _helper = config.sqliteOpenHelperFactory.create(_sqliteConfig);
    return _helper;
  }

  @Override
  @NonNull
  protected InvalidationTracker createInvalidationTracker() {
    final HashMap<String, String> _shadowTablesMap = new HashMap<String, String>(0);
    final HashMap<String, Set<String>> _viewTables = new HashMap<String, Set<String>>(0);
    return new InvalidationTracker(this, _shadowTablesMap, _viewTables, "ExampleEntity2","ExampleLinkEntity","ExampleEntityPkInt","SyncNode","ExampleSyncableEntity","OtherSyncableEntity","AccessGrant","DoorNode");
  }

  @Override
  public void clearAllTables() {
    super.assertNotMainThread();
    final SupportSQLiteDatabase _db = super.getOpenHelper().getWritableDatabase();
    try {
      super.beginTransaction();
      _db.execSQL("DELETE FROM `ExampleEntity2`");
      _db.execSQL("DELETE FROM `ExampleLinkEntity`");
      _db.execSQL("DELETE FROM `ExampleEntityPkInt`");
      _db.execSQL("DELETE FROM `SyncNode`");
      _db.execSQL("DELETE FROM `ExampleSyncableEntity`");
      _db.execSQL("DELETE FROM `OtherSyncableEntity`");
      _db.execSQL("DELETE FROM `AccessGrant`");
      _db.execSQL("DELETE FROM `DoorNode`");
      super.setTransactionSuccessful();
    } finally {
      super.endTransaction();
      _db.query("PRAGMA wal_checkpoint(FULL)").close();
      if (!_db.inTransaction()) {
        _db.execSQL("VACUUM");
      }
    }
  }

  @Override
  @NonNull
  protected Map<Class<?>, List<Class<?>>> getRequiredTypeConverters() {
    final HashMap<Class<?>, List<Class<?>>> _typeConvertersMap = new HashMap<Class<?>, List<Class<?>>>();
    _typeConvertersMap.put(ExampleSyncableDao.class, ExampleSyncableDao_Impl.getRequiredConverters());
    _typeConvertersMap.put(ExampleDao2.class, ExampleDao2_Impl.getRequiredConverters());
    _typeConvertersMap.put(ExampleLinkEntityDao.class, ExampleLinkEntityDao_Impl.getRequiredConverters());
    _typeConvertersMap.put(ExampleDaoWithInterface.class, ExampleDaoWithInterface_Impl.getRequiredConverters());
    _typeConvertersMap.put(ExampleEntityPkIntDao.class, ExampleEntityPkIntDao_Impl.getRequiredConverters());
    _typeConvertersMap.put(AccessGrantDao.class, AccessGrantDao_Impl.getRequiredConverters());
    return _typeConvertersMap;
  }

  @Override
  @NonNull
  public Set<Class<? extends AutoMigrationSpec>> getRequiredAutoMigrationSpecs() {
    final HashSet<Class<? extends AutoMigrationSpec>> _autoMigrationSpecsSet = new HashSet<Class<? extends AutoMigrationSpec>>();
    return _autoMigrationSpecsSet;
  }

  @Override
  @NonNull
  public List<Migration> getAutoMigrations(
      @NonNull final Map<Class<? extends AutoMigrationSpec>, AutoMigrationSpec> autoMigrationSpecs) {
    final List<Migration> _autoMigrations = new ArrayList<Migration>();
    return _autoMigrations;
  }

  @Override
  public ExampleSyncableDao exampleSyncableDao() {
    if (_exampleSyncableDao != null) {
      return _exampleSyncableDao;
    } else {
      synchronized(this) {
        if(_exampleSyncableDao == null) {
          _exampleSyncableDao = new ExampleSyncableDao_Impl(this);
        }
        return _exampleSyncableDao;
      }
    }
  }

  @Override
  public ExampleDao2 exampleDao2() {
    if (_exampleDao2 != null) {
      return _exampleDao2;
    } else {
      synchronized(this) {
        if(_exampleDao2 == null) {
          _exampleDao2 = new ExampleDao2_Impl(this);
        }
        return _exampleDao2;
      }
    }
  }

  @Override
  public ExampleLinkEntityDao exampleLinkedEntityDao() {
    if (_exampleLinkEntityDao != null) {
      return _exampleLinkEntityDao;
    } else {
      synchronized(this) {
        if(_exampleLinkEntityDao == null) {
          _exampleLinkEntityDao = new ExampleLinkEntityDao_Impl(this);
        }
        return _exampleLinkEntityDao;
      }
    }
  }

  @Override
  public ExampleDaoWithInterface examlpeDaoWithInterface() {
    if (_exampleDaoWithInterface != null) {
      return _exampleDaoWithInterface;
    } else {
      synchronized(this) {
        if(_exampleDaoWithInterface == null) {
          _exampleDaoWithInterface = new ExampleDaoWithInterface_Impl(this);
        }
        return _exampleDaoWithInterface;
      }
    }
  }

  @Override
  public ExampleEntityPkIntDao exampleEntityPkIntDao() {
    if (_exampleEntityPkIntDao != null) {
      return _exampleEntityPkIntDao;
    } else {
      synchronized(this) {
        if(_exampleEntityPkIntDao == null) {
          _exampleEntityPkIntDao = new ExampleEntityPkIntDao_Impl(this);
        }
        return _exampleEntityPkIntDao;
      }
    }
  }

  @Override
  public AccessGrantDao accessGrantDao() {
    if (_accessGrantDao != null) {
      return _accessGrantDao;
    } else {
      synchronized(this) {
        if(_accessGrantDao == null) {
          _accessGrantDao = new AccessGrantDao_Impl(this);
        }
        return _accessGrantDao;
      }
    }
  }
}
