package db3;

import android.database.Cursor;
import android.os.CancellationSignal;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.paging.PagingSource;
import androidx.room.CoroutinesRoom;
import androidx.room.EntityDeletionOrUpdateAdapter;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.paging.LimitOffsetPagingSource;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.room.util.StringUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import java.lang.Boolean;
import java.lang.Class;
import java.lang.Exception;
import java.lang.Integer;
import java.lang.Long;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.StringBuilder;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import javax.annotation.processing.Generated;
import kotlin.Unit;
import kotlin.coroutines.Continuation;
import kotlinx.coroutines.flow.Flow;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class DiscussionPostDao_Impl extends DiscussionPostDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<DiscussionPost> __insertionAdapterOfDiscussionPost;

  private final EntityDeletionOrUpdateAdapter<DiscussionPost> __updateAdapterOfDiscussionPost;

  public DiscussionPostDao_Impl(@NonNull final RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfDiscussionPost = new EntityInsertionAdapter<DiscussionPost>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "INSERT OR ABORT INTO `DiscussionPost` (`postUid`,`postReplyToPostUid`,`postTitle`,`postText`,`postLastModified`,`posterMemberUid`,`isBanned`) VALUES (nullif(?, 0),?,?,?,?,?,?)";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final DiscussionPost entity) {
        statement.bindLong(1, entity.getPostUid());
        statement.bindLong(2, entity.getPostReplyToPostUid());
        if (entity.getPostTitle() == null) {
          statement.bindNull(3);
        } else {
          statement.bindString(3, entity.getPostTitle());
        }
        if (entity.getPostText() == null) {
          statement.bindNull(4);
        } else {
          statement.bindString(4, entity.getPostText());
        }
        statement.bindLong(5, entity.getPostLastModified());
        statement.bindLong(6, entity.getPosterMemberUid());
        final Integer _tmp = entity.isBanned() == null ? null : (entity.isBanned() ? 1 : 0);
        if (_tmp == null) {
          statement.bindNull(7);
        } else {
          statement.bindLong(7, _tmp);
        }
      }
    };
    this.__updateAdapterOfDiscussionPost = new EntityDeletionOrUpdateAdapter<DiscussionPost>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "UPDATE OR ABORT `DiscussionPost` SET `postUid` = ?,`postReplyToPostUid` = ?,`postTitle` = ?,`postText` = ?,`postLastModified` = ?,`posterMemberUid` = ?,`isBanned` = ? WHERE `postUid` = ?";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final DiscussionPost entity) {
        statement.bindLong(1, entity.getPostUid());
        statement.bindLong(2, entity.getPostReplyToPostUid());
        if (entity.getPostTitle() == null) {
          statement.bindNull(3);
        } else {
          statement.bindString(3, entity.getPostTitle());
        }
        if (entity.getPostText() == null) {
          statement.bindNull(4);
        } else {
          statement.bindString(4, entity.getPostText());
        }
        statement.bindLong(5, entity.getPostLastModified());
        statement.bindLong(6, entity.getPosterMemberUid());
        final Integer _tmp = entity.isBanned() == null ? null : (entity.isBanned() ? 1 : 0);
        if (_tmp == null) {
          statement.bindNull(7);
        } else {
          statement.bindLong(7, _tmp);
        }
        statement.bindLong(8, entity.getPostUid());
      }
    };
  }

  @Override
  public Object insertAsync(final DiscussionPost post,
      final Continuation<? super Long> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Long>() {
      @Override
      @NonNull
      public Long call() throws Exception {
        __db.beginTransaction();
        try {
          final Long _result = __insertionAdapterOfDiscussionPost.insertAndReturnId(post);
          __db.setTransactionSuccessful();
          return _result;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public Object update(final DiscussionPost post, final Continuation<? super Unit> $completion) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      @NonNull
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __updateAdapterOfDiscussionPost.handle(post);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, $completion);
  }

  @Override
  public Object findByUid(final long postUid,
      final Continuation<? super DiscussionPost> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost\n"
            + "         WHERE DiscussionPost.postUid = ?\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<DiscussionPost>() {
      @Override
      @Nullable
      public DiscussionPost call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final DiscussionPost _result;
          if (_cursor.moveToFirst()) {
            final long _tmpPostUid;
            _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
            final long _tmpPostReplyToPostUid;
            _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
            final String _tmpPostTitle;
            if (_cursor.isNull(_cursorIndexOfPostTitle)) {
              _tmpPostTitle = null;
            } else {
              _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
            }
            final String _tmpPostText;
            if (_cursor.isNull(_cursorIndexOfPostText)) {
              _tmpPostText = null;
            } else {
              _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
            }
            final long _tmpPostLastModified;
            _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
            final long _tmpPosterMemberUid;
            _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
            final Boolean _tmpIsBanned;
            final Integer _tmp;
            if (_cursor.isNull(_cursorIndexOfIsBanned)) {
              _tmp = null;
            } else {
              _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
            }
            _tmpIsBanned = _tmp == null ? null : _tmp != 0;
            _result = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object findByUidAsyncOverHttp(final long postUid,
      final Continuation<? super DiscussionPost> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost\n"
            + "         WHERE DiscussionPost.postUid = ?\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<DiscussionPost>() {
      @Override
      @Nullable
      public DiscussionPost call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final DiscussionPost _result;
          if (_cursor.moveToFirst()) {
            final long _tmpPostUid;
            _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
            final long _tmpPostReplyToPostUid;
            _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
            final String _tmpPostTitle;
            if (_cursor.isNull(_cursorIndexOfPostTitle)) {
              _tmpPostTitle = null;
            } else {
              _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
            }
            final String _tmpPostText;
            if (_cursor.isNull(_cursorIndexOfPostText)) {
              _tmpPostText = null;
            } else {
              _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
            }
            final long _tmpPostLastModified;
            _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
            final long _tmpPosterMemberUid;
            _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
            final Boolean _tmpIsBanned;
            final Integer _tmp;
            if (_cursor.isNull(_cursorIndexOfIsBanned)) {
              _tmp = null;
            } else {
              _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
            }
            _tmpIsBanned = _tmp == null ? null : _tmp != 0;
            _result = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object findAllRepliesWithPosterMember(final long postUid,
      final Continuation<? super List<DiscussionPostAndPosterMember>> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*, Member.*\n"
            + "          FROM DiscussionPost\n"
            + "               LEFT JOIN Member\n"
            + "                     ON Member.memberUid = DiscussionPost.posterMemberUid\n"
            + "         WHERE DiscussionPost.postReplyToPostUid = ?\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<DiscussionPostAndPosterMember>>() {
      @Override
      @NonNull
      public List<DiscussionPostAndPosterMember> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "memberUid");
          final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
          final int _cursorIndexOfLastName = CursorUtil.getColumnIndexOrThrow(_cursor, "lastName");
          final int _cursorIndexOfMemberLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "memberLastModified");
          final List<DiscussionPostAndPosterMember> _result = new ArrayList<DiscussionPostAndPosterMember>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final DiscussionPostAndPosterMember _item;
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            final Member _tmpPosterMember;
            if (!(_cursor.isNull(_cursorIndexOfMemberUid) && _cursor.isNull(_cursorIndexOfFirstName) && _cursor.isNull(_cursorIndexOfLastName) && _cursor.isNull(_cursorIndexOfMemberLastModified))) {
              final long _tmpMemberUid;
              _tmpMemberUid = _cursor.getLong(_cursorIndexOfMemberUid);
              final String _tmpFirstName;
              if (_cursor.isNull(_cursorIndexOfFirstName)) {
                _tmpFirstName = null;
              } else {
                _tmpFirstName = _cursor.getString(_cursorIndexOfFirstName);
              }
              final String _tmpLastName;
              if (_cursor.isNull(_cursorIndexOfLastName)) {
                _tmpLastName = null;
              } else {
                _tmpLastName = _cursor.getString(_cursorIndexOfLastName);
              }
              final long _tmpMemberLastModified;
              _tmpMemberLastModified = _cursor.getLong(_cursorIndexOfMemberLastModified);
              _tmpPosterMember = new Member(_tmpMemberUid,_tmpFirstName,_tmpLastName,_tmpMemberLastModified);
            } else {
              _tmpPosterMember = null;
            }
            _item = new DiscussionPostAndPosterMember();
            _item.setDiscussionPost(_tmpDiscussionPost);
            _item.setPosterMember(_tmpPosterMember);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Flow<List<DiscussionPostAndPosterMember>> findAllRepliesWithPosterMemberAsFlow(
      final long postUid) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*, Member.*\n"
            + "          FROM DiscussionPost\n"
            + "               LEFT JOIN Member\n"
            + "                     ON Member.memberUid = DiscussionPost.posterMemberUid\n"
            + "         WHERE DiscussionPost.postReplyToPostUid = ?\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    return CoroutinesRoom.createFlow(__db, false, new String[] {"DiscussionPost",
        "Member"}, new Callable<List<DiscussionPostAndPosterMember>>() {
      @Override
      @NonNull
      public List<DiscussionPostAndPosterMember> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "memberUid");
          final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
          final int _cursorIndexOfLastName = CursorUtil.getColumnIndexOrThrow(_cursor, "lastName");
          final int _cursorIndexOfMemberLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "memberLastModified");
          final List<DiscussionPostAndPosterMember> _result = new ArrayList<DiscussionPostAndPosterMember>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final DiscussionPostAndPosterMember _item;
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            final Member _tmpPosterMember;
            if (!(_cursor.isNull(_cursorIndexOfMemberUid) && _cursor.isNull(_cursorIndexOfFirstName) && _cursor.isNull(_cursorIndexOfLastName) && _cursor.isNull(_cursorIndexOfMemberLastModified))) {
              final long _tmpMemberUid;
              _tmpMemberUid = _cursor.getLong(_cursorIndexOfMemberUid);
              final String _tmpFirstName;
              if (_cursor.isNull(_cursorIndexOfFirstName)) {
                _tmpFirstName = null;
              } else {
                _tmpFirstName = _cursor.getString(_cursorIndexOfFirstName);
              }
              final String _tmpLastName;
              if (_cursor.isNull(_cursorIndexOfLastName)) {
                _tmpLastName = null;
              } else {
                _tmpLastName = _cursor.getString(_cursorIndexOfLastName);
              }
              final long _tmpMemberLastModified;
              _tmpMemberLastModified = _cursor.getLong(_cursorIndexOfMemberLastModified);
              _tmpPosterMember = new Member(_tmpMemberUid,_tmpFirstName,_tmpLastName,_tmpMemberLastModified);
            } else {
              _tmpPosterMember = null;
            }
            _item = new DiscussionPostAndPosterMember();
            _item.setDiscussionPost(_tmpDiscussionPost);
            _item.setPosterMember(_tmpPosterMember);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Object findByUidWithPosterMember(final long postUid,
      final Continuation<? super DiscussionPostAndPosterMember> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*, Member.*\n"
            + "          FROM DiscussionPost\n"
            + "               LEFT JOIN Member\n"
            + "                     ON Member.memberUid = DiscussionPost.posterMemberUid\n"
            + "         WHERE DiscussionPost.postUid = ?            \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<DiscussionPostAndPosterMember>() {
      @Override
      @Nullable
      public DiscussionPostAndPosterMember call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "memberUid");
          final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
          final int _cursorIndexOfLastName = CursorUtil.getColumnIndexOrThrow(_cursor, "lastName");
          final int _cursorIndexOfMemberLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "memberLastModified");
          final DiscussionPostAndPosterMember _result;
          if (_cursor.moveToFirst()) {
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            final Member _tmpPosterMember;
            if (!(_cursor.isNull(_cursorIndexOfMemberUid) && _cursor.isNull(_cursorIndexOfFirstName) && _cursor.isNull(_cursorIndexOfLastName) && _cursor.isNull(_cursorIndexOfMemberLastModified))) {
              final long _tmpMemberUid;
              _tmpMemberUid = _cursor.getLong(_cursorIndexOfMemberUid);
              final String _tmpFirstName;
              if (_cursor.isNull(_cursorIndexOfFirstName)) {
                _tmpFirstName = null;
              } else {
                _tmpFirstName = _cursor.getString(_cursorIndexOfFirstName);
              }
              final String _tmpLastName;
              if (_cursor.isNull(_cursorIndexOfLastName)) {
                _tmpLastName = null;
              } else {
                _tmpLastName = _cursor.getString(_cursorIndexOfLastName);
              }
              final long _tmpMemberLastModified;
              _tmpMemberLastModified = _cursor.getLong(_cursorIndexOfMemberLastModified);
              _tmpPosterMember = new Member(_tmpMemberUid,_tmpFirstName,_tmpLastName,_tmpMemberLastModified);
            } else {
              _tmpPosterMember = null;
            }
            _result = new DiscussionPostAndPosterMember();
            _result.setDiscussionPost(_tmpDiscussionPost);
            _result.setPosterMember(_tmpPosterMember);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Flow<DiscussionPostAndPosterMember> findByUidWithPosterMemberAsFlow(final long postUid) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*, Member.*\n"
            + "          FROM DiscussionPost\n"
            + "               LEFT JOIN Member\n"
            + "                     ON Member.memberUid = DiscussionPost.posterMemberUid\n"
            + "         WHERE DiscussionPost.postUid = ?            \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    return CoroutinesRoom.createFlow(__db, false, new String[] {"DiscussionPost",
        "Member"}, new Callable<DiscussionPostAndPosterMember>() {
      @Override
      @Nullable
      public DiscussionPostAndPosterMember call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "memberUid");
          final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
          final int _cursorIndexOfLastName = CursorUtil.getColumnIndexOrThrow(_cursor, "lastName");
          final int _cursorIndexOfMemberLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "memberLastModified");
          final DiscussionPostAndPosterMember _result;
          if (_cursor.moveToFirst()) {
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            final Member _tmpPosterMember;
            if (!(_cursor.isNull(_cursorIndexOfMemberUid) && _cursor.isNull(_cursorIndexOfFirstName) && _cursor.isNull(_cursorIndexOfLastName) && _cursor.isNull(_cursorIndexOfMemberLastModified))) {
              final long _tmpMemberUid;
              _tmpMemberUid = _cursor.getLong(_cursorIndexOfMemberUid);
              final String _tmpFirstName;
              if (_cursor.isNull(_cursorIndexOfFirstName)) {
                _tmpFirstName = null;
              } else {
                _tmpFirstName = _cursor.getString(_cursorIndexOfFirstName);
              }
              final String _tmpLastName;
              if (_cursor.isNull(_cursorIndexOfLastName)) {
                _tmpLastName = null;
              } else {
                _tmpLastName = _cursor.getString(_cursorIndexOfLastName);
              }
              final long _tmpMemberLastModified;
              _tmpMemberLastModified = _cursor.getLong(_cursorIndexOfMemberLastModified);
              _tmpPosterMember = new Member(_tmpMemberUid,_tmpFirstName,_tmpLastName,_tmpMemberLastModified);
            } else {
              _tmpPosterMember = null;
            }
            _result = new DiscussionPostAndPosterMember();
            _result.setDiscussionPost(_tmpDiscussionPost);
            _result.setPosterMember(_tmpPosterMember);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Object findByUidList(final List<Long> postUids,
      final Continuation<? super List<DiscussionPostAndPosterMember>> $completion) {
    final StringBuilder _stringBuilder = StringUtil.newStringBuilder();
    _stringBuilder.append("\n");
    _stringBuilder.append("        SELECT DiscussionPost.*, Member.*");
    _stringBuilder.append("\n");
    _stringBuilder.append("          FROM DiscussionPost");
    _stringBuilder.append("\n");
    _stringBuilder.append("               LEFT JOIN Member");
    _stringBuilder.append("\n");
    _stringBuilder.append("                     ON Member.memberUid = DiscussionPost.posterMemberUid");
    _stringBuilder.append("\n");
    _stringBuilder.append("         WHERE DiscussionPost.postUid IN (");
    final int _inputSize = postUids.size();
    StringUtil.appendPlaceholders(_stringBuilder, _inputSize);
    _stringBuilder.append(")    ");
    _stringBuilder.append("\n");
    _stringBuilder.append("    ");
    final String _sql = _stringBuilder.toString();
    final int _argCount = 0 + _inputSize;
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, _argCount);
    int _argIndex = 1;
    for (long _item : postUids) {
      _statement.bindLong(_argIndex, _item);
      _argIndex++;
    }
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<DiscussionPostAndPosterMember>>() {
      @Override
      @NonNull
      public List<DiscussionPostAndPosterMember> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "memberUid");
          final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
          final int _cursorIndexOfLastName = CursorUtil.getColumnIndexOrThrow(_cursor, "lastName");
          final int _cursorIndexOfMemberLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "memberLastModified");
          final List<DiscussionPostAndPosterMember> _result = new ArrayList<DiscussionPostAndPosterMember>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final DiscussionPostAndPosterMember _item_1;
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            final Member _tmpPosterMember;
            if (!(_cursor.isNull(_cursorIndexOfMemberUid) && _cursor.isNull(_cursorIndexOfFirstName) && _cursor.isNull(_cursorIndexOfLastName) && _cursor.isNull(_cursorIndexOfMemberLastModified))) {
              final long _tmpMemberUid;
              _tmpMemberUid = _cursor.getLong(_cursorIndexOfMemberUid);
              final String _tmpFirstName;
              if (_cursor.isNull(_cursorIndexOfFirstName)) {
                _tmpFirstName = null;
              } else {
                _tmpFirstName = _cursor.getString(_cursorIndexOfFirstName);
              }
              final String _tmpLastName;
              if (_cursor.isNull(_cursorIndexOfLastName)) {
                _tmpLastName = null;
              } else {
                _tmpLastName = _cursor.getString(_cursorIndexOfLastName);
              }
              final long _tmpMemberLastModified;
              _tmpMemberLastModified = _cursor.getLong(_cursorIndexOfMemberLastModified);
              _tmpPosterMember = new Member(_tmpMemberUid,_tmpFirstName,_tmpLastName,_tmpMemberLastModified);
            } else {
              _tmpPosterMember = null;
            }
            _item_1 = new DiscussionPostAndPosterMember();
            _item_1.setDiscussionPost(_tmpDiscussionPost);
            _item_1.setPosterMember(_tmpPosterMember);
            _result.add(_item_1);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object getNumPostsSinceTime(final long since,
      final Continuation<? super Integer> $completion) {
    final String _sql = "\n"
            + "        SELECT COUNT(*) \n"
            + "          FROM DiscussionPost\n"
            + "         WHERE DiscussionPost.postLastModified >= ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, since);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<Integer>() {
      @Override
      @NonNull
      public Integer call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final Integer _result;
          if (_cursor.moveToFirst()) {
            final int _tmp;
            _tmp = _cursor.getInt(0);
            _result = _tmp;
          } else {
            _result = 0;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object getNumPostsSinceTimeHttpOnly(final long since,
      final Continuation<? super Integer> $completion) {
    final String _sql = "\n"
            + "        SELECT COUNT(*) \n"
            + "          FROM DiscussionPost\n"
            + "         WHERE DiscussionPost.postLastModified >= ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, since);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<Integer>() {
      @Override
      @NonNull
      public Integer call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final Integer _result;
          if (_cursor.moveToFirst()) {
            final int _tmp;
            _tmp = _cursor.getInt(0);
            _result = _tmp;
          } else {
            _result = 0;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public PagingSource<Integer, DiscussionPost> findAllPostAsPagingSource(final long since) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost \n"
            + "         WHERE DiscussionPost.postLastModified >= ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, since);
    return new LimitOffsetPagingSource<DiscussionPost>(_statement, __db, "DiscussionPost") {
      @Override
      @NonNull
      protected List<DiscussionPost> convertRows(@NonNull final Cursor cursor) {
        final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postUid");
        final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postReplyToPostUid");
        final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(cursor, "postTitle");
        final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(cursor, "postText");
        final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(cursor, "postLastModified");
        final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(cursor, "posterMemberUid");
        final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(cursor, "isBanned");
        final List<DiscussionPost> _result = new ArrayList<DiscussionPost>(cursor.getCount());
        while (cursor.moveToNext()) {
          final DiscussionPost _item;
          final long _tmpPostUid;
          _tmpPostUid = cursor.getLong(_cursorIndexOfPostUid);
          final long _tmpPostReplyToPostUid;
          _tmpPostReplyToPostUid = cursor.getLong(_cursorIndexOfPostReplyToPostUid);
          final String _tmpPostTitle;
          if (cursor.isNull(_cursorIndexOfPostTitle)) {
            _tmpPostTitle = null;
          } else {
            _tmpPostTitle = cursor.getString(_cursorIndexOfPostTitle);
          }
          final String _tmpPostText;
          if (cursor.isNull(_cursorIndexOfPostText)) {
            _tmpPostText = null;
          } else {
            _tmpPostText = cursor.getString(_cursorIndexOfPostText);
          }
          final long _tmpPostLastModified;
          _tmpPostLastModified = cursor.getLong(_cursorIndexOfPostLastModified);
          final long _tmpPosterMemberUid;
          _tmpPosterMemberUid = cursor.getLong(_cursorIndexOfPosterMemberUid);
          final Boolean _tmpIsBanned;
          final Integer _tmp;
          if (cursor.isNull(_cursorIndexOfIsBanned)) {
            _tmp = null;
          } else {
            _tmp = cursor.getInt(_cursorIndexOfIsBanned);
          }
          _tmpIsBanned = _tmp == null ? null : _tmp != 0;
          _item = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
          _result.add(_item);
        }
        return _result;
      }
    };
  }

  @Override
  public PagingSource<Integer, DiscussionPost> findAllPostAsNetworkOnlyPagingSource(
      final long since) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost \n"
            + "         WHERE DiscussionPost.postLastModified >= ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, since);
    return new LimitOffsetPagingSource<DiscussionPost>(_statement, __db, "DiscussionPost") {
      @Override
      @NonNull
      protected List<DiscussionPost> convertRows(@NonNull final Cursor cursor) {
        final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postUid");
        final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postReplyToPostUid");
        final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(cursor, "postTitle");
        final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(cursor, "postText");
        final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(cursor, "postLastModified");
        final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(cursor, "posterMemberUid");
        final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(cursor, "isBanned");
        final List<DiscussionPost> _result = new ArrayList<DiscussionPost>(cursor.getCount());
        while (cursor.moveToNext()) {
          final DiscussionPost _item;
          final long _tmpPostUid;
          _tmpPostUid = cursor.getLong(_cursorIndexOfPostUid);
          final long _tmpPostReplyToPostUid;
          _tmpPostReplyToPostUid = cursor.getLong(_cursorIndexOfPostReplyToPostUid);
          final String _tmpPostTitle;
          if (cursor.isNull(_cursorIndexOfPostTitle)) {
            _tmpPostTitle = null;
          } else {
            _tmpPostTitle = cursor.getString(_cursorIndexOfPostTitle);
          }
          final String _tmpPostText;
          if (cursor.isNull(_cursorIndexOfPostText)) {
            _tmpPostText = null;
          } else {
            _tmpPostText = cursor.getString(_cursorIndexOfPostText);
          }
          final long _tmpPostLastModified;
          _tmpPostLastModified = cursor.getLong(_cursorIndexOfPostLastModified);
          final long _tmpPosterMemberUid;
          _tmpPosterMemberUid = cursor.getLong(_cursorIndexOfPosterMemberUid);
          final Boolean _tmpIsBanned;
          final Integer _tmp;
          if (cursor.isNull(_cursorIndexOfIsBanned)) {
            _tmp = null;
          } else {
            _tmp = cursor.getInt(_cursorIndexOfIsBanned);
          }
          _tmpIsBanned = _tmp == null ? null : _tmp != 0;
          _item = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
          _result.add(_item);
        }
        return _result;
      }
    };
  }

  @Override
  public PagingSource<Integer, DiscussionPost> findAllPostAsNetworkWithFallbackPagingSource(
      final long since) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost \n"
            + "         WHERE DiscussionPost.postLastModified >= ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, since);
    return new LimitOffsetPagingSource<DiscussionPost>(_statement, __db, "DiscussionPost") {
      @Override
      @NonNull
      protected List<DiscussionPost> convertRows(@NonNull final Cursor cursor) {
        final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postUid");
        final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postReplyToPostUid");
        final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(cursor, "postTitle");
        final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(cursor, "postText");
        final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(cursor, "postLastModified");
        final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(cursor, "posterMemberUid");
        final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(cursor, "isBanned");
        final List<DiscussionPost> _result = new ArrayList<DiscussionPost>(cursor.getCount());
        while (cursor.moveToNext()) {
          final DiscussionPost _item;
          final long _tmpPostUid;
          _tmpPostUid = cursor.getLong(_cursorIndexOfPostUid);
          final long _tmpPostReplyToPostUid;
          _tmpPostReplyToPostUid = cursor.getLong(_cursorIndexOfPostReplyToPostUid);
          final String _tmpPostTitle;
          if (cursor.isNull(_cursorIndexOfPostTitle)) {
            _tmpPostTitle = null;
          } else {
            _tmpPostTitle = cursor.getString(_cursorIndexOfPostTitle);
          }
          final String _tmpPostText;
          if (cursor.isNull(_cursorIndexOfPostText)) {
            _tmpPostText = null;
          } else {
            _tmpPostText = cursor.getString(_cursorIndexOfPostText);
          }
          final long _tmpPostLastModified;
          _tmpPostLastModified = cursor.getLong(_cursorIndexOfPostLastModified);
          final long _tmpPosterMemberUid;
          _tmpPosterMemberUid = cursor.getLong(_cursorIndexOfPosterMemberUid);
          final Boolean _tmpIsBanned;
          final Integer _tmp;
          if (cursor.isNull(_cursorIndexOfIsBanned)) {
            _tmp = null;
          } else {
            _tmp = cursor.getInt(_cursorIndexOfIsBanned);
          }
          _tmpIsBanned = _tmp == null ? null : _tmp != 0;
          _item = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
          _result.add(_item);
        }
        return _result;
      }
    };
  }

  @Override
  public Object findAllRepliesForPost(final long postUid, final long nodeId,
      final Continuation<? super List<DiscussionPost>> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost\n"
            + "         WHERE DiscussionPost.postReplyToPostUid = ? \n"
            + "           AND ? != 0\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 2);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    _argIndex = 2;
    _statement.bindLong(_argIndex, nodeId);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<DiscussionPost>>() {
      @Override
      @NonNull
      public List<DiscussionPost> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final List<DiscussionPost> _result = new ArrayList<DiscussionPost>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final DiscussionPost _item;
            final long _tmpPostUid;
            _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
            final long _tmpPostReplyToPostUid;
            _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
            final String _tmpPostTitle;
            if (_cursor.isNull(_cursorIndexOfPostTitle)) {
              _tmpPostTitle = null;
            } else {
              _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
            }
            final String _tmpPostText;
            if (_cursor.isNull(_cursorIndexOfPostText)) {
              _tmpPostText = null;
            } else {
              _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
            }
            final long _tmpPostLastModified;
            _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
            final long _tmpPosterMemberUid;
            _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
            final Boolean _tmpIsBanned;
            final Integer _tmp;
            if (_cursor.isNull(_cursorIndexOfIsBanned)) {
              _tmp = null;
            } else {
              _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
            }
            _tmpIsBanned = _tmp == null ? null : _tmp != 0;
            _item = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object findPostAndNumReplies(final long postUid, final long sinceTime,
      final Continuation<? super DiscussionPostAndNumReplies> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*,\n"
            + "               (SELECT COUNT(*) \n"
            + "                  FROM DiscussionPost DiscussionPostInternal\n"
            + "                 WHERE DiscussionPostInternal.postReplyToPostUid = ?) AS numReplies\n"
            + "         FROM DiscussionPost\n"
            + "        WHERE DiscussionPost.postUid = ?\n"
            + "          AND DiscussionPost.postLastModified >= ?\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 3);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    _argIndex = 2;
    _statement.bindLong(_argIndex, postUid);
    _argIndex = 3;
    _statement.bindLong(_argIndex, sinceTime);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<DiscussionPostAndNumReplies>() {
      @Override
      @Nullable
      public DiscussionPostAndNumReplies call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfNumReplies = CursorUtil.getColumnIndexOrThrow(_cursor, "numReplies");
          final DiscussionPostAndNumReplies _result;
          if (_cursor.moveToFirst()) {
            final int _tmpNumReplies;
            _tmpNumReplies = _cursor.getInt(_cursorIndexOfNumReplies);
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            _result = new DiscussionPostAndNumReplies(_tmpDiscussionPost,_tmpNumReplies);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public PagingSource<Integer, DiscussionPost> findRootRepliesAsPagingSource() {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost\n"
            + "         WHERE DiscussionPost.postReplyToPostUid != 0 \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return new LimitOffsetPagingSource<DiscussionPost>(_statement, __db, "DiscussionPost") {
      @Override
      @NonNull
      protected List<DiscussionPost> convertRows(@NonNull final Cursor cursor) {
        final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postUid");
        final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postReplyToPostUid");
        final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(cursor, "postTitle");
        final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(cursor, "postText");
        final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(cursor, "postLastModified");
        final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(cursor, "posterMemberUid");
        final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(cursor, "isBanned");
        final List<DiscussionPost> _result = new ArrayList<DiscussionPost>(cursor.getCount());
        while (cursor.moveToNext()) {
          final DiscussionPost _item;
          final long _tmpPostUid;
          _tmpPostUid = cursor.getLong(_cursorIndexOfPostUid);
          final long _tmpPostReplyToPostUid;
          _tmpPostReplyToPostUid = cursor.getLong(_cursorIndexOfPostReplyToPostUid);
          final String _tmpPostTitle;
          if (cursor.isNull(_cursorIndexOfPostTitle)) {
            _tmpPostTitle = null;
          } else {
            _tmpPostTitle = cursor.getString(_cursorIndexOfPostTitle);
          }
          final String _tmpPostText;
          if (cursor.isNull(_cursorIndexOfPostText)) {
            _tmpPostText = null;
          } else {
            _tmpPostText = cursor.getString(_cursorIndexOfPostText);
          }
          final long _tmpPostLastModified;
          _tmpPostLastModified = cursor.getLong(_cursorIndexOfPostLastModified);
          final long _tmpPosterMemberUid;
          _tmpPosterMemberUid = cursor.getLong(_cursorIndexOfPosterMemberUid);
          final Boolean _tmpIsBanned;
          final Integer _tmp;
          if (cursor.isNull(_cursorIndexOfIsBanned)) {
            _tmp = null;
          } else {
            _tmp = cursor.getInt(_cursorIndexOfIsBanned);
          }
          _tmpIsBanned = _tmp == null ? null : _tmp != 0;
          _item = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
          _result.add(_item);
        }
        return _result;
      }
    };
  }

  @Override
  public PagingSource<Integer, DiscussionPostAndNumReplies> findRootPostsAndNumRepliesAsPagingSource(
      ) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*,\n"
            + "               (SELECT COUNT(*) \n"
            + "                  FROM DiscussionPost DiscussionPostInternal\n"
            + "                 WHERE DiscussionPostInternal.postReplyToPostUid = DiscussionPost.postUid) AS numReplies\n"
            + "         FROM DiscussionPost\n"
            + "        WHERE DiscussionPost.postReplyToPostUid = 0\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return new LimitOffsetPagingSource<DiscussionPostAndNumReplies>(_statement, __db, "DiscussionPost") {
      @Override
      @NonNull
      protected List<DiscussionPostAndNumReplies> convertRows(@NonNull final Cursor cursor) {
        final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postUid");
        final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postReplyToPostUid");
        final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(cursor, "postTitle");
        final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(cursor, "postText");
        final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(cursor, "postLastModified");
        final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(cursor, "posterMemberUid");
        final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(cursor, "isBanned");
        final int _cursorIndexOfNumReplies = CursorUtil.getColumnIndexOrThrow(cursor, "numReplies");
        final List<DiscussionPostAndNumReplies> _result = new ArrayList<DiscussionPostAndNumReplies>(cursor.getCount());
        while (cursor.moveToNext()) {
          final DiscussionPostAndNumReplies _item;
          final int _tmpNumReplies;
          _tmpNumReplies = cursor.getInt(_cursorIndexOfNumReplies);
          final DiscussionPost _tmpDiscussionPost;
          if (!(cursor.isNull(_cursorIndexOfPostUid) && cursor.isNull(_cursorIndexOfPostReplyToPostUid) && cursor.isNull(_cursorIndexOfPostTitle) && cursor.isNull(_cursorIndexOfPostText) && cursor.isNull(_cursorIndexOfPostLastModified) && cursor.isNull(_cursorIndexOfPosterMemberUid) && cursor.isNull(_cursorIndexOfIsBanned))) {
            final long _tmpPostUid;
            _tmpPostUid = cursor.getLong(_cursorIndexOfPostUid);
            final long _tmpPostReplyToPostUid;
            _tmpPostReplyToPostUid = cursor.getLong(_cursorIndexOfPostReplyToPostUid);
            final String _tmpPostTitle;
            if (cursor.isNull(_cursorIndexOfPostTitle)) {
              _tmpPostTitle = null;
            } else {
              _tmpPostTitle = cursor.getString(_cursorIndexOfPostTitle);
            }
            final String _tmpPostText;
            if (cursor.isNull(_cursorIndexOfPostText)) {
              _tmpPostText = null;
            } else {
              _tmpPostText = cursor.getString(_cursorIndexOfPostText);
            }
            final long _tmpPostLastModified;
            _tmpPostLastModified = cursor.getLong(_cursorIndexOfPostLastModified);
            final long _tmpPosterMemberUid;
            _tmpPosterMemberUid = cursor.getLong(_cursorIndexOfPosterMemberUid);
            final Boolean _tmpIsBanned;
            final Integer _tmp;
            if (cursor.isNull(_cursorIndexOfIsBanned)) {
              _tmp = null;
            } else {
              _tmp = cursor.getInt(_cursorIndexOfIsBanned);
            }
            _tmpIsBanned = _tmp == null ? null : _tmp != 0;
            _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
          } else {
            _tmpDiscussionPost = null;
          }
          _item = new DiscussionPostAndNumReplies(_tmpDiscussionPost,_tmpNumReplies);
          _result.add(_item);
        }
        return _result;
      }
    };
  }

  @Override
  public Object findReplyPostsWithOffsetAndLimit(final int offset, final int limit,
      final Continuation<? super List<DiscussionPost>> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost\n"
            + "         WHERE DiscussionPost.postReplyToPostUid != 0 \n"
            + "         LIMIT ?\n"
            + "        OFFSET ?   \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 2);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, limit);
    _argIndex = 2;
    _statement.bindLong(_argIndex, offset);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<DiscussionPost>>() {
      @Override
      @NonNull
      public List<DiscussionPost> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final List<DiscussionPost> _result = new ArrayList<DiscussionPost>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final DiscussionPost _item;
            final long _tmpPostUid;
            _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
            final long _tmpPostReplyToPostUid;
            _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
            final String _tmpPostTitle;
            if (_cursor.isNull(_cursorIndexOfPostTitle)) {
              _tmpPostTitle = null;
            } else {
              _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
            }
            final String _tmpPostText;
            if (_cursor.isNull(_cursorIndexOfPostText)) {
              _tmpPostText = null;
            } else {
              _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
            }
            final long _tmpPostLastModified;
            _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
            final long _tmpPosterMemberUid;
            _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
            final Boolean _tmpIsBanned;
            final Integer _tmp;
            if (_cursor.isNull(_cursorIndexOfIsBanned)) {
              _tmp = null;
            } else {
              _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
            }
            _tmpIsBanned = _tmp == null ? null : _tmp != 0;
            _item = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public PagingSource<Integer, DiscussionPostAndNumReplies> findRootPostAndNumRepliesAsPagingSourceWithPagedParams(
      ) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*,\n"
            + "               (SELECT COUNT(*) \n"
            + "                  FROM DiscussionPost DiscussionPostInternal\n"
            + "                 WHERE DiscussionPostInternal.postReplyToPostUid = DiscussionPost.postUid) AS numReplies\n"
            + "         FROM DiscussionPost\n"
            + "        WHERE DiscussionPost.postReplyToPostUid = 0\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return new LimitOffsetPagingSource<DiscussionPostAndNumReplies>(_statement, __db, "DiscussionPost") {
      @Override
      @NonNull
      protected List<DiscussionPostAndNumReplies> convertRows(@NonNull final Cursor cursor) {
        final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postUid");
        final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(cursor, "postReplyToPostUid");
        final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(cursor, "postTitle");
        final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(cursor, "postText");
        final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(cursor, "postLastModified");
        final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(cursor, "posterMemberUid");
        final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(cursor, "isBanned");
        final int _cursorIndexOfNumReplies = CursorUtil.getColumnIndexOrThrow(cursor, "numReplies");
        final List<DiscussionPostAndNumReplies> _result = new ArrayList<DiscussionPostAndNumReplies>(cursor.getCount());
        while (cursor.moveToNext()) {
          final DiscussionPostAndNumReplies _item;
          final int _tmpNumReplies;
          _tmpNumReplies = cursor.getInt(_cursorIndexOfNumReplies);
          final DiscussionPost _tmpDiscussionPost;
          if (!(cursor.isNull(_cursorIndexOfPostUid) && cursor.isNull(_cursorIndexOfPostReplyToPostUid) && cursor.isNull(_cursorIndexOfPostTitle) && cursor.isNull(_cursorIndexOfPostText) && cursor.isNull(_cursorIndexOfPostLastModified) && cursor.isNull(_cursorIndexOfPosterMemberUid) && cursor.isNull(_cursorIndexOfIsBanned))) {
            final long _tmpPostUid;
            _tmpPostUid = cursor.getLong(_cursorIndexOfPostUid);
            final long _tmpPostReplyToPostUid;
            _tmpPostReplyToPostUid = cursor.getLong(_cursorIndexOfPostReplyToPostUid);
            final String _tmpPostTitle;
            if (cursor.isNull(_cursorIndexOfPostTitle)) {
              _tmpPostTitle = null;
            } else {
              _tmpPostTitle = cursor.getString(_cursorIndexOfPostTitle);
            }
            final String _tmpPostText;
            if (cursor.isNull(_cursorIndexOfPostText)) {
              _tmpPostText = null;
            } else {
              _tmpPostText = cursor.getString(_cursorIndexOfPostText);
            }
            final long _tmpPostLastModified;
            _tmpPostLastModified = cursor.getLong(_cursorIndexOfPostLastModified);
            final long _tmpPosterMemberUid;
            _tmpPosterMemberUid = cursor.getLong(_cursorIndexOfPosterMemberUid);
            final Boolean _tmpIsBanned;
            final Integer _tmp;
            if (cursor.isNull(_cursorIndexOfIsBanned)) {
              _tmp = null;
            } else {
              _tmp = cursor.getInt(_cursorIndexOfIsBanned);
            }
            _tmpIsBanned = _tmp == null ? null : _tmp != 0;
            _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
          } else {
            _tmpDiscussionPost = null;
          }
          _item = new DiscussionPostAndNumReplies(_tmpDiscussionPost,_tmpNumReplies);
          _result.add(_item);
        }
        return _result;
      }
    };
  }

  @Override
  public Flow<List<DiscussionPostAndNumReplies>> findRootPostAndNumRepliesAsPagingSourceWithAsFlow(
      ) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*,\n"
            + "               (SELECT COUNT(*) \n"
            + "                  FROM DiscussionPost DiscussionPostInternal\n"
            + "                 WHERE DiscussionPostInternal.postReplyToPostUid = DiscussionPost.postUid) AS numReplies\n"
            + "         FROM DiscussionPost\n"
            + "        WHERE DiscussionPost.postReplyToPostUid = 0\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[] {"DiscussionPost"}, new Callable<List<DiscussionPostAndNumReplies>>() {
      @Override
      @NonNull
      public List<DiscussionPostAndNumReplies> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfNumReplies = CursorUtil.getColumnIndexOrThrow(_cursor, "numReplies");
          final List<DiscussionPostAndNumReplies> _result = new ArrayList<DiscussionPostAndNumReplies>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final DiscussionPostAndNumReplies _item;
            final int _tmpNumReplies;
            _tmpNumReplies = _cursor.getInt(_cursorIndexOfNumReplies);
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            _item = new DiscussionPostAndNumReplies(_tmpDiscussionPost,_tmpNumReplies);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Object checkNodeHasPermission(final long postUid, final long nodeId,
      final Continuation<? super Boolean> $completion) {
    final String _sql = "\n"
            + "        SELECT EXISTS(\n"
            + "               SELECT Member.memberUid\n"
            + "                 FROM Member\n"
            + "                WHERE ? != 0\n"
            + "                  AND Member.memberUid = ?\n"
            + "                  AND ? != 0\n"
            + "        )\n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 3);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    _argIndex = 2;
    _statement.bindLong(_argIndex, postUid);
    _argIndex = 3;
    _statement.bindLong(_argIndex, nodeId);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<Boolean>() {
      @Override
      @NonNull
      public Boolean call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final Boolean _result;
          if (_cursor.moveToFirst()) {
            final int _tmp;
            _tmp = _cursor.getInt(0);
            _result = _tmp != 0;
          } else {
            _result = false;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object findRepliesWithAuthCheck(final long postUid,
      final Continuation<? super List<DiscussionPost>> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*\n"
            + "          FROM DiscussionPost\n"
            + "         WHERE DiscussionPost.postReplyToPostUid = ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<DiscussionPost>>() {
      @Override
      @NonNull
      public List<DiscussionPost> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final List<DiscussionPost> _result = new ArrayList<DiscussionPost>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final DiscussionPost _item;
            final long _tmpPostUid;
            _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
            final long _tmpPostReplyToPostUid;
            _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
            final String _tmpPostTitle;
            if (_cursor.isNull(_cursorIndexOfPostTitle)) {
              _tmpPostTitle = null;
            } else {
              _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
            }
            final String _tmpPostText;
            if (_cursor.isNull(_cursorIndexOfPostText)) {
              _tmpPostText = null;
            } else {
              _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
            }
            final long _tmpPostLastModified;
            _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
            final long _tmpPosterMemberUid;
            _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
            final Boolean _tmpIsBanned;
            final Integer _tmp;
            if (_cursor.isNull(_cursorIndexOfIsBanned)) {
              _tmp = null;
            } else {
              _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
            }
            _tmpIsBanned = _tmp == null ? null : _tmp != 0;
            _item = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object getDiscussionPostAndAuthorName(final long postUid,
      final Continuation<? super DiscussionPostAndAuthorName> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*,\n"
            + "               Member.firstName AS firstName,\n"
            + "               Member.lastName AS lastName\n"
            + "          FROM DiscussionPost\n"
            + "               LEFT JOIN Member\n"
            + "                         ON Member.memberUid = DiscussionPost.posterMemberUid \n"
            + "         WHERE DiscussionPost.postUid = ?       \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postUid);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<DiscussionPostAndAuthorName>() {
      @Override
      @Nullable
      public DiscussionPostAndAuthorName call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
          final int _cursorIndexOfLastName = CursorUtil.getColumnIndexOrThrow(_cursor, "lastName");
          final DiscussionPostAndAuthorName _result;
          if (_cursor.moveToFirst()) {
            final String _tmpFirstName;
            if (_cursor.isNull(_cursorIndexOfFirstName)) {
              _tmpFirstName = null;
            } else {
              _tmpFirstName = _cursor.getString(_cursorIndexOfFirstName);
            }
            final String _tmpLastName;
            if (_cursor.isNull(_cursorIndexOfLastName)) {
              _tmpLastName = null;
            } else {
              _tmpLastName = _cursor.getString(_cursorIndexOfLastName);
            }
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            _result = new DiscussionPostAndAuthorName(_tmpDiscussionPost,_tmpFirstName,_tmpLastName);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object getDiscussionPostAndAuthorNameById(final long postId,
      final Continuation<? super DiscussionPostAndAuthorName> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*,\n"
            + "               Member.firstName AS firstName,\n"
            + "               Member.lastName AS lastName\n"
            + "          FROM DiscussionPost\n"
            + "               LEFT JOIN Member\n"
            + "                         ON Member.memberUid = DiscussionPost.posterMemberUid \n"
            + "         WHERE DiscussionPost.postUid = ?       \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, postId);
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<DiscussionPostAndAuthorName>() {
      @Override
      @Nullable
      public DiscussionPostAndAuthorName call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
          final int _cursorIndexOfLastName = CursorUtil.getColumnIndexOrThrow(_cursor, "lastName");
          final DiscussionPostAndAuthorName _result;
          if (_cursor.moveToFirst()) {
            final String _tmpFirstName;
            if (_cursor.isNull(_cursorIndexOfFirstName)) {
              _tmpFirstName = null;
            } else {
              _tmpFirstName = _cursor.getString(_cursorIndexOfFirstName);
            }
            final String _tmpLastName;
            if (_cursor.isNull(_cursorIndexOfLastName)) {
              _tmpLastName = null;
            } else {
              _tmpLastName = _cursor.getString(_cursorIndexOfLastName);
            }
            final DiscussionPost _tmpDiscussionPost;
            if (!(_cursor.isNull(_cursorIndexOfPostUid) && _cursor.isNull(_cursorIndexOfPostReplyToPostUid) && _cursor.isNull(_cursorIndexOfPostTitle) && _cursor.isNull(_cursorIndexOfPostText) && _cursor.isNull(_cursorIndexOfPostLastModified) && _cursor.isNull(_cursorIndexOfPosterMemberUid) && _cursor.isNull(_cursorIndexOfIsBanned))) {
              final long _tmpPostUid;
              _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
              final long _tmpPostReplyToPostUid;
              _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
              final String _tmpPostTitle;
              if (_cursor.isNull(_cursorIndexOfPostTitle)) {
                _tmpPostTitle = null;
              } else {
                _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
              }
              final String _tmpPostText;
              if (_cursor.isNull(_cursorIndexOfPostText)) {
                _tmpPostText = null;
              } else {
                _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
              }
              final long _tmpPostLastModified;
              _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
              final long _tmpPosterMemberUid;
              _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
              final Boolean _tmpIsBanned;
              final Integer _tmp;
              if (_cursor.isNull(_cursorIndexOfIsBanned)) {
                _tmp = null;
              } else {
                _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
              }
              _tmpIsBanned = _tmp == null ? null : _tmp != 0;
              _tmpDiscussionPost = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            } else {
              _tmpDiscussionPost = null;
            }
            _result = new DiscussionPostAndAuthorName(_tmpDiscussionPost,_tmpFirstName,_tmpLastName);
          } else {
            _result = null;
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @Override
  public Object findByName(final String firstName,
      final Continuation<? super List<DiscussionPost>> $completion) {
    final String _sql = "\n"
            + "        SELECT DiscussionPost.*,\n"
            + "               Member.firstName AS firstName,\n"
            + "               Member.lastName AS lastName\n"
            + "          FROM DiscussionPost\n"
            + "               LEFT JOIN Member\n"
            + "                         ON Member.memberUid = DiscussionPost.posterMemberUid \n"
            + "         WHERE Member.firstName = ?       \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    if (firstName == null) {
      _statement.bindNull(_argIndex);
    } else {
      _statement.bindString(_argIndex, firstName);
    }
    final CancellationSignal _cancellationSignal = DBUtil.createCancellationSignal();
    return CoroutinesRoom.execute(__db, false, _cancellationSignal, new Callable<List<DiscussionPost>>() {
      @Override
      @NonNull
      public List<DiscussionPost> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postUid");
          final int _cursorIndexOfPostReplyToPostUid = CursorUtil.getColumnIndexOrThrow(_cursor, "postReplyToPostUid");
          final int _cursorIndexOfPostTitle = CursorUtil.getColumnIndexOrThrow(_cursor, "postTitle");
          final int _cursorIndexOfPostText = CursorUtil.getColumnIndexOrThrow(_cursor, "postText");
          final int _cursorIndexOfPostLastModified = CursorUtil.getColumnIndexOrThrow(_cursor, "postLastModified");
          final int _cursorIndexOfPosterMemberUid = CursorUtil.getColumnIndexOrThrow(_cursor, "posterMemberUid");
          final int _cursorIndexOfIsBanned = CursorUtil.getColumnIndexOrThrow(_cursor, "isBanned");
          final List<DiscussionPost> _result = new ArrayList<DiscussionPost>(_cursor.getCount());
          while (_cursor.moveToNext()) {
            final DiscussionPost _item;
            final long _tmpPostUid;
            _tmpPostUid = _cursor.getLong(_cursorIndexOfPostUid);
            final long _tmpPostReplyToPostUid;
            _tmpPostReplyToPostUid = _cursor.getLong(_cursorIndexOfPostReplyToPostUid);
            final String _tmpPostTitle;
            if (_cursor.isNull(_cursorIndexOfPostTitle)) {
              _tmpPostTitle = null;
            } else {
              _tmpPostTitle = _cursor.getString(_cursorIndexOfPostTitle);
            }
            final String _tmpPostText;
            if (_cursor.isNull(_cursorIndexOfPostText)) {
              _tmpPostText = null;
            } else {
              _tmpPostText = _cursor.getString(_cursorIndexOfPostText);
            }
            final long _tmpPostLastModified;
            _tmpPostLastModified = _cursor.getLong(_cursorIndexOfPostLastModified);
            final long _tmpPosterMemberUid;
            _tmpPosterMemberUid = _cursor.getLong(_cursorIndexOfPosterMemberUid);
            final Boolean _tmpIsBanned;
            final Integer _tmp;
            if (_cursor.isNull(_cursorIndexOfIsBanned)) {
              _tmp = null;
            } else {
              _tmp = _cursor.getInt(_cursorIndexOfIsBanned);
            }
            _tmpIsBanned = _tmp == null ? null : _tmp != 0;
            _item = new DiscussionPost(_tmpPostUid,_tmpPostReplyToPostUid,_tmpPostTitle,_tmpPostText,_tmpPostLastModified,_tmpPosterMemberUid,_tmpIsBanned);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
          _statement.release();
        }
      }
    }, $completion);
  }

  @NonNull
  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
