package db3;

import androidx.annotation.NonNull;
import androidx.room.DatabaseConfiguration;
import androidx.room.InvalidationTracker;
import androidx.room.RoomDatabase;
import androidx.room.RoomOpenHelper;
import androidx.room.migration.AutoMigrationSpec;
import androidx.room.migration.Migration;
import androidx.room.util.DBUtil;
import androidx.room.util.TableInfo;
import androidx.sqlite.db.SupportSQLiteDatabase;
import androidx.sqlite.db.SupportSQLiteOpenHelper;
import java.lang.Class;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.annotation.processing.Generated;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class ExampleDb3_Impl extends ExampleDb3 {
  private volatile ExampleEntity3Dao _exampleEntity3Dao;

  private volatile DiscussionPostDao _discussionPostDao;

  private volatile MemberDao _memberDao;

  private volatile BadgeDao _badgeDao;

  private volatile StatementEntityDao _statementEntityDao;

  @Override
  @NonNull
  protected SupportSQLiteOpenHelper createOpenHelper(@NonNull final DatabaseConfiguration config) {
    final SupportSQLiteOpenHelper.Callback _openCallback = new RoomOpenHelper(config, new RoomOpenHelper.Delegate(1) {
      @Override
      public void createAllTables(@NonNull final SupportSQLiteDatabase db) {
        db.execSQL("CREATE TABLE IF NOT EXISTS `ExampleEntity3` (`eeUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `cardNumber` INTEGER NOT NULL, `name` TEXT, `lastUpdatedTime` INTEGER NOT NULL, `nullableNumber` INTEGER)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `DiscussionPost` (`postUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `postReplyToPostUid` INTEGER NOT NULL, `postTitle` TEXT, `postText` TEXT, `postLastModified` INTEGER NOT NULL, `posterMemberUid` INTEGER NOT NULL, `isBanned` INTEGER)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `Member` (`memberUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `firstName` TEXT, `lastName` TEXT, `memberLastModified` INTEGER NOT NULL)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `OutgoingReplication` (`orUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `destNodeId` INTEGER NOT NULL, `orTableId` INTEGER NOT NULL, `orPk1` INTEGER NOT NULL, `orPk2` INTEGER NOT NULL DEFAULT 0, `orPk3` INTEGER NOT NULL DEFAULT 0, `orPk4` INTEGER NOT NULL DEFAULT 0)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `ReplicationOperation` (`repOpRemoteNodeId` INTEGER NOT NULL, `repOpTableId` INTEGER NOT NULL, `repOpStatus` INTEGER NOT NULL, PRIMARY KEY(`repOpRemoteNodeId`, `repOpTableId`))");
        db.execSQL("CREATE TABLE IF NOT EXISTS `PendingRepositorySession` (`rsUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `remoteNodeId` INTEGER NOT NULL, `endpointUrl` TEXT)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `Badge` (`badgeUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `badgeName` TEXT, `badgePoints` INTEGER NOT NULL, `badgeLastChangeTime` INTEGER NOT NULL)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `StatementEntity` (`uidHi` INTEGER NOT NULL, `uidLo` INTEGER NOT NULL, `lct` INTEGER NOT NULL, `name` TEXT, PRIMARY KEY(`uidHi`, `uidLo`))");
        db.execSQL("CREATE TABLE IF NOT EXISTS room_master_table (id INTEGER PRIMARY KEY,identity_hash TEXT)");
        db.execSQL("INSERT OR REPLACE INTO room_master_table (id,identity_hash) VALUES(42, '60283eccd3d8be41e3a4be00144a12b7')");
      }

      @Override
      public void dropAllTables(@NonNull final SupportSQLiteDatabase db) {
        db.execSQL("DROP TABLE IF EXISTS `ExampleEntity3`");
        db.execSQL("DROP TABLE IF EXISTS `DiscussionPost`");
        db.execSQL("DROP TABLE IF EXISTS `Member`");
        db.execSQL("DROP TABLE IF EXISTS `OutgoingReplication`");
        db.execSQL("DROP TABLE IF EXISTS `ReplicationOperation`");
        db.execSQL("DROP TABLE IF EXISTS `PendingRepositorySession`");
        db.execSQL("DROP TABLE IF EXISTS `Badge`");
        db.execSQL("DROP TABLE IF EXISTS `StatementEntity`");
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onDestructiveMigration(db);
          }
        }
      }

      @Override
      public void onCreate(@NonNull final SupportSQLiteDatabase db) {
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onCreate(db);
          }
        }
      }

      @Override
      public void onOpen(@NonNull final SupportSQLiteDatabase db) {
        mDatabase = db;
        internalInitInvalidationTracker(db);
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onOpen(db);
          }
        }
      }

      @Override
      public void onPreMigrate(@NonNull final SupportSQLiteDatabase db) {
        DBUtil.dropFtsSyncTriggers(db);
      }

      @Override
      public void onPostMigrate(@NonNull final SupportSQLiteDatabase db) {
      }

      @Override
      @NonNull
      public RoomOpenHelper.ValidationResult onValidateSchema(
          @NonNull final SupportSQLiteDatabase db) {
        final HashMap<String, TableInfo.Column> _columnsExampleEntity3 = new HashMap<String, TableInfo.Column>(5);
        _columnsExampleEntity3.put("eeUid", new TableInfo.Column("eeUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntity3.put("cardNumber", new TableInfo.Column("cardNumber", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntity3.put("name", new TableInfo.Column("name", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntity3.put("lastUpdatedTime", new TableInfo.Column("lastUpdatedTime", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsExampleEntity3.put("nullableNumber", new TableInfo.Column("nullableNumber", "INTEGER", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysExampleEntity3 = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesExampleEntity3 = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoExampleEntity3 = new TableInfo("ExampleEntity3", _columnsExampleEntity3, _foreignKeysExampleEntity3, _indicesExampleEntity3);
        final TableInfo _existingExampleEntity3 = TableInfo.read(db, "ExampleEntity3");
        if (!_infoExampleEntity3.equals(_existingExampleEntity3)) {
          return new RoomOpenHelper.ValidationResult(false, "ExampleEntity3(db3.ExampleEntity3).\n"
                  + " Expected:\n" + _infoExampleEntity3 + "\n"
                  + " Found:\n" + _existingExampleEntity3);
        }
        final HashMap<String, TableInfo.Column> _columnsDiscussionPost = new HashMap<String, TableInfo.Column>(7);
        _columnsDiscussionPost.put("postUid", new TableInfo.Column("postUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDiscussionPost.put("postReplyToPostUid", new TableInfo.Column("postReplyToPostUid", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDiscussionPost.put("postTitle", new TableInfo.Column("postTitle", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDiscussionPost.put("postText", new TableInfo.Column("postText", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDiscussionPost.put("postLastModified", new TableInfo.Column("postLastModified", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDiscussionPost.put("posterMemberUid", new TableInfo.Column("posterMemberUid", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDiscussionPost.put("isBanned", new TableInfo.Column("isBanned", "INTEGER", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysDiscussionPost = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesDiscussionPost = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoDiscussionPost = new TableInfo("DiscussionPost", _columnsDiscussionPost, _foreignKeysDiscussionPost, _indicesDiscussionPost);
        final TableInfo _existingDiscussionPost = TableInfo.read(db, "DiscussionPost");
        if (!_infoDiscussionPost.equals(_existingDiscussionPost)) {
          return new RoomOpenHelper.ValidationResult(false, "DiscussionPost(db3.DiscussionPost).\n"
                  + " Expected:\n" + _infoDiscussionPost + "\n"
                  + " Found:\n" + _existingDiscussionPost);
        }
        final HashMap<String, TableInfo.Column> _columnsMember = new HashMap<String, TableInfo.Column>(4);
        _columnsMember.put("memberUid", new TableInfo.Column("memberUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsMember.put("firstName", new TableInfo.Column("firstName", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsMember.put("lastName", new TableInfo.Column("lastName", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsMember.put("memberLastModified", new TableInfo.Column("memberLastModified", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysMember = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesMember = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoMember = new TableInfo("Member", _columnsMember, _foreignKeysMember, _indicesMember);
        final TableInfo _existingMember = TableInfo.read(db, "Member");
        if (!_infoMember.equals(_existingMember)) {
          return new RoomOpenHelper.ValidationResult(false, "Member(db3.Member).\n"
                  + " Expected:\n" + _infoMember + "\n"
                  + " Found:\n" + _existingMember);
        }
        final HashMap<String, TableInfo.Column> _columnsOutgoingReplication = new HashMap<String, TableInfo.Column>(7);
        _columnsOutgoingReplication.put("orUid", new TableInfo.Column("orUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("destNodeId", new TableInfo.Column("destNodeId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orTableId", new TableInfo.Column("orTableId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orPk1", new TableInfo.Column("orPk1", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orPk2", new TableInfo.Column("orPk2", "INTEGER", true, 0, "0", TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orPk3", new TableInfo.Column("orPk3", "INTEGER", true, 0, "0", TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orPk4", new TableInfo.Column("orPk4", "INTEGER", true, 0, "0", TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysOutgoingReplication = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesOutgoingReplication = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoOutgoingReplication = new TableInfo("OutgoingReplication", _columnsOutgoingReplication, _foreignKeysOutgoingReplication, _indicesOutgoingReplication);
        final TableInfo _existingOutgoingReplication = TableInfo.read(db, "OutgoingReplication");
        if (!_infoOutgoingReplication.equals(_existingOutgoingReplication)) {
          return new RoomOpenHelper.ValidationResult(false, "OutgoingReplication(com.ustadmobile.door.entities.OutgoingReplication).\n"
                  + " Expected:\n" + _infoOutgoingReplication + "\n"
                  + " Found:\n" + _existingOutgoingReplication);
        }
        final HashMap<String, TableInfo.Column> _columnsReplicationOperation = new HashMap<String, TableInfo.Column>(3);
        _columnsReplicationOperation.put("repOpRemoteNodeId", new TableInfo.Column("repOpRemoteNodeId", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsReplicationOperation.put("repOpTableId", new TableInfo.Column("repOpTableId", "INTEGER", true, 2, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsReplicationOperation.put("repOpStatus", new TableInfo.Column("repOpStatus", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysReplicationOperation = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesReplicationOperation = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoReplicationOperation = new TableInfo("ReplicationOperation", _columnsReplicationOperation, _foreignKeysReplicationOperation, _indicesReplicationOperation);
        final TableInfo _existingReplicationOperation = TableInfo.read(db, "ReplicationOperation");
        if (!_infoReplicationOperation.equals(_existingReplicationOperation)) {
          return new RoomOpenHelper.ValidationResult(false, "ReplicationOperation(com.ustadmobile.door.entities.ReplicationOperation).\n"
                  + " Expected:\n" + _infoReplicationOperation + "\n"
                  + " Found:\n" + _existingReplicationOperation);
        }
        final HashMap<String, TableInfo.Column> _columnsPendingRepositorySession = new HashMap<String, TableInfo.Column>(3);
        _columnsPendingRepositorySession.put("rsUid", new TableInfo.Column("rsUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsPendingRepositorySession.put("remoteNodeId", new TableInfo.Column("remoteNodeId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsPendingRepositorySession.put("endpointUrl", new TableInfo.Column("endpointUrl", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysPendingRepositorySession = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesPendingRepositorySession = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoPendingRepositorySession = new TableInfo("PendingRepositorySession", _columnsPendingRepositorySession, _foreignKeysPendingRepositorySession, _indicesPendingRepositorySession);
        final TableInfo _existingPendingRepositorySession = TableInfo.read(db, "PendingRepositorySession");
        if (!_infoPendingRepositorySession.equals(_existingPendingRepositorySession)) {
          return new RoomOpenHelper.ValidationResult(false, "PendingRepositorySession(com.ustadmobile.door.entities.PendingRepositorySession).\n"
                  + " Expected:\n" + _infoPendingRepositorySession + "\n"
                  + " Found:\n" + _existingPendingRepositorySession);
        }
        final HashMap<String, TableInfo.Column> _columnsBadge = new HashMap<String, TableInfo.Column>(4);
        _columnsBadge.put("badgeUid", new TableInfo.Column("badgeUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsBadge.put("badgeName", new TableInfo.Column("badgeName", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsBadge.put("badgePoints", new TableInfo.Column("badgePoints", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsBadge.put("badgeLastChangeTime", new TableInfo.Column("badgeLastChangeTime", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysBadge = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesBadge = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoBadge = new TableInfo("Badge", _columnsBadge, _foreignKeysBadge, _indicesBadge);
        final TableInfo _existingBadge = TableInfo.read(db, "Badge");
        if (!_infoBadge.equals(_existingBadge)) {
          return new RoomOpenHelper.ValidationResult(false, "Badge(db3.Badge).\n"
                  + " Expected:\n" + _infoBadge + "\n"
                  + " Found:\n" + _existingBadge);
        }
        final HashMap<String, TableInfo.Column> _columnsStatementEntity = new HashMap<String, TableInfo.Column>(4);
        _columnsStatementEntity.put("uidHi", new TableInfo.Column("uidHi", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsStatementEntity.put("uidLo", new TableInfo.Column("uidLo", "INTEGER", true, 2, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsStatementEntity.put("lct", new TableInfo.Column("lct", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsStatementEntity.put("name", new TableInfo.Column("name", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysStatementEntity = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesStatementEntity = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoStatementEntity = new TableInfo("StatementEntity", _columnsStatementEntity, _foreignKeysStatementEntity, _indicesStatementEntity);
        final TableInfo _existingStatementEntity = TableInfo.read(db, "StatementEntity");
        if (!_infoStatementEntity.equals(_existingStatementEntity)) {
          return new RoomOpenHelper.ValidationResult(false, "StatementEntity(db3.StatementEntity).\n"
                  + " Expected:\n" + _infoStatementEntity + "\n"
                  + " Found:\n" + _existingStatementEntity);
        }
        return new RoomOpenHelper.ValidationResult(true, null);
      }
    }, "60283eccd3d8be41e3a4be00144a12b7", "c93aebddbd9869e93a7ae578baa7437e");
    final SupportSQLiteOpenHelper.Configuration _sqliteConfig = SupportSQLiteOpenHelper.Configuration.builder(config.context).name(config.name).callback(_openCallback).build();
    final SupportSQLiteOpenHelper _helper = config.sqliteOpenHelperFactory.create(_sqliteConfig);
    return _helper;
  }

  @Override
  @NonNull
  protected InvalidationTracker createInvalidationTracker() {
    final HashMap<String, String> _shadowTablesMap = new HashMap<String, String>(0);
    final HashMap<String, Set<String>> _viewTables = new HashMap<String, Set<String>>(0);
    return new InvalidationTracker(this, _shadowTablesMap, _viewTables, "ExampleEntity3","DiscussionPost","Member","OutgoingReplication","ReplicationOperation","PendingRepositorySession","Badge","StatementEntity");
  }

  @Override
  public void clearAllTables() {
    super.assertNotMainThread();
    final SupportSQLiteDatabase _db = super.getOpenHelper().getWritableDatabase();
    try {
      super.beginTransaction();
      _db.execSQL("DELETE FROM `ExampleEntity3`");
      _db.execSQL("DELETE FROM `DiscussionPost`");
      _db.execSQL("DELETE FROM `Member`");
      _db.execSQL("DELETE FROM `OutgoingReplication`");
      _db.execSQL("DELETE FROM `ReplicationOperation`");
      _db.execSQL("DELETE FROM `PendingRepositorySession`");
      _db.execSQL("DELETE FROM `Badge`");
      _db.execSQL("DELETE FROM `StatementEntity`");
      super.setTransactionSuccessful();
    } finally {
      super.endTransaction();
      _db.query("PRAGMA wal_checkpoint(FULL)").close();
      if (!_db.inTransaction()) {
        _db.execSQL("VACUUM");
      }
    }
  }

  @Override
  @NonNull
  protected Map<Class<?>, List<Class<?>>> getRequiredTypeConverters() {
    final HashMap<Class<?>, List<Class<?>>> _typeConvertersMap = new HashMap<Class<?>, List<Class<?>>>();
    _typeConvertersMap.put(ExampleEntity3Dao.class, ExampleEntity3Dao_Impl.getRequiredConverters());
    _typeConvertersMap.put(DiscussionPostDao.class, DiscussionPostDao_Impl.getRequiredConverters());
    _typeConvertersMap.put(MemberDao.class, MemberDao_Impl.getRequiredConverters());
    _typeConvertersMap.put(BadgeDao.class, BadgeDao_Impl.getRequiredConverters());
    _typeConvertersMap.put(StatementEntityDao.class, StatementEntityDao_Impl.getRequiredConverters());
    return _typeConvertersMap;
  }

  @Override
  @NonNull
  public Set<Class<? extends AutoMigrationSpec>> getRequiredAutoMigrationSpecs() {
    final HashSet<Class<? extends AutoMigrationSpec>> _autoMigrationSpecsSet = new HashSet<Class<? extends AutoMigrationSpec>>();
    return _autoMigrationSpecsSet;
  }

  @Override
  @NonNull
  public List<Migration> getAutoMigrations(
      @NonNull final Map<Class<? extends AutoMigrationSpec>, AutoMigrationSpec> autoMigrationSpecs) {
    final List<Migration> _autoMigrations = new ArrayList<Migration>();
    return _autoMigrations;
  }

  @Override
  public ExampleEntity3Dao getExampleEntity3Dao() {
    if (_exampleEntity3Dao != null) {
      return _exampleEntity3Dao;
    } else {
      synchronized(this) {
        if(_exampleEntity3Dao == null) {
          _exampleEntity3Dao = new ExampleEntity3Dao_Impl(this);
        }
        return _exampleEntity3Dao;
      }
    }
  }

  @Override
  public DiscussionPostDao getDiscussionPostDao() {
    if (_discussionPostDao != null) {
      return _discussionPostDao;
    } else {
      synchronized(this) {
        if(_discussionPostDao == null) {
          _discussionPostDao = new DiscussionPostDao_Impl(this);
        }
        return _discussionPostDao;
      }
    }
  }

  @Override
  public MemberDao getMemberDao() {
    if (_memberDao != null) {
      return _memberDao;
    } else {
      synchronized(this) {
        if(_memberDao == null) {
          _memberDao = new MemberDao_Impl(this);
        }
        return _memberDao;
      }
    }
  }

  @Override
  public BadgeDao getBadgeDao() {
    if (_badgeDao != null) {
      return _badgeDao;
    } else {
      synchronized(this) {
        if(_badgeDao == null) {
          _badgeDao = new BadgeDao_Impl(this);
        }
        return _badgeDao;
      }
    }
  }

  @Override
  public StatementEntityDao getStatementEntityDao() {
    if (_statementEntityDao != null) {
      return _statementEntityDao;
    } else {
      synchronized(this) {
        if(_statementEntityDao == null) {
          _statementEntityDao = new StatementEntityDao_Impl(this);
        }
        return _statementEntityDao;
      }
    }
  }
}
