package repdb;

import android.database.Cursor;
import androidx.annotation.NonNull;
import androidx.room.EntityDeletionOrUpdateAdapter;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import java.lang.Class;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.Collections;
import java.util.List;
import javax.annotation.processing.Generated;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class CompositePkDao_Impl extends CompositePkDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<CompositePkEntity> __insertionAdapterOfCompositePkEntity;

  private final EntityDeletionOrUpdateAdapter<CompositePkEntity> __deletionAdapterOfCompositePkEntity;

  private final EntityDeletionOrUpdateAdapter<CompositePkEntity> __updateAdapterOfCompositePkEntity;

  public CompositePkDao_Impl(@NonNull final RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfCompositePkEntity = new EntityInsertionAdapter<CompositePkEntity>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "INSERT OR ABORT INTO `CompositePkEntity` (`code1`,`code2`,`name`) VALUES (?,?,?)";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final CompositePkEntity entity) {
        statement.bindLong(1, entity.getCode1());
        statement.bindLong(2, entity.getCode2());
        if (entity.getName() == null) {
          statement.bindNull(3);
        } else {
          statement.bindString(3, entity.getName());
        }
      }
    };
    this.__deletionAdapterOfCompositePkEntity = new EntityDeletionOrUpdateAdapter<CompositePkEntity>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "DELETE FROM `CompositePkEntity` WHERE `code1` = ? AND `code2` = ?";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final CompositePkEntity entity) {
        statement.bindLong(1, entity.getCode1());
        statement.bindLong(2, entity.getCode2());
      }
    };
    this.__updateAdapterOfCompositePkEntity = new EntityDeletionOrUpdateAdapter<CompositePkEntity>(__db) {
      @Override
      @NonNull
      protected String createQuery() {
        return "UPDATE OR ABORT `CompositePkEntity` SET `code1` = ?,`code2` = ?,`name` = ? WHERE `code1` = ? AND `code2` = ?";
      }

      @Override
      protected void bind(@NonNull final SupportSQLiteStatement statement,
          @NonNull final CompositePkEntity entity) {
        statement.bindLong(1, entity.getCode1());
        statement.bindLong(2, entity.getCode2());
        if (entity.getName() == null) {
          statement.bindNull(3);
        } else {
          statement.bindString(3, entity.getName());
        }
        statement.bindLong(4, entity.getCode1());
        statement.bindLong(5, entity.getCode2());
      }
    };
  }

  @Override
  public void insert(final CompositePkEntity entity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfCompositePkEntity.insert(entity);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void delete(final CompositePkEntity entity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __deletionAdapterOfCompositePkEntity.handle(entity);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void update(final CompositePkEntity entity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __updateAdapterOfCompositePkEntity.handle(entity);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public CompositePkEntity findByPKs(final long code1, final long code2) {
    final String _sql = "\n"
            + "        SELECT CompositePkEntity.* \n"
            + "          FROM CompositePkEntity\n"
            + "         WHERE CompositePkEntity.code1 = ? AND CompositePkEntity.code2 = ? \n"
            + "    ";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 2);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, code1);
    _argIndex = 2;
    _statement.bindLong(_argIndex, code2);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfCode1 = CursorUtil.getColumnIndexOrThrow(_cursor, "code1");
      final int _cursorIndexOfCode2 = CursorUtil.getColumnIndexOrThrow(_cursor, "code2");
      final int _cursorIndexOfName = CursorUtil.getColumnIndexOrThrow(_cursor, "name");
      final CompositePkEntity _result;
      if (_cursor.moveToFirst()) {
        _result = new CompositePkEntity();
        final long _tmpCode1;
        _tmpCode1 = _cursor.getLong(_cursorIndexOfCode1);
        _result.setCode1(_tmpCode1);
        final long _tmpCode2;
        _tmpCode2 = _cursor.getLong(_cursorIndexOfCode2);
        _result.setCode2(_tmpCode2);
        final String _tmpName;
        if (_cursor.isNull(_cursorIndexOfName)) {
          _tmpName = null;
        } else {
          _tmpName = _cursor.getString(_cursorIndexOfName);
        }
        _result.setName(_tmpName);
      } else {
        _result = null;
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @NonNull
  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
