package repdb;

import androidx.annotation.NonNull;
import androidx.room.DatabaseConfiguration;
import androidx.room.InvalidationTracker;
import androidx.room.RoomDatabase;
import androidx.room.RoomOpenHelper;
import androidx.room.migration.AutoMigrationSpec;
import androidx.room.migration.Migration;
import androidx.room.util.DBUtil;
import androidx.room.util.TableInfo;
import androidx.sqlite.db.SupportSQLiteDatabase;
import androidx.sqlite.db.SupportSQLiteOpenHelper;
import java.lang.Class;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.annotation.processing.Generated;

@Generated("androidx.room.RoomProcessor")
@SuppressWarnings({"unchecked", "deprecation"})
public final class RepDb_Impl extends RepDb {
  private volatile RepDao _repDao;

  private volatile CompositePkDao _compositePkDao;

  private volatile RepWithAttachmentDao _repWithAttachmentDao;

  @Override
  @NonNull
  protected SupportSQLiteOpenHelper createOpenHelper(@NonNull final DatabaseConfiguration config) {
    final SupportSQLiteOpenHelper.Callback _openCallback = new RoomOpenHelper(config, new RoomOpenHelper.Delegate(1) {
      @Override
      public void createAllTables(@NonNull final SupportSQLiteDatabase db) {
        db.execSQL("CREATE TABLE IF NOT EXISTS `RepEntity` (`rePrimaryKey` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `reLastChangedBy` INTEGER NOT NULL, `reLastChangeTime` INTEGER NOT NULL DEFAULT 0, `reNumField` INTEGER NOT NULL, `reString` TEXT, `reBoolean` INTEGER NOT NULL)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `DoorNode` (`nodeId` INTEGER NOT NULL, `auth` TEXT, `rel` INTEGER NOT NULL DEFAULT 2, PRIMARY KEY(`nodeId`))");
        db.execSQL("CREATE TABLE IF NOT EXISTS `RepEntityWithAttachment` (`waUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `waVersionId` INTEGER NOT NULL, `waAttachmentUri` TEXT, `waMd5` TEXT, `waSize` INTEGER NOT NULL)");
        db.execSQL("CREATE INDEX IF NOT EXISTS `index_RepEntityWithAttachment_waMd5` ON `RepEntityWithAttachment` (`waMd5`)");
        db.execSQL("CREATE TABLE IF NOT EXISTS `SyncNode` (`nodeClientId` INTEGER NOT NULL, PRIMARY KEY(`nodeClientId`))");
        db.execSQL("CREATE TABLE IF NOT EXISTS `CompositePkEntity` (`code1` INTEGER NOT NULL, `code2` INTEGER NOT NULL, `name` TEXT, PRIMARY KEY(`code1`, `code2`))");
        db.execSQL("CREATE TABLE IF NOT EXISTS `OutgoingReplication` (`orUid` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `destNodeId` INTEGER NOT NULL, `orTableId` INTEGER NOT NULL, `orPk1` INTEGER NOT NULL, `orPk2` INTEGER NOT NULL DEFAULT 0, `orPk3` INTEGER NOT NULL DEFAULT 0, `orPk4` INTEGER NOT NULL DEFAULT 0)");
        db.execSQL("CREATE TABLE IF NOT EXISTS room_master_table (id INTEGER PRIMARY KEY,identity_hash TEXT)");
        db.execSQL("INSERT OR REPLACE INTO room_master_table (id,identity_hash) VALUES(42, 'e8ceea77cec096a8d66ad71152854288')");
      }

      @Override
      public void dropAllTables(@NonNull final SupportSQLiteDatabase db) {
        db.execSQL("DROP TABLE IF EXISTS `RepEntity`");
        db.execSQL("DROP TABLE IF EXISTS `DoorNode`");
        db.execSQL("DROP TABLE IF EXISTS `RepEntityWithAttachment`");
        db.execSQL("DROP TABLE IF EXISTS `SyncNode`");
        db.execSQL("DROP TABLE IF EXISTS `CompositePkEntity`");
        db.execSQL("DROP TABLE IF EXISTS `OutgoingReplication`");
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onDestructiveMigration(db);
          }
        }
      }

      @Override
      public void onCreate(@NonNull final SupportSQLiteDatabase db) {
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onCreate(db);
          }
        }
      }

      @Override
      public void onOpen(@NonNull final SupportSQLiteDatabase db) {
        mDatabase = db;
        internalInitInvalidationTracker(db);
        final List<? extends RoomDatabase.Callback> _callbacks = mCallbacks;
        if (_callbacks != null) {
          for (RoomDatabase.Callback _callback : _callbacks) {
            _callback.onOpen(db);
          }
        }
      }

      @Override
      public void onPreMigrate(@NonNull final SupportSQLiteDatabase db) {
        DBUtil.dropFtsSyncTriggers(db);
      }

      @Override
      public void onPostMigrate(@NonNull final SupportSQLiteDatabase db) {
      }

      @Override
      @NonNull
      public RoomOpenHelper.ValidationResult onValidateSchema(
          @NonNull final SupportSQLiteDatabase db) {
        final HashMap<String, TableInfo.Column> _columnsRepEntity = new HashMap<String, TableInfo.Column>(6);
        _columnsRepEntity.put("rePrimaryKey", new TableInfo.Column("rePrimaryKey", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntity.put("reLastChangedBy", new TableInfo.Column("reLastChangedBy", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntity.put("reLastChangeTime", new TableInfo.Column("reLastChangeTime", "INTEGER", true, 0, "0", TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntity.put("reNumField", new TableInfo.Column("reNumField", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntity.put("reString", new TableInfo.Column("reString", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntity.put("reBoolean", new TableInfo.Column("reBoolean", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysRepEntity = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesRepEntity = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoRepEntity = new TableInfo("RepEntity", _columnsRepEntity, _foreignKeysRepEntity, _indicesRepEntity);
        final TableInfo _existingRepEntity = TableInfo.read(db, "RepEntity");
        if (!_infoRepEntity.equals(_existingRepEntity)) {
          return new RoomOpenHelper.ValidationResult(false, "RepEntity(repdb.RepEntity).\n"
                  + " Expected:\n" + _infoRepEntity + "\n"
                  + " Found:\n" + _existingRepEntity);
        }
        final HashMap<String, TableInfo.Column> _columnsDoorNode = new HashMap<String, TableInfo.Column>(3);
        _columnsDoorNode.put("nodeId", new TableInfo.Column("nodeId", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDoorNode.put("auth", new TableInfo.Column("auth", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsDoorNode.put("rel", new TableInfo.Column("rel", "INTEGER", true, 0, "2", TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysDoorNode = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesDoorNode = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoDoorNode = new TableInfo("DoorNode", _columnsDoorNode, _foreignKeysDoorNode, _indicesDoorNode);
        final TableInfo _existingDoorNode = TableInfo.read(db, "DoorNode");
        if (!_infoDoorNode.equals(_existingDoorNode)) {
          return new RoomOpenHelper.ValidationResult(false, "DoorNode(com.ustadmobile.door.entities.DoorNode).\n"
                  + " Expected:\n" + _infoDoorNode + "\n"
                  + " Found:\n" + _existingDoorNode);
        }
        final HashMap<String, TableInfo.Column> _columnsRepEntityWithAttachment = new HashMap<String, TableInfo.Column>(5);
        _columnsRepEntityWithAttachment.put("waUid", new TableInfo.Column("waUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntityWithAttachment.put("waVersionId", new TableInfo.Column("waVersionId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntityWithAttachment.put("waAttachmentUri", new TableInfo.Column("waAttachmentUri", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntityWithAttachment.put("waMd5", new TableInfo.Column("waMd5", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsRepEntityWithAttachment.put("waSize", new TableInfo.Column("waSize", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysRepEntityWithAttachment = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesRepEntityWithAttachment = new HashSet<TableInfo.Index>(1);
        _indicesRepEntityWithAttachment.add(new TableInfo.Index("index_RepEntityWithAttachment_waMd5", false, Arrays.asList("waMd5"), Arrays.asList("ASC")));
        final TableInfo _infoRepEntityWithAttachment = new TableInfo("RepEntityWithAttachment", _columnsRepEntityWithAttachment, _foreignKeysRepEntityWithAttachment, _indicesRepEntityWithAttachment);
        final TableInfo _existingRepEntityWithAttachment = TableInfo.read(db, "RepEntityWithAttachment");
        if (!_infoRepEntityWithAttachment.equals(_existingRepEntityWithAttachment)) {
          return new RoomOpenHelper.ValidationResult(false, "RepEntityWithAttachment(repdb.RepEntityWithAttachment).\n"
                  + " Expected:\n" + _infoRepEntityWithAttachment + "\n"
                  + " Found:\n" + _existingRepEntityWithAttachment);
        }
        final HashMap<String, TableInfo.Column> _columnsSyncNode = new HashMap<String, TableInfo.Column>(1);
        _columnsSyncNode.put("nodeClientId", new TableInfo.Column("nodeClientId", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysSyncNode = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesSyncNode = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoSyncNode = new TableInfo("SyncNode", _columnsSyncNode, _foreignKeysSyncNode, _indicesSyncNode);
        final TableInfo _existingSyncNode = TableInfo.read(db, "SyncNode");
        if (!_infoSyncNode.equals(_existingSyncNode)) {
          return new RoomOpenHelper.ValidationResult(false, "SyncNode(com.ustadmobile.door.SyncNode).\n"
                  + " Expected:\n" + _infoSyncNode + "\n"
                  + " Found:\n" + _existingSyncNode);
        }
        final HashMap<String, TableInfo.Column> _columnsCompositePkEntity = new HashMap<String, TableInfo.Column>(3);
        _columnsCompositePkEntity.put("code1", new TableInfo.Column("code1", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCompositePkEntity.put("code2", new TableInfo.Column("code2", "INTEGER", true, 2, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCompositePkEntity.put("name", new TableInfo.Column("name", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysCompositePkEntity = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesCompositePkEntity = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoCompositePkEntity = new TableInfo("CompositePkEntity", _columnsCompositePkEntity, _foreignKeysCompositePkEntity, _indicesCompositePkEntity);
        final TableInfo _existingCompositePkEntity = TableInfo.read(db, "CompositePkEntity");
        if (!_infoCompositePkEntity.equals(_existingCompositePkEntity)) {
          return new RoomOpenHelper.ValidationResult(false, "CompositePkEntity(repdb.CompositePkEntity).\n"
                  + " Expected:\n" + _infoCompositePkEntity + "\n"
                  + " Found:\n" + _existingCompositePkEntity);
        }
        final HashMap<String, TableInfo.Column> _columnsOutgoingReplication = new HashMap<String, TableInfo.Column>(7);
        _columnsOutgoingReplication.put("orUid", new TableInfo.Column("orUid", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("destNodeId", new TableInfo.Column("destNodeId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orTableId", new TableInfo.Column("orTableId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orPk1", new TableInfo.Column("orPk1", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orPk2", new TableInfo.Column("orPk2", "INTEGER", true, 0, "0", TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orPk3", new TableInfo.Column("orPk3", "INTEGER", true, 0, "0", TableInfo.CREATED_FROM_ENTITY));
        _columnsOutgoingReplication.put("orPk4", new TableInfo.Column("orPk4", "INTEGER", true, 0, "0", TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysOutgoingReplication = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesOutgoingReplication = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoOutgoingReplication = new TableInfo("OutgoingReplication", _columnsOutgoingReplication, _foreignKeysOutgoingReplication, _indicesOutgoingReplication);
        final TableInfo _existingOutgoingReplication = TableInfo.read(db, "OutgoingReplication");
        if (!_infoOutgoingReplication.equals(_existingOutgoingReplication)) {
          return new RoomOpenHelper.ValidationResult(false, "OutgoingReplication(com.ustadmobile.door.entities.OutgoingReplication).\n"
                  + " Expected:\n" + _infoOutgoingReplication + "\n"
                  + " Found:\n" + _existingOutgoingReplication);
        }
        return new RoomOpenHelper.ValidationResult(true, null);
      }
    }, "e8ceea77cec096a8d66ad71152854288", "1bf20ac92354c8d19db986eabae2ec64");
    final SupportSQLiteOpenHelper.Configuration _sqliteConfig = SupportSQLiteOpenHelper.Configuration.builder(config.context).name(config.name).callback(_openCallback).build();
    final SupportSQLiteOpenHelper _helper = config.sqliteOpenHelperFactory.create(_sqliteConfig);
    return _helper;
  }

  @Override
  @NonNull
  protected InvalidationTracker createInvalidationTracker() {
    final HashMap<String, String> _shadowTablesMap = new HashMap<String, String>(0);
    final HashMap<String, Set<String>> _viewTables = new HashMap<String, Set<String>>(0);
    return new InvalidationTracker(this, _shadowTablesMap, _viewTables, "RepEntity","DoorNode","RepEntityWithAttachment","SyncNode","CompositePkEntity","OutgoingReplication");
  }

  @Override
  public void clearAllTables() {
    super.assertNotMainThread();
    final SupportSQLiteDatabase _db = super.getOpenHelper().getWritableDatabase();
    try {
      super.beginTransaction();
      _db.execSQL("DELETE FROM `RepEntity`");
      _db.execSQL("DELETE FROM `DoorNode`");
      _db.execSQL("DELETE FROM `RepEntityWithAttachment`");
      _db.execSQL("DELETE FROM `SyncNode`");
      _db.execSQL("DELETE FROM `CompositePkEntity`");
      _db.execSQL("DELETE FROM `OutgoingReplication`");
      super.setTransactionSuccessful();
    } finally {
      super.endTransaction();
      _db.query("PRAGMA wal_checkpoint(FULL)").close();
      if (!_db.inTransaction()) {
        _db.execSQL("VACUUM");
      }
    }
  }

  @Override
  @NonNull
  protected Map<Class<?>, List<Class<?>>> getRequiredTypeConverters() {
    final HashMap<Class<?>, List<Class<?>>> _typeConvertersMap = new HashMap<Class<?>, List<Class<?>>>();
    _typeConvertersMap.put(RepDao.class, RepDao_Impl.getRequiredConverters());
    _typeConvertersMap.put(CompositePkDao.class, CompositePkDao_Impl.getRequiredConverters());
    _typeConvertersMap.put(RepWithAttachmentDao.class, RepWithAttachmentDao_Impl.getRequiredConverters());
    return _typeConvertersMap;
  }

  @Override
  @NonNull
  public Set<Class<? extends AutoMigrationSpec>> getRequiredAutoMigrationSpecs() {
    final HashSet<Class<? extends AutoMigrationSpec>> _autoMigrationSpecsSet = new HashSet<Class<? extends AutoMigrationSpec>>();
    return _autoMigrationSpecsSet;
  }

  @Override
  @NonNull
  public List<Migration> getAutoMigrations(
      @NonNull final Map<Class<? extends AutoMigrationSpec>, AutoMigrationSpec> autoMigrationSpecs) {
    final List<Migration> _autoMigrations = new ArrayList<Migration>();
    return _autoMigrations;
  }

  @Override
  public RepDao getRepDao() {
    if (_repDao != null) {
      return _repDao;
    } else {
      synchronized(this) {
        if(_repDao == null) {
          _repDao = new RepDao_Impl(this);
        }
        return _repDao;
      }
    }
  }

  @Override
  public CompositePkDao getCompositePkDao() {
    if (_compositePkDao != null) {
      return _compositePkDao;
    } else {
      synchronized(this) {
        if(_compositePkDao == null) {
          _compositePkDao = new CompositePkDao_Impl(this);
        }
        return _compositePkDao;
      }
    }
  }

  @Override
  public RepWithAttachmentDao getRepWithAttachmentDao() {
    if (_repWithAttachmentDao != null) {
      return _repWithAttachmentDao;
    } else {
      synchronized(this) {
        if(_repWithAttachmentDao == null) {
          _repWithAttachmentDao = new RepWithAttachmentDao_Impl(this);
        }
        return _repWithAttachmentDao;
      }
    }
  }
}
