package dbonly

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import androidx.room.Update
import kotlin.Any
import kotlin.Long
import kotlin.collections.List

@Dao
public actual abstract class VanillaDao {
  @Query(`value` = "SELECT * FROM VanillaEntity WHERE vanillaUid = :pk")
  public actual abstract fun findEntityByPk(pk: Long): VanillaEntity?

  @Insert(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract fun insert(entity: VanillaEntity)

  @Update(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract suspend fun updateListAsync(list: List<VanillaEntity>)
}
