package repdb

import androidx.room.Dao
import androidx.room.Delete
import androidx.room.Insert
import androidx.room.Query
import androidx.room.Update
import kotlin.Any
import kotlin.Long

@Dao
public actual abstract class CompositePkDao {
  @Insert(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract fun insert(entity: CompositePkEntity)

  @Update(
    entity = Any::class,
    onConflict = 3,
  )
  public actual abstract fun update(entity: CompositePkEntity)

  @Delete(entity = Any::class)
  public actual abstract fun delete(entity: CompositePkEntity)

  @Query(`value` =
      "\n        SELECT CompositePkEntity.* \n          FROM CompositePkEntity\n         WHERE CompositePkEntity.code1 = :code1 AND CompositePkEntity.code2 = :code2 \n    ")
  public actual abstract fun findByPKs(code1: Long, code2: Long): CompositePkEntity?
}
