package repdb

import androidx.room.Database
import com.ustadmobile.door.SyncNode
import com.ustadmobile.door.entities.DoorNode
import com.ustadmobile.door.entities.OutgoingReplication
import com.ustadmobile.door.room.RoomDatabase

@Database(
  version = 1,
  entities = arrayOf(RepEntity::class, DoorNode::class, RepEntityWithAttachment::class,
          SyncNode::class, CompositePkEntity::class, OutgoingReplication::class),
  views = arrayOf(),
  exportSchema = true,
)
public actual abstract class RepDb : RoomDatabase() {
  public actual abstract val repDao: RepDao

  public actual abstract val compositePkDao: CompositePkDao

  public actual abstract val repWithAttachmentDao: RepWithAttachmentDao
}
