package db2

import androidx.paging.PagingSource
import com.ustadmobile.door.DoorQuery
import kotlin.Array
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow

public actual abstract class ExampleDao2 {
  public actual abstract fun insertAndReturnId(entity: ExampleEntity2): Long

  public actual abstract suspend fun insertAsync(entity: ExampleEntity2)

  public actual abstract suspend fun insertAsyncAndGiveId(entity: ExampleEntity2): Long

  public actual abstract suspend fun insertOrIgnore(entity: ExampleEntity2)

  public actual abstract fun insertList(entityList: List<ExampleEntity2>)

  public actual abstract suspend fun insertListAsync(entityList: List<ExampleEntity2>)

  public actual abstract fun insertOtherList(entityList: List<ExampleEntity2>)

  public actual abstract fun insertAndReturnList(entityList: List<ExampleEntity2>): List<Long>

  public actual abstract fun insertListAndReturnIdsArray(entityList: List<ExampleEntity2>):
      Array<Long>

  public actual abstract fun replace(entityList: List<ExampleEntity2>)

  public actual abstract fun findByUid(uid: Long): ExampleEntity2?

  public actual abstract suspend fun findByUidAsync(uid: Long): ExampleEntity2?

  public actual abstract suspend fun findLarge(uid: Long, min: Long): ExampleEntity2?

  public actual abstract suspend fun findLargeAsync(uid: Long, min: Long): List<ExampleEntity2>

  public actual abstract fun findWithNullableParam(name: String?): List<ExampleEntity2>

  public actual abstract fun findNameByUid(uid: Long): String?

  public actual abstract suspend fun findNameByUidAsync(uid: Long): String?

  public actual abstract suspend fun findByUidWithLinkEntityAsync(uid: Long):
      ExampleEntity2WithExampleLinkEntity?

  public actual abstract fun findAll(): List<ExampleEntity2>

  public actual abstract suspend fun findAllAsync(): List<ExampleEntity2>

  public actual abstract suspend fun findAllStrings(): List<String?>

  public actual abstract fun findAllStringsSync(): List<String?>

  public actual abstract suspend fun updateSingleItemAsync(entity: ExampleEntity2)

  public actual abstract suspend fun updateSingleItemAndReturnCountAsync(entity: ExampleEntity2):
      Int

  public actual abstract suspend fun updateListAsync(updateEntityList: List<ExampleEntity2>)

  public actual abstract fun updateByParam(newName: String, num: Long): Int

  public actual abstract suspend fun updateByParamAsync(newName: String, num: Long): Int

  public actual abstract fun updateByParamNoReturn(newName: String, number: Long)

  public actual abstract fun deleteSingle(entity: ExampleEntity2)

  public actual abstract fun deleteList(deleteList: List<ExampleEntity2>)

  public actual abstract suspend fun deleteListAsync(deleteList: List<ExampleEntity2>): Int

  public actual abstract fun countNumEntities(): Int

  public actual abstract suspend fun countNumEntitiesAsync(): Int

  public actual abstract fun queryUsingArray(uidList: List<Long>): List<ExampleEntity2>

  public actual abstract fun rawQueryForList(query: DoorQuery): List<ExampleEntity2>

  public actual abstract suspend fun rawQueryForListAsyc(query: DoorQuery): List<ExampleEntity2>

  public actual abstract fun rawQueryForListWithEmbeddedVals(query: DoorQuery):
      List<ExampleEntity2WithExampleLinkEntity>

  public actual abstract fun rawQueryForSingleValue(query: DoorQuery): ExampleEntity2?

  public actual abstract fun rawQueryWithArrParam(query: DoorQuery): List<ExampleEntity2>

  public actual abstract fun insertFromSelectQuery(uid: Int)

  public actual abstract fun queryAllAsFlow(): Flow<List<ExampleEntity2>>

  public actual abstract fun findSingleNotNullableEntity(greaterThan: Int): ExampleEntity2

  public actual abstract suspend fun findSingleNotNullableEntityAsync(greaterThan: Int):
      ExampleEntity2

  public actual abstract fun findSingleNotNullablePrimitive(greaterThan: Int): Int

  public actual abstract suspend fun findSingleNotNullablePrimitiveAsync(greaterThan: Int): Int

  public actual abstract fun findSingleNullablePrimitive(greaterThan: Int): Int?

  public actual abstract suspend fun findSingleNullablePrimitiveAsync(greaterThan: Long): Long?

  public actual abstract suspend fun findWithNullableIntAsync(rewardsNum: Int?): ExampleEntity2?

  public actual abstract fun findAllWithRewardNumberAsPagingSource(minNumber: Int):
      PagingSource<Int, ExampleEntity2>

  public actual abstract suspend fun findAllWithRewardNumberAsListAsync(minNumber: Int):
      List<ExampleEntity2>

  public actual abstract suspend fun findByMinSomeNumber(minNumber: Long): List<ExampleEntity2>
}
