package db2

import com.ustadmobile.door.DoorDatabaseRepository
import com.ustadmobile.door.SyncNode
import com.ustadmobile.door.replication.withRepoChangeMonitor
import com.ustadmobile.door.replication.withRepoChangeMonitorAsync
import com.ustadmobile.door.room.RoomDatabase
import io.ktor.client.HttpClient
import kotlin.Boolean
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.Suppress
import kotlin.collections.List

@Suppress("REDUNDANT_PROJECTION", "LocalVariableName", "ClassName")
public class ExampleSyncableDao_Repo(
  public val _db: RoomDatabase,
  public val _repo: DoorDatabaseRepository,
  public val _dao: ExampleSyncableDao,
  public val _httpClient: HttpClient,
  public val _clientId: Long,
  public val _endpoint: String,
) : ExampleSyncableDao() {
  override fun insert(syncableEntity: ExampleSyncableEntity): Long {
    val _result = _repo.withRepoChangeMonitor("ExampleSyncableEntity") {
      _dao.insert(syncableEntity)
    }
    return _result
  }

  override fun insertList(syncableEntityLIst: List<ExampleSyncableEntity>) {
    _repo.withRepoChangeMonitor("ExampleSyncableEntity") {
      _dao.insertList(syncableEntityLIst)
    }
  }

  override suspend fun insertAndReturnList(entities: List<ExampleSyncableEntity>): List<Long> {
    val _result = _repo.withRepoChangeMonitorAsync("ExampleSyncableEntity") {
      _dao.insertAndReturnList(entities)
    }
    return _result
  }

  override suspend fun insertAsync(syncableEntity: ExampleSyncableEntity): Long {
    val _result = _repo.withRepoChangeMonitorAsync("ExampleSyncableEntity") {
      _dao.insertAsync(syncableEntity)
    }
    return _result
  }

  override fun findAll(): List<ExampleSyncableEntity> {
    val _result = _dao.findAll()
    return _result
  }

  override suspend fun findByListParam(numberList: List<Long>): List<ExampleSyncableEntity> {
    val _result = _dao.findByListParam(numberList)
    return _result
  }

  override fun findByUid(uid: Long): ExampleSyncableEntity? {
    val _result = _dao.findByUid(uid)
    return _result
  }

  override fun findByName(name: String?): ExampleSyncableEntity? {
    val _result = _dao.findByName(name)
    return _result
  }

  override fun findAllWithOtherByUid(): List<ExampleSyncableEntityWithOtherSyncableEntity> {
    val _result = _dao.findAllWithOtherByUid()
    return _result
  }

  override fun updateNumberByUid(uid: Long, newNumber: Long) {
    _repo.withRepoChangeMonitor("ExampleSyncableEntity") {
      _dao.updateNumberByUid(uid, newNumber)
    }
  }

  override suspend fun updateAsync(exampleSyncableEntity: ExampleSyncableEntity) {
    _repo.withRepoChangeMonitorAsync("ExampleSyncableEntity") {
      _dao.updateAsync(exampleSyncableEntity)
    }
  }

  override suspend fun findOneFromWeb(): ExampleSyncableEntity? {
    val _result = _dao.findOneFromWeb()
    return _result
  }

  override suspend fun findOneValue(): Int {
    val _result = _dao.findOneValue()
    return _result
  }

  override fun getSyncNode(): SyncNode? {
    val _result = _dao.getSyncNode()
    return _result
  }

  override fun insertFromSelectQuery(name: String?, publik: Boolean) {
    _repo.withRepoChangeMonitor("ExampleSyncableEntity") {
      _dao.insertFromSelectQuery(name, publik)
    }
  }
}
