package repdb

import androidx.paging.PagingSource
import com.ustadmobile.door.entities.DoorNode
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.collections.List
import kotlinx.coroutines.flow.Flow

public actual interface RepDao : RepDaoInterface<RepEntity> {
  public actual suspend fun insertDoorNodeAsync(node: DoorNode)

  public actual fun insertDoorNode(node: DoorNode)

  public actual suspend fun insertAsync(repEntity: RepEntity): Long

  public actual fun insert(repEntity: RepEntity): Long

  public actual fun insertList(repEntityList: List<RepEntity>)

  public actual fun update(repEntity: RepEntity)

  public actual suspend fun updateAsync(repEntity: RepEntity)

  public actual fun countEntities(): Int

  public actual fun findByUid(uid: Long): RepEntity?

  public actual suspend fun findByUidAsync(uid: Long): RepEntity?

  public actual suspend fun findAllAsync(): List<RepEntity>

  public actual suspend fun insertHttp(entity: RepEntity): Long

  public actual suspend fun selectSyncNodeId(): Long

  public actual suspend fun findInStringList(strList: List<String>): List<RepEntity>

  public actual suspend fun sqliteOnlyFun(num1: Int, num2: Int): Long

  public actual fun findAllAsFlow(): Flow<List<RepEntity>>

  public actual fun findAllPaged(): PagingSource<Int, RepEntity>
}
