package repdb

import com.ustadmobile.door.ext.doorPrimaryKeyManager
import com.ustadmobile.door.ext.rootDatabase
import com.ustadmobile.door.room.RoomDatabase
import com.ustadmobile.door.util.systemTimeInMillis
import kotlin.IllegalStateException
import kotlin.Long
import kotlin.Unit

public class RepWithAttachmentDao_DoorWrapper(
  private val _db: RoomDatabase,
  private val _dao: RepWithAttachmentDao,
) : RepWithAttachmentDao() {
  override fun insert(entityWithAttachment: RepEntityWithAttachment): Long = throw
      IllegalStateException("insert: synchronous db access is NOT possible on Javascript!")

  override suspend fun insertAsync(entityWithAttachment: RepEntityWithAttachment): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(entityWithAttachment.waUid == 0L) {
      val _newPk = _pkManager.nextIdAsync(50)
      entityWithAttachment.waUid = _newPk
    }
    entityWithAttachment.waVersionId = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insertAsync(entityWithAttachment)
    return entityWithAttachment.waUid
  }

  override fun replace(entityWithAttachment: RepEntityWithAttachment): Unit = throw
      IllegalStateException("replace: synchronous db access is NOT possible on Javascript!")

  override fun findByUid(uid: Long): RepEntityWithAttachment? = throw
      IllegalStateException("findByUid: synchronous db access is NOT possible on Javascript!")

  override fun update(entity: RepEntityWithAttachment): Unit = throw
      IllegalStateException("update: synchronous db access is NOT possible on Javascript!")
}
