package repdb

import com.ustadmobile.door.DoorDbType
import com.ustadmobile.door.EntityInsertionAdapter
import com.ustadmobile.door.PreparedStatementConfig
import com.ustadmobile.door.ext.prepareAndUseStatement
import com.ustadmobile.door.jdbc.PreparedStatement
import com.ustadmobile.door.jdbc.ext.mapNextRow
import com.ustadmobile.door.jdbc.ext.useResults
import com.ustadmobile.door.room.RoomDatabase
import kotlin.Boolean
import kotlin.Long
import kotlin.String

public class RepWithAttachmentDao_JdbcImpl(
  public val _db: RoomDatabase,
) : RepWithAttachmentDao() {
  public val _insertAdapterRepEntityWithAttachment_abort:
      EntityInsertionAdapter<RepEntityWithAttachment> = object :
      EntityInsertionAdapter<RepEntityWithAttachment>(_db) {
    override fun makeSql(returnsId: Boolean): String =
        "INSERT INTO RepEntityWithAttachment (waUid, waVersionId, waAttachmentUri, waMd5, waSize) VALUES(?, ?, ?, ?, ?)"

    override fun bindPreparedStmtToEntity(stmt: PreparedStatement,
        entity: RepEntityWithAttachment) {
      if(entity.waUid == 0L) {
        stmt.setObject(1, null)
      } else {
        stmt.setLong(1, entity.waUid)
      }
      stmt.setLong(2, entity.waVersionId)
      stmt.setString(3, entity.waAttachmentUri)
      stmt.setString(4, entity.waMd5)
      stmt.setInt(5, entity.waSize)
    }
  }

  public val _insertAdapterRepEntityWithAttachment_upsert:
      EntityInsertionAdapter<RepEntityWithAttachment> = object :
      EntityInsertionAdapter<RepEntityWithAttachment>(_db) {
    override fun makeSql(returnsId: Boolean): String =
        "INSERT OR REPLACE INTO RepEntityWithAttachment (waUid, waVersionId, waAttachmentUri, waMd5, waSize) VALUES(?, ?, ?, ?, ?)"

    override fun bindPreparedStmtToEntity(stmt: PreparedStatement,
        entity: RepEntityWithAttachment) {
      if(entity.waUid == 0L) {
        stmt.setObject(1, null)
      } else {
        stmt.setLong(1, entity.waUid)
      }
      stmt.setLong(2, entity.waVersionId)
      stmt.setString(3, entity.waAttachmentUri)
      stmt.setString(4, entity.waMd5)
      stmt.setInt(5, entity.waSize)
    }
  }

  override fun insert(entityWithAttachment: RepEntityWithAttachment): Long {
    val _retVal =
        _insertAdapterRepEntityWithAttachment_abort.insertAndReturnId(entityWithAttachment)
    return _retVal
  }

  override suspend fun insertAsync(entityWithAttachment: RepEntityWithAttachment): Long {
    val _retVal =
        _insertAdapterRepEntityWithAttachment_abort.insertAndReturnIdAsync(entityWithAttachment)
    return _retVal
  }

  override fun replace(entityWithAttachment: RepEntityWithAttachment) {
    _insertAdapterRepEntityWithAttachment_upsert.insert(entityWithAttachment)
  }

  override fun update(entity: RepEntityWithAttachment) {
    val _sql =
        "UPDATE RepEntityWithAttachment SET waVersionId = ?, waAttachmentUri = ?, waMd5 = ?, waSize = ? WHERE waUid = ?"
    _db.prepareAndUseStatement(_sql) {
       _stmt ->
      _stmt.setLong(1, entity.waVersionId)
      _stmt.setString(2, entity.waAttachmentUri)
      _stmt.setString(3, entity.waMd5)
      _stmt.setInt(4, entity.waSize)
      _stmt.setLong(5, entity.waUid)
      _stmt.executeUpdate()
    }
  }

  override fun findByUid(uid: Long): RepEntityWithAttachment? =
      _db.prepareAndUseStatement(PreparedStatementConfig(
    sql = """
    |
    |        SELECT RepEntityWithAttachment.*
    |          FROM RepEntityWithAttachment
    |         WHERE waUid = CAST(? AS BIGINT)
    |    
    """.trimMargin(),
    postgreSql = """
    |
    |        SELECT RepEntityWithAttachment.*
    |          FROM RepEntityWithAttachment
    |         WHERE waUid = ?
    |    
    |""".trimMargin(),
    readOnly = true,)
  ) { _stmt -> 
    _stmt.setLong(1,uid)
    _stmt.executeQuery().useResults{ _result -> 
      _result.mapNextRow(null) {
        val _tmp_waUid = _result.getLong("waUid")
        val _tmp_waVersionId = _result.getLong("waVersionId")
        val _tmp_waAttachmentUri = _result.getString("waAttachmentUri")
        val _tmp_waMd5 = _result.getString("waMd5")
        val _tmp_waSize = _result.getInt("waSize")
        RepEntityWithAttachment().apply {
          this.waUid = _tmp_waUid
          this.waVersionId = _tmp_waVersionId
          this.waAttachmentUri = _tmp_waAttachmentUri
          this.waMd5 = _tmp_waMd5
          this.waSize = _tmp_waSize
        }
      }
    }
  }
}
