package repdb

import com.ustadmobile.door.DoorDatabaseRepository
import com.ustadmobile.door.replication.withRepoChangeMonitor
import com.ustadmobile.door.replication.withRepoChangeMonitorAsync
import com.ustadmobile.door.room.RoomDatabase
import io.ktor.client.HttpClient
import kotlin.Long
import kotlin.String
import kotlin.Suppress

@Suppress("REDUNDANT_PROJECTION", "LocalVariableName", "ClassName")
public class RepWithAttachmentDao_Repo(
  public val _db: RoomDatabase,
  public val _repo: DoorDatabaseRepository,
  public val _dao: RepWithAttachmentDao,
  public val _httpClient: HttpClient,
  public val _clientId: Long,
  public val _endpoint: String,
) : RepWithAttachmentDao() {
  override fun insert(entityWithAttachment: RepEntityWithAttachment): Long {
    val _result = _repo.withRepoChangeMonitor("RepEntityWithAttachment") {
      _dao.insert(entityWithAttachment)
    }
    return _result
  }

  override suspend fun insertAsync(entityWithAttachment: RepEntityWithAttachment): Long {
    val _result = _repo.withRepoChangeMonitorAsync("RepEntityWithAttachment") {
      _dao.insertAsync(entityWithAttachment)
    }
    return _result
  }

  override fun replace(entityWithAttachment: RepEntityWithAttachment) {
    _repo.withRepoChangeMonitor("RepEntityWithAttachment") {
      _dao.replace(entityWithAttachment)
    }
  }

  override fun findByUid(uid: Long): RepEntityWithAttachment? {
    val _result = _dao.findByUid(uid)
    return _result
  }

  override fun update(entity: RepEntityWithAttachment) {
    _repo.withRepoChangeMonitor("RepEntityWithAttachment") {
      _dao.update(entity)
    }
  }
}
