package db2

import com.ustadmobile.door.DoorDbType
import com.ustadmobile.door.EntityInsertionAdapter
import com.ustadmobile.door.jdbc.PreparedStatement
import com.ustadmobile.door.room.RoomDatabase
import kotlin.Boolean
import kotlin.IllegalArgumentException
import kotlin.String

public class AccessGrantDao_JdbcImpl(
  public val _db: RoomDatabase,
) : AccessGrantDao() {
  public val _insertAdapterAccessGrant_abort: EntityInsertionAdapter<AccessGrant> = object :
      EntityInsertionAdapter<AccessGrant>(_db) {
    override fun makeSql(returnsId: Boolean): String = when(dbType) {
      DoorDbType.SQLITE -> {
        "INSERT INTO AccessGrant (accessId, aLcsn, aPcsn, aLcb, deviceId, tableId, entityUid) VALUES(?, ?, ?, ?, ?, ?, ?)"
      }
      DoorDbType.POSTGRES ->  {
        "INSERT INTO AccessGrant (accessId, aLcsn, aPcsn, aLcb, deviceId, tableId, entityUid) VALUES(COALESCE(?,nextval('AccessGrant_accessId_seq')), ?, ?, ?, ?, ?, ?)" + if(returnsId) { " RETURNING accessId" } else "" 
      }
      else -> {
        throw IllegalArgumentException("Unsupported db type")
      }
    }

    override fun bindPreparedStmtToEntity(stmt: PreparedStatement, entity: AccessGrant) {
      if(entity.accessId == 0L) {
        stmt.setObject(1, null)
      } else {
        stmt.setLong(1, entity.accessId)
      }
      stmt.setInt(2, entity.aLcsn)
      stmt.setInt(3, entity.aPcsn)
      stmt.setInt(4, entity.aLcb)
      stmt.setInt(5, entity.deviceId)
      stmt.setInt(6, entity.tableId)
      stmt.setLong(7, entity.entityUid)
    }
  }

  override fun insert(entity: AccessGrant) {
    _insertAdapterAccessGrant_abort.insert(entity)
  }
}
