package db2

import com.ustadmobile.door.DoorDbType
import com.ustadmobile.door.EntityInsertionAdapter
import com.ustadmobile.door.PreparedStatementConfig
import com.ustadmobile.door.ext.prepareAndUseStatement
import com.ustadmobile.door.jdbc.PreparedStatement
import com.ustadmobile.door.jdbc.ext.mapNextRow
import com.ustadmobile.door.jdbc.ext.useResults
import com.ustadmobile.door.room.RoomDatabase
import kotlin.Boolean
import kotlin.IllegalArgumentException
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.collections.List

public class ExampleEntityPkIntDao_JdbcImpl(
  public val _db: RoomDatabase,
) : ExampleEntityPkIntDao() {
  public val _insertAdapterExampleEntityPkInt_abort: EntityInsertionAdapter<ExampleEntityPkInt> =
      object : EntityInsertionAdapter<ExampleEntityPkInt>(_db) {
    override fun makeSql(returnsId: Boolean): String = when(dbType) {
      DoorDbType.SQLITE -> {
        "INSERT INTO ExampleEntityPkInt (pk, str) VALUES(?, ?)"
      }
      DoorDbType.POSTGRES ->  {
        "INSERT INTO ExampleEntityPkInt (pk, str) VALUES(COALESCE(?,nextval('ExampleEntityPkInt_pk_seq')), ?)" + if(returnsId) { " RETURNING pk" } else "" 
      }
      else -> {
        throw IllegalArgumentException("Unsupported db type")
      }
    }

    override fun bindPreparedStmtToEntity(stmt: PreparedStatement, entity: ExampleEntityPkInt) {
      if(entity.pk == 0) {
        stmt.setObject(1, null)
      } else {
        stmt.setInt(1, entity.pk)
      }
      stmt.setString(2, entity.str)
    }
  }

  override fun insertAndReturnId(entity: ExampleEntityPkInt): Long {
    val _retVal = _insertAdapterExampleEntityPkInt_abort.insertAndReturnId(entity)
    return _retVal
  }

  override fun insertListAndReturnIds(entityList: List<ExampleEntityPkInt>): List<Long> {
    val _retVal = _insertAdapterExampleEntityPkInt_abort.insertListAndReturnIds(entityList)
    return _retVal
  }

  override fun findByPk(pk: Int): ExampleEntityPkInt? =
      _db.prepareAndUseStatement(PreparedStatementConfig(
    sql = "SELECT * FROM ExampleEntityPkInt WHERE pk = ?",
    readOnly = true,)
  ) { _stmt -> 
    _stmt.setInt(1,pk)
    _stmt.executeQuery().useResults{ _result -> 
      _result.mapNextRow(null) {
        val _tmp_pk = _result.getInt("pk")
        val _tmp_str = _result.getString("str")
        ExampleEntityPkInt().apply {
          this.pk = _tmp_pk
          this.str = _tmp_str
        }
      }
    }
  }
}
