package db2

import com.ustadmobile.door.DoorDbType
import com.ustadmobile.door.EntityInsertionAdapter
import com.ustadmobile.door.jdbc.PreparedStatement
import com.ustadmobile.door.room.RoomDatabase
import kotlin.Boolean
import kotlin.IllegalArgumentException
import kotlin.String

public class ExampleLinkEntityDao_JdbcImpl(
  public val _db: RoomDatabase,
) : ExampleLinkEntityDao() {
  public val _insertAdapterExampleLinkEntity_abort: EntityInsertionAdapter<ExampleLinkEntity> =
      object : EntityInsertionAdapter<ExampleLinkEntity>(_db) {
    override fun makeSql(returnsId: Boolean): String = when(dbType) {
      DoorDbType.SQLITE -> {
        "INSERT INTO ExampleLinkEntity (eeUid, fkValue) VALUES(?, ?)"
      }
      DoorDbType.POSTGRES ->  {
        "INSERT INTO ExampleLinkEntity (eeUid, fkValue) VALUES(?, ?)" + if(returnsId) { " RETURNING eeUid" } else "" 
      }
      else -> {
        throw IllegalArgumentException("Unsupported db type")
      }
    }

    override fun bindPreparedStmtToEntity(stmt: PreparedStatement, entity: ExampleLinkEntity) {
      stmt.setLong(1, entity.eeUid)
      stmt.setLong(2, entity.fkValue)
    }
  }

  override fun insert(linkEntity: ExampleLinkEntity) {
    _insertAdapterExampleLinkEntity_abort.insert(linkEntity)
  }

  override suspend fun insertAsync(linkEntity: ExampleLinkEntity) {
    _insertAdapterExampleLinkEntity_abort.insertAsync(linkEntity)
  }
}
