package db3

import com.ustadmobile.door.ext.doorPrimaryKeyManager
import com.ustadmobile.door.ext.rootDatabase
import com.ustadmobile.door.room.RoomDatabase
import com.ustadmobile.door.util.systemTimeInMillis
import kotlin.Long

public class BadgeDao_DoorWrapper(
  private val _db: RoomDatabase,
  private val _dao: BadgeDao,
) : BadgeDao() {
  override suspend fun insertAsync(badge: Badge): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(badge.badgeUid == 0L) {
      val _newPk = _pkManager.nextIdAsync(1702)
      badge.badgeUid = _newPk
    }
    badge.badgeLastChangeTime = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insertAsync(badge)
    return badge.badgeUid
  }

  override suspend fun findBadgeByUid(uid: Long): BadgeWithTotal? = _dao.findBadgeByUid(uid)
}
