package dbonly

import com.ustadmobile.door.DoorDbType
import com.ustadmobile.door.EntityInsertionAdapter
import com.ustadmobile.door.PreparedStatementConfig
import com.ustadmobile.door.ext.prepareAndUseStatement
import com.ustadmobile.door.ext.prepareAndUseStatementAsync
import com.ustadmobile.door.jdbc.PreparedStatement
import com.ustadmobile.door.jdbc.ext.executeUpdateAsyncKmp
import com.ustadmobile.door.jdbc.ext.mapNextRow
import com.ustadmobile.door.jdbc.ext.useResults
import com.ustadmobile.door.room.RoomDatabase
import kotlin.Boolean
import kotlin.IllegalArgumentException
import kotlin.Long
import kotlin.String
import kotlin.collections.List

public class VanillaDao_JdbcImpl(
  public val _db: RoomDatabase,
) : VanillaDao() {
  public val _insertAdapterVanillaEntity_abort: EntityInsertionAdapter<VanillaEntity> = object :
      EntityInsertionAdapter<VanillaEntity>(_db) {
    override fun makeSql(returnsId: Boolean): String = when(dbType) {
      DoorDbType.SQLITE -> {
        "INSERT INTO VanillaEntity (vanillaUid, vanillaNum, vanillaStr) VALUES(?, ?, ?)"
      }
      DoorDbType.POSTGRES ->  {
        "INSERT INTO VanillaEntity (vanillaUid, vanillaNum, vanillaStr) VALUES(COALESCE(?,nextval('VanillaEntity_vanillaUid_seq')), ?, ?)" + if(returnsId) { " RETURNING vanillaUid" } else "" 
      }
      else -> {
        throw IllegalArgumentException("Unsupported db type")
      }
    }

    override fun bindPreparedStmtToEntity(stmt: PreparedStatement, entity: VanillaEntity) {
      if(entity.vanillaUid == 0L) {
        stmt.setObject(1, null)
      } else {
        stmt.setLong(1, entity.vanillaUid)
      }
      stmt.setInt(2, entity.vanillaNum)
      stmt.setString(3, entity.vanillaStr)
    }
  }

  override fun insert(entity: VanillaEntity) {
    _insertAdapterVanillaEntity_abort.insert(entity)
  }

  override suspend fun updateListAsync(list: List<VanillaEntity>) {
    val _sql = "UPDATE VanillaEntity SET vanillaNum = ?, vanillaStr = ? WHERE vanillaUid = ?"
    _db.prepareAndUseStatementAsync(_sql) {
       _stmt ->
      _stmt.getConnection().setAutoCommit(false)
      for(_entity in list) {
        _stmt.setInt(1, _entity.vanillaNum)
        _stmt.setString(2, _entity.vanillaStr)
        _stmt.setLong(3, _entity.vanillaUid)
        _stmt.executeUpdateAsyncKmp()
      }
      _stmt.getConnection().commit()
    }
  }

  override fun findEntityByPk(pk: Long): VanillaEntity? =
      _db.prepareAndUseStatement(PreparedStatementConfig(
    sql = "SELECT * FROM VanillaEntity WHERE vanillaUid = ?",
    readOnly = true,)
  ) { _stmt -> 
    _stmt.setLong(1,pk)
    _stmt.executeQuery().useResults{ _result -> 
      _result.mapNextRow(null) {
        val _tmp_vanillaUid = _result.getLong("vanillaUid")
        val _tmp_vanillaNum = _result.getInt("vanillaNum")
        val _tmp_vanillaStr = _result.getString("vanillaStr")
        VanillaEntity().apply {
          this.vanillaUid = _tmp_vanillaUid
          this.vanillaNum = _tmp_vanillaNum
          this.vanillaStr = _tmp_vanillaStr
        }
      }
    }
  }
}
